package com.xxh.cloud.datalabel.config.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

/**
 * <p>
 * 数据标签规则配置表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_data_label_rule_config")
public class DataLabelRuleConfig extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    @ApiModelProperty(value = "分类ID")
    private String categoryId;

    /**
     * 项目编号
     */
    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    /**
     * 版本号
     */
    @ApiModelProperty(value = "版本号")
    private Integer versionNo;

    @ApiModelProperty(value = "疾病")
    private String diseaseIds;


    /**
     * 名称
     */
    @ApiModelProperty(value = "名称")
    private String name;

    /**
     * 分类
     */
    @ApiModelProperty(value = "分类")
    private String type;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 配置
     */
    @ApiModelProperty(value = "配置")
    private String config;

    /**
     * 新增标签列表
     */
    @ApiModelProperty(value = "新增标签列表")
    private String labelIds;

    /**
     * 初始数据时间分类
     */
    @ApiModelProperty(value = "初始数据时间分类")
    private String initDateType;

    /**
     * 初始数据时间值
     */
    @ApiModelProperty(value = "初始数据时间值")
    private Integer initDateValue;

    @ApiModelProperty(value = "初始数据执行状态")
    private String initExeStatus;

    @ApiModelProperty(value = "初始数据执行时间")
    private Date initExeTime;

    @ApiModelProperty(value = "上架时间")
    private Date upTime;

    @ApiModelProperty(value = "实时数据执行时间")
    private Date realRunTime;



    /**
     * 顺序
     */
    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "新增标签有效期")
    private Integer labelValidityNum;

    @ApiModelProperty(value = "执行批次")
    private Integer exeBatch;

    @ApiModelProperty(value = "扩展字段1")
    private String extendOne;

    @ApiModelProperty(value = "扩展字段2")
    private String extendTwo;

    @ApiModelProperty(value = "扩展字段3")
    private String extendThree;


    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


}
