package com.xxh.cloud.datalabel.config.framework.modules.biz.bean.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

@Getter
@Setter
public class DataLabelRuleConfigSaveDTO {



    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;

    @ApiModelProperty(value = "分类ID")
    private String categoryId;

    @ApiModelProperty(value = "版本号")
    private Integer versionNo;


    @ApiModelProperty(value = "名称",required = true)
    private String name;


    @ApiModelProperty(value = "分类")
    private String type;

    @ApiModelProperty(value = "疾病",required = true)
    private List<String> diseaseIds;


    @ApiModelProperty(value = "备注")
    private String remark;



    @ApiModelProperty(value = "新增标签列表",required = true)
    private List<String> labelIds;

    @ApiModelProperty(value = "新增标签有效期",required = true)
    private Integer labelValidityNum;


    @ApiModelProperty(value = "初始数据时间分类",required = true)
    @NotEmpty(message = "初始数据时间分类不能为空")
    private String initDateType;


    @ApiModelProperty(value = "初始数据时间值")
    private Integer initDateValue;


    @ApiModelProperty(value = "顺序")
    private Integer orders;

    @ApiModelProperty(value = "执行批次")
    private Integer exeBatch;

    @ApiModelProperty(value = "扩展字段1")
    private String extendOne;

    @ApiModelProperty(value = "扩展字段2")
    private String extendTwo;

    @ApiModelProperty(value = "扩展字段3")
    private String extendThree;


    @ApiModelProperty(value = "配置")
    private NodeCondition config;

}
