package com.xxh.cloud.datalabel.config.framework.modules.biz.bean.dto;

import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class DataLabelRuleConfigUpdateDTO {


    @ApiModelProperty(value = "id",required = true)
    @NotEmpty(message = "ID不能为空")
    private String id;

    @ApiModelProperty(value = "分类ID")
    private String categoryId;



    @ApiModelProperty(value = "疾病")
    private List<String> diseaseIds;



    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "分类")
    private String type;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "新增标签列表")
    private List<String> labelIds;

    @ApiModelProperty(value = "新增标签有效期")
    private Integer labelValidityNum;


    @ApiModelProperty(value = "初始数据时间分类",required = true)
    @NotEmpty(message = "初始数据时间分类不能为空")
    private String initDateType;


    @ApiModelProperty(value = "初始数据时间值")
    private Integer initDateValue;


    @ApiModelProperty(value = "顺序")
    private Integer orders;

    @ApiModelProperty(value = "执行批次")
    private Integer exeBatch;

    @ApiModelProperty(value = "扩展字段1")
    private String extendOne;

    @ApiModelProperty(value = "扩展字段2")
    private String extendTwo;

    @ApiModelProperty(value = "扩展字段3")
    private String extendThree;


    @ApiModelProperty(value = "配置")
    private NodeCondition config;

}
