package com.xxh.cloud.datalabel.config.framework.modules.biz.bean.vos;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.*;

@Getter
@Setter
public class DataLabelRuleConfigVO {


    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "分类ID")
    private String categoryId;

    @ApiModelProperty(value = "版本号")
    private Integer versionNo;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "分类")
    private String type;


    @ApiModelProperty(value = "状态")
    private String status;


    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "疾病")
    private List<String> diseaseIds;

    @ApiModelProperty(value = "新增标签列表")
    private List<String> labelIds;

    @ApiModelProperty(value = "新增标签有效期")
    private Integer labelValidityNum;

    @ApiModelProperty(value = "初始数据时间分类")
    private String initDateType;


    @ApiModelProperty(value = "初始数据时间值")
    private Integer initDateValue;


    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;

    @ApiModelProperty(value = "上架时间")
    private Date upTime;

    @ApiModelProperty(value = "实时数据执行时间")
    private Date realRunTime;


    @ApiModelProperty(value = "初始数据执行状态")
    private String initExeStatus;

    @ApiModelProperty(value = "初始数据执行时间")
    private Date initExeTime;


    @ApiModelProperty(value = "执行批次")
    private Integer exeBatch;

    @ApiModelProperty(value = "扩展字段1")
    private String extendOne;

    @ApiModelProperty(value = "扩展字段2")
    private String extendTwo;

    @ApiModelProperty(value = "扩展字段3")
    private String extendThree;



    //=====================

    @ApiModelProperty(value = "配置")
    private NodeCondition config;

    @ApiModelProperty("标签列表")
    private List<LabelBO> labelList;

    @ApiModelProperty(value = "疾病")
    private List<Map<String,String>> diseaseList;

    public void addLabel(LabelBO item){
        if(this.labelList==null){
            this.labelList=new ArrayList<>();
        }
        if(item!=null){
            this.labelList.add(item);
        }
    }

    public void addDisease(String id,String name){
        if(this.diseaseList==null){
            this.diseaseList=new ArrayList<>();
        }
        Map<String,String> entity=new HashMap<>();
        entity.put("id",id);
        entity.put("name",name);
        this.diseaseList.add(entity);
    }




}
