package com.xxh.cloud.datalabel.config.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.datalabel.config.framework.modules.base.entity.DataLabelRuleBackUpInfo;
import com.xxh.cloud.datalabel.config.framework.modules.base.entity.DataLabelRuleConfig;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.vos.DataLabelRuleBackUpVO;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.vos.DataLabelRuleConfigVO;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class DataLabelRuleBackUpConvert {

    public static DataLabelRuleBackUpVO getDataLabelRuleBackUpVO(DataLabelRuleBackUpInfo entity){
        DataLabelRuleBackUpVO data=new DataLabelRuleBackUpVO();
        BeanUtil.copyProperties(entity,data,"labelIds","config");
        if(StrUtil.isNotEmpty(entity.getLabelIds())){
            data.setLabelIds(StrJoinSplitUtils.split2List(entity.getLabelIds()));
        }
        if(StrUtil.isNotEmpty(entity.getConfig())){
            data.setConfig(JSON.parseObject(entity.getConfig(), NodeCondition.class));
        }
        return data;
    }


    public static DataLabelRuleBackUpVO getDataLabelRuleBackUpVO(DataLabelRuleBackUpInfo entity,
                                                                 Map<String, LabelBO> labelMap,
                                                                 Map<String, AdminUserBO> userMap) {
        DataLabelRuleBackUpVO data = getDataLabelRuleBackUpVO(entity);
        if(MapUtil.isNotEmpty(labelMap) && CollUtil.isNotEmpty(data.getLabelIds())){
            data.getLabelIds().forEach(id->{
                data.addLabel(labelMap.get(id));
            });
        }
        //todo:
        return data;
    }

}






