package com.xxh.cloud.datalabel.config.framework.modules.biz.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.datalabel.config.framework.modules.base.entity.DataLabelRuleConfig;
import com.xxh.cloud.datalabel.config.framework.modules.base.entity.DataLabelRuleRelInfo;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.vos.DataLabelRuleConfigVO;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.basic.label.client.api.bean.bos.LabelBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.rule.core.context.XXRuleVariable2NodeBO;
import com.xxh.cloud.rule.core.context.XXRuleVariableBO;
import com.xxh.cloud.rule.core.context.XXRuleVariableRoom;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class DataLabelRuleConfigConvert {

    public static DataLabelRuleConfigVO getDataLabelRuleConfigVO(DataLabelRuleConfig entity){
        DataLabelRuleConfigVO data=new DataLabelRuleConfigVO();
        BeanUtil.copyProperties(entity,data,"labelIds","config","diseaseIds");
        if(StrUtil.isNotEmpty(entity.getLabelIds())){
            data.setLabelIds(StrJoinSplitUtils.split2List(entity.getLabelIds()));
        }
        if(StrUtil.isNotEmpty(entity.getDiseaseIds())){
            data.setDiseaseIds(StrJoinSplitUtils.split2List(entity.getDiseaseIds()));
        }
        return data;
    }

    public static DataLabelRuleConfigVO getDataLabelRuleConfigVO(DataLabelRuleConfig entity,
                                                                 Map<String, LabelBO> labelMap,
                                                                 Map<String, AdminUserBO> userMap,
                                                                 Map<String, StandardDiseaseBO> diseaseMap){
        DataLabelRuleConfigVO data=getDataLabelRuleConfigVO(entity);
        if(MapUtil.isNotEmpty(labelMap) && CollUtil.isNotEmpty(data.getLabelIds())){
            data.getLabelIds().forEach(id->{
                data.addLabel(labelMap.get(id));
            });
        }

        if(MapUtil.isNotEmpty(userMap)){

        }
        if(MapUtil.isNotEmpty(diseaseMap) && CollUtil.isNotEmpty(data.getDiseaseIds())){
            data.getDiseaseIds().forEach(id->{
                StandardDiseaseBO disease= diseaseMap.get(id);
                if(disease!=null){
                    data.addDisease(disease.getId(),disease.getName());
                }
            });
        }
        return data;
    }


    public static DataLabelRuleConfigVO getDataLabelRuleConfigVOFull(DataLabelRuleConfig entity){
        DataLabelRuleConfigVO data=getDataLabelRuleConfigVO(entity);
        if(StrUtil.isNotEmpty(entity.getConfig())){
            data.setConfig(JSON.parseObject(entity.getConfig(), NodeCondition.class));
        }
        return data;
    }



    //

    public static List<DataLabelRuleRelInfo> getDataLabelRuleRelInfo_Add(String configId, XXRuleVariableRoom ruleVariableRoom){
        List<DataLabelRuleRelInfo> data=new ArrayList<>();
        for(String key:ruleVariableRoom.keySet()){
            XXRuleVariable2NodeBO ruleVariable2NodeBO = ruleVariableRoom.get(key);
            if(CollUtil.isNotEmpty(ruleVariable2NodeBO.getVars())){
                ruleVariable2NodeBO.getVars().forEach(item->{
                    data.add(DataLabelRuleConfigConvert.getDataLabelRuleRelInfo_Add(configId,item));
                });
            }
        }
        return data;
    }

    public static DataLabelRuleRelInfo getDataLabelRuleRelInfo_Add(String configId, XXRuleVariableBO item){
        DataLabelRuleRelInfo entity=new DataLabelRuleRelInfo();
        entity.setId(IdUtil.getSnowflake(5,1).nextIdStr());
//        entity.setProjectCode("");
        entity.setConfigId(configId);
        entity.setConditionOneCode(item.getContionOneCode());
        entity.setConditionOneName(item.getContionOneName());
        entity.setParamType(item.getParamType());
        entity.setParamCode(item.getParamCode());
        entity.setParamName(item.getParamName());
        return entity;
    }



}
