package com.xxh.cloud.datalabel.config.framework.modules.cache.service.impl;

import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.datalabel.config.framework.modules.cache.keys.DataLabelRuleConfigKeys;
import com.xxh.cloud.datalabel.config.framework.modules.cache.service.DataLabelRuleConfigCacheService;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class DataLabelRuleConfigCacheServiceImpl implements DataLabelRuleConfigCacheService {

    @Autowired
    private RedisUtils redisUtils;


    @Override
    public void removeDataLabelRuleConfig(String id) {
        String key= DataLabelRuleConfigKeys.getDataLabelRuleConfigIdKey(id);
        redisUtils.delete(key);

        String allKey= DataLabelRuleConfigKeys.getDataLabelRuleConfigALLKey();
        redisUtils.delete(allKey);

    }

    @Override
    public void removeDataLabelRuleConfig(String id, String type, String label) {
        String key= DataLabelRuleConfigKeys.getDataLabelRuleConfigIdKey(id);
        redisUtils.delete(key);


        if(StrUtil.isNotEmpty(type)){
            String typeKey= DataLabelRuleConfigKeys.getDataLabelRuleConfigTypeKey(type);
            redisUtils.delete(typeKey);
        }

        if(StrUtil.isNotEmpty(label)){
            String labelKey= DataLabelRuleConfigKeys.getDataLabelRuleConfigLabelKey(label);
            redisUtils.delete(labelKey);
        }

        String allKey= DataLabelRuleConfigKeys.getDataLabelRuleConfigALLKey();
        redisUtils.delete(allKey);

        
    }




}
