package com.xxh.cloud.datalabel.config.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.dto.DataLabelRuleConfigQueryDTO;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.dto.DataLabelRuleRelQueryDTO;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.vos.DataLabelRuleConfigVO;
import com.xxh.cloud.datalabel.config.framework.modules.biz.bean.vos.DataLabelRuleRelVO;
import com.xxh.cloud.datalabel.config.framework.modules.biz.service.DataLabelRuleRelBizService;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("/sys/dataLabel/configRel")
@Api(tags = "运营端,数据标签规则引用管理")
public class DataLabelRuleRelManagerController {

    @Autowired
    private DataLabelRuleRelBizService dataLabelRuleRelBizService;

    @SaCheckPermission("sys:dataLabel:configRel:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = DataLabelRuleRelVO.class)
    public Result<PageData<DataLabelRuleRelVO>> query(@RequestBody DataLabelRuleRelQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<DataLabelRuleRelVO> data= dataLabelRuleRelBizService.query(params);
        return new Result<PageData<DataLabelRuleRelVO>>().ok(data);
    }






}
