package com.xxh.cloud.datalabel.executor.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 数据标签调用日志表
 * </p>
 *
 * @author anros
 * @since 2024-08-06
 */
@Data
@TableName("r_data_label_rule_call_log")
public class DataLabelRuleCallLog {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 开始执行时间
     */
     @ApiModelProperty(value = "开始执行时间")
      private Date startDt;

    /**
     * 截止执行时间
     */
     @ApiModelProperty(value = "截止执行时间")
      private Date endDt;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 患者数据日期
     */
     @ApiModelProperty(value = "患者数据日期")
      private String patientDataDt;

    /**
     * 患者数据变更
     */
     @ApiModelProperty(value = "患者数据变更")
      private String patientDataChange;

    @ApiModelProperty(value = "调用类型")
     private String callType;

    @ApiModelProperty(value = "调用参数")
    private String callParam;


    @ApiModelProperty(value = "错误信息")
    private String errMsg;

    @ApiModelProperty(value = "结果标记")
    private String resultFlag;


}
