package com.xxh.cloud.datalabel.executor.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 数据标签执行日志表
 * </p>
 *
 * @author anros
 * @since 2024-08-06
 */
@Data
@TableName("r_data_label_rule_exe_log")
public class DataLabelRuleExeLog{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 主执行批次ID
     */
     @ApiModelProperty(value = "主执行批次ID")
      private String mainBatchId;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 规则ID
     */
     @ApiModelProperty(value = "规则ID")
      private String ruleId;

    /**
     * 开始执行时间
     */
     @ApiModelProperty(value = "开始执行时间")
      private Date startDt;

    /**
     * 截止执行时间
     */
     @ApiModelProperty(value = "截止执行时间")
      private Date endDt;

    /**
     * 患者数据日期
     */
     @ApiModelProperty(value = "患者数据日期")
      private String patientDataDt;

    /**
     * 执行结果状态
     */
     @ApiModelProperty(value = "执行结果状态")
      private String resultStatus;

    /**
     * 执行结果备注
     */
     @ApiModelProperty(value = "执行结果备注")
      private String resultRemark;


}
