package com.xxh.cloud.datalabel.executor.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 数据标签规则执行成功依据表
 * </p>
 *
 * @author anros
 * @since 2024-08-06
 */
@Data
@TableName("r_data_label_rule_exe_success_info")
public class DataLabelRuleExeSuccessInfo{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 患者数据日期
     */
     @ApiModelProperty(value = "患者数据日期")
      private Date patientDataDt;

    /**
     * 流程规则配置ID
     */
     @ApiModelProperty(value = "流程规则配置ID")
      private String ruleId;

    /**
     * 流程规则版本号
     */
     @ApiModelProperty(value = "流程规则版本号")
      private Integer ruleVersion;

    /**
     * 流程规则名称
     */
     @ApiModelProperty(value = "流程规则名称")
      private String ruleName;

    /**
     * 操作开始时间
     */
     @ApiModelProperty(value = "操作开始时间")
      private Date startDate;

    /**
     * 操作截止时间
     */
     @ApiModelProperty(value = "操作截止时间")
      private Date endDate;

    /**
     * 操作时间(秒)
     */
     @ApiModelProperty(value = "操作时间(秒)")
      private Integer timeNum;

    /**
     * 执行结果路径
     */
     @ApiModelProperty(value = "执行结果路径")
      private String executeResult;

    /**
     * 执行结果状态
     */
     @ApiModelProperty(value = "执行结果状态")
      private String executeResultStatus;

    /**
     * 执行动作配置
     */
     @ApiModelProperty(value = "执行动作配置")
      private String actionConfig;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;


}
