package com.xxh.cloud.datalabel.executor.framework.modules.biz.bean.dto;


import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.xxh.cloud.datalabel.client.bean.dto.LabelRuleExecuteByAllDTO;
import com.xxh.cloud.datalabel.client.bean.dto.LabelRuleExecuteByRuleIdDTO;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.convert.DLELogIdUtils;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

@Getter
@Setter
public class DataLabelRuleCallLogAddDTO {



    private String id;


    @ApiModelProperty(value = "调用类型")
    private String callType;

    @ApiModelProperty(value = "调用参数")
    private String callParam;


    @ApiModelProperty(value = "开始执行时间")
    private Date startDt;


    @ApiModelProperty(value = "截止执行时间")
    private Date endDt;


    @ApiModelProperty(value = "患者ID")
    private String patientId;


    @ApiModelProperty(value = "患者数据日期")
    private String patientDataDt;


    @ApiModelProperty(value = "患者数据变更")
    private String patientDataChange;


    @ApiModelProperty(value = "错误信息")
    private String errMsg;

    @ApiModelProperty(value = "结果标记")
    private String resultFlag;


    public DataLabelRuleCallLogAddDTO(LabelRuleExecuteByRuleIdDTO params){
        this.id= DLELogIdUtils.getDataLabelRuleCallLogId();
        this.startDt=new Date();
        this.callType="id";
        this.callParam=params.getRuleId();
        this.patientId=params.getPatientId();
        this.patientDataDt=params.getDataDay();
        this.patientDataChange=params.getDataScope();
    }


    public DataLabelRuleCallLogAddDTO(LabelRuleExecuteByAllDTO params){
        this.id= DLELogIdUtils.getDataLabelRuleCallLogId();
        this.startDt=new DateTime();
        this.callType="all";
        this.callParam="all";
        this.patientId=params.getPatientId();
        this.patientDataDt=params.getDataDay();
        this.patientDataChange=params.getDataScope();
    }


//    public static void main(String[] args) throws InterruptedException {
//        Date d1=new Date();
//        System.out.println(DateUtil.formatDateTime(d1));
//
//        Thread.sleep(2000);
//
//        Date d2=new Date();
//        System.out.println(DateUtil.formatDateTime(d2));
//    }




}
