package com.xxh.cloud.datalabel.executor.framework.modules.biz.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.datalabel.executor.framework.modules.base.entity.DataLabelRuleCallLog;
import com.xxh.cloud.datalabel.executor.framework.modules.base.entity.DataLabelRuleExeLog;
import com.xxh.cloud.datalabel.executor.framework.modules.base.entity.DataLabelRuleExeSuccessInfo;
import com.xxh.cloud.datalabel.executor.framework.modules.base.service.DataLabelRuleCallLogService;
import com.xxh.cloud.datalabel.executor.framework.modules.base.service.DataLabelRuleExeLogService;
import com.xxh.cloud.datalabel.executor.framework.modules.base.service.DataLabelRuleExeSuccessInfoService;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.bean.dto.DataLabelRuleCallLogAddDTO;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.bean.vos.DataLabelExecuteLogVO;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.convert.DLELogIdUtils;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.convert.DataLabelExecuteLogConvert;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.service.DataLabelExecuteLogBizService;

import com.xxh.cloud.framework.common.mybatisplus.config.DynamicTableNameHandler;
import io.swagger.annotations.ApiModelProperty;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Log4j2
@Service
public class DataLabelExecuteLogBizServiceImpl implements DataLabelExecuteLogBizService {

    @Autowired
    private DataLabelRuleExeSuccessInfoService dataLabelRuleExeSuccessInfoService;

    @Autowired
    private DataLabelRuleCallLogService dataLabelRuleCallLogService;
    @Autowired
    private DataLabelRuleExeLogService dataLabelRuleExeLogService;




    @Override
    public String saveDlrCallLog(DataLabelRuleCallLogAddDTO params) {

        DataLabelRuleCallLog entity=new DataLabelRuleCallLog();
        entity.setId(params.getId());
        entity.setStartDt(params.getStartDt());
        entity.setEndDt(params.getEndDt());
        entity.setCallType(params.getCallType());
        entity.setCallParam(params.getCallParam());
        entity.setPatientId(params.getPatientId());
        entity.setPatientDataDt(params.getPatientDataDt());
        entity.setPatientDataChange(params.getPatientDataChange());
        entity.setErrMsg(params.getErrMsg());
        entity.setResultFlag(params.getResultFlag());

        String idPrefix = DLELogIdUtils.getIdPrefix_ById(entity.getId());
        DynamicTableNameHandler.setTableNameSuffix(idPrefix);
        dataLabelRuleCallLogService.save(entity);

        return entity.getId();
    }

    @Override
    public void saveDlrExeLogBatch(String idPrefix, List<DataLabelRuleExeLog> list){
        if(CollUtil.isEmpty(list)){
            return;
        }
        System.out.println("-----r_data_label_rule_exe_log = "+idPrefix);
        DynamicTableNameHandler.setTableNameSuffix(idPrefix);
        dataLabelRuleExeLogService.saveBatch(list);
    }

    @Override
    public void saveDLRExeSuccessBatch(String idPrefix,List<DataLabelRuleExeSuccessInfo> list) {
        if(CollUtil.isEmpty(list)){
            return;
        }
        System.out.println("-----r_data_label_rule_exe_success_info = "+idPrefix);
        DynamicTableNameHandler.setTableNameSuffix(idPrefix);
        dataLabelRuleExeSuccessInfoService.saveBatch(list);
    }



    @Override
    public DataLabelExecuteLogVO getDataLabelExecuteLogById(String id) {
        String idPrefix = DLELogIdUtils.getDataLabelRuleExeSuccess2Prefix(id);
        DynamicTableNameHandler.setTableNameSuffix(idPrefix);
        DataLabelRuleExeSuccessInfo entity= dataLabelRuleExeSuccessInfoService.getById(id);
        if(entity==null){
            return null;
        }
        DataLabelExecuteLogVO data= DataLabelExecuteLogConvert.getDataLabelExecuteLogVO(entity);
        return data;
    }
}
