package com.xxh.cloud.datalabel.executor.framework.modules.biz.utils;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.rule.core.entity.label.XXLabelRuleBO;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class RuleDataScopeUtils {


    public static  XXLabelRuleBO getRuleConfigByScope(XXLabelRuleBO ruleConfig,String dataScope){
        Set<String> dataScopeSet= StrJoinSplitUtils.split2Set(dataScope);
        boolean flag= RuleDataScopeUtils.isRuleConfigScope(ruleConfig.getVarCodes(),dataScopeSet);
        return flag?ruleConfig:null;
    }


    public static List<XXLabelRuleBO> getRuleConfigListByScope(List<XXLabelRuleBO> ruleConfigList,String dataScope){

        if(CollUtil.isEmpty(ruleConfigList)){
            return null;
        }

        if(StrUtil.isEmpty(dataScope)){
            return null;
        }
        Set<String> dataScopeSet= StrJoinSplitUtils.split2Set(dataScope);

        List<XXLabelRuleBO> data=new ArrayList<>();

        for(XXLabelRuleBO ruleConfig : ruleConfigList){
            boolean flag= RuleDataScopeUtils.isRuleConfigScope(ruleConfig.getVarCodes(),dataScopeSet);
            if(flag){
                data.add(ruleConfig);
            }
        }

        return data;
    }


    public static boolean isRuleConfigScope(Set<String> ruleVarCodes ,String dataScope){
        Set<String> dataScopeSet= StrJoinSplitUtils.split2Set(dataScope);
        return RuleDataScopeUtils.isRuleConfigScope(ruleVarCodes,dataScopeSet);
    }

    public static boolean isRuleConfigScope(Set<String> ruleVarCodes ,Set<String> dataScopeSet){
        if(CollUtil.isEmpty(ruleVarCodes)){
            return false;
        }
        if(CollUtil.isEmpty(dataScopeSet)){
            return false;
        }

        Set<String> resSet=new HashSet<>();

        resSet.addAll(ruleVarCodes);
        resSet.retainAll(dataScopeSet);

        if(resSet.size()>0){
            return true;
        }else {
            return false;
        }
    }


//    public static void main(String[] args) {
//
//    }


}
