package com.xxh.cloud.datalabel.executor.framework.modules.cache.service.impl;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.datalabel.executor.framework.modules.base.entity.DataLabelRuleExeSuccessInfo;
import com.xxh.cloud.datalabel.executor.framework.modules.base.service.DataLabelRuleExeSuccessInfoService;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.bean.vos.DataLabelExecuteLogVO;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.convert.DLELogIdUtils;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.convert.DataLabelExecuteLogConvert;
import com.xxh.cloud.datalabel.executor.framework.modules.cache.keys.DataLabelCacheKeys;
import com.xxh.cloud.datalabel.executor.framework.modules.cache.service.DataLabelExecuteLogCacheService;
import com.xxh.cloud.framework.common.mybatisplus.config.DynamicTableNameHandler;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class DataLabelExecuteLogCacheServiceImpl implements DataLabelExecuteLogCacheService {

    @Autowired
    private RedisUtils redisUtils;

    @Autowired
    private DataLabelRuleExeSuccessInfoService dataLabelRuleExeSuccessInfoService;


    @Override
    public DataLabelExecuteLogVO getDataLabelExecuteLogByCache(String id) {

        String cacheKey= DataLabelCacheKeys.getDataLabelExecuteLogKey(id);
        Object objJson= redisUtils.get(cacheKey);
        if(objJson!=null){
            return JSON.parseObject(objJson.toString(),DataLabelExecuteLogVO.class);
        }

        DataLabelExecuteLogVO data=this.getDataLabelExecuteLogByDB(id);

        if(data!=null){
            redisUtils.set(cacheKey,JSON.toJSONString(data),RedisUtils.HOUR_ONE_EXPIRE);
        }

        return data;
    }


    @Override
    public DataLabelExecuteLogVO getDataLabelExecuteLogByDB(String id) {
        //todo:240806 wang
        String idPrefix = DLELogIdUtils.getDataLabelRuleExeSuccess2Prefix(id);
        DynamicTableNameHandler.setTableNameSuffix(idPrefix);
        DataLabelRuleExeSuccessInfo entity= dataLabelRuleExeSuccessInfoService.getById(id);
        if(entity==null){
            return null;
        }
        DataLabelExecuteLogVO data= DataLabelExecuteLogConvert.getDataLabelExecuteLogVO(entity);
        return data;
    }


}
