package com.xxh.cloud.datalabel.executor.framework.modules.config.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.datalabel.executor.framework.modules.config.bean.DataLabelConfigDataGetBO;
import com.xxh.cloud.datalabel.executor.framework.modules.config.bean.DataLabelConfigRelGetBO;
import com.xxh.cloud.datalabel.executor.framework.modules.config.mapper.DataLabelConfigDataGetMapper;
import com.xxh.cloud.datalabel.executor.framework.modules.config.service.DataLabelConfigDataGetService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.entity.label.XXLabelRuleBO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class DataLabelConfigDataGetServiceImpl implements DataLabelConfigDataGetService {

    @Autowired
    private DataLabelConfigDataGetMapper dataLabelConfigDataGetMapper;


    @Override
    public XXLabelRuleBO getDataLabelConfig(String id) {
        DataLabelConfigDataGetBO entity= dataLabelConfigDataGetMapper.getDataLabelConfig(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("id",id)
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );

        if(entity==null){
            return null;
        }

        List<DataLabelConfigRelGetBO> varList= dataLabelConfigDataGetMapper.getDataLabelConfigRelList(
                new QueryWrapper<DataLabelConfigRelGetBO>()
                        .eq("config_id",entity.getId())
        );


        return this.getXXLabelRuleBO(entity,varList);
    }

    @Override
    public XXLabelRuleBO getDataLabelConfig_Test(String id) {
        DataLabelConfigDataGetBO entity= dataLabelConfigDataGetMapper.getDataLabelConfig(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("id",id)
                        .eq("rows_status",YN.YES.getCode())
        );

        if(entity==null){
            return null;
        }

        List<DataLabelConfigRelGetBO> varList= dataLabelConfigDataGetMapper.getDataLabelConfigRelList(
                new QueryWrapper<DataLabelConfigRelGetBO>()
                        .eq("config_id",entity.getId())
        );


        return this.getXXLabelRuleBO(entity,varList);
    }

    @Override
    public List<XXLabelRuleBO> getDataLabelConfig(Collection<String> ids) {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .in("id",ids)
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );
        return this._getList(entityList);
    }

    @Override
    public List<XXLabelRuleBO> getDataLabelConfigByAll() {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );
        return this._getList(entityList);
    }

    @Override
    public Set<String> getDataLabelConfigIdByAll() {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigIdList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );

        Set<String> data=new HashSet<>();
        if(CollUtil.isNotEmpty(entityList)){
            entityList.forEach(item->{
                data.add(item.getId());
            });
        }
        return data;
    }


    @Override
    public List<XXLabelRuleBO> getDataLabelConfigByLabel(String labelId) {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("label_ids",labelId)
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );
        return this._getList(entityList);
    }

    @Override
    public List<XXLabelRuleBO> getDataLabelConfigByType(String type) {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("type",type)
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );
        return this._getList(entityList);
    }

    @Override
    public List<XXLabelRuleBO> getDataLabelConfigByCategory(String categoryId) {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .eq("category_id",categoryId)
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );
        return this._getList(entityList);
    }

    @Override
    public List<XXLabelRuleBO> getDataLabelConfigByCategory(List<String> categoryIds) {
        List<DataLabelConfigDataGetBO> entityList= dataLabelConfigDataGetMapper.getDataLabelConfigList(
                new QueryWrapper<DataLabelConfigDataGetBO>()
                        .in("category_id",categoryIds)
                        .eq("status", YN.YES.getCode())
                        .eq("rows_status",YN.YES.getCode())
        );
        return this._getList(entityList);
    }



    private List<XXLabelRuleBO> _getList(List<DataLabelConfigDataGetBO> entityList){
        List<XXLabelRuleBO> data=new ArrayList<>();
        if(CollUtil.isEmpty(entityList)){
            return data;
        }

        Set<String> ids=new HashSet<>();
        entityList.forEach(item->{
            ids.add(item.getId());
        });

        List<DataLabelConfigRelGetBO> varList= dataLabelConfigDataGetMapper.getDataLabelConfigRelList(
                new QueryWrapper<DataLabelConfigRelGetBO>()
                        .in("config_id",ids)
        );

        entityList.forEach(item->{
            data.add(this.getXXLabelRuleBO(item,varList));
        });

        return data;
    }



    private XXLabelRuleBO getXXLabelRuleBO(DataLabelConfigDataGetBO entity,List<DataLabelConfigRelGetBO> varList){
        if(entity==null){
            return null;
        }
        XXLabelRuleBO data=new XXLabelRuleBO();
        data.setId(entity.getId());
        data.setCategoryId(entity.getCategoryId());
        data.setProjectCode(entity.getProjectCode());
        data.setVersion(entity.getVersionNo());
        data.setName(entity.getName());
        data.setType(entity.getType());
        data.setStatus(entity.getStatus());
        data.setLabelId(entity.getLabelIds());
        data.setLabelValidityNum(entity.getLabelValidityNum());
        data.setDiseaseIds(entity.getDiseaseIds());
        data.setInitDateType(entity.getInitDateType());
        data.setInitDateValue(entity.getInitDateValue());
        if(StrUtil.isNotEmpty(entity.getConfig())){
            data.setConfig(JSON.parseObject(entity.getConfig(),NodeCondition.class));
        }


        if(CollUtil.isNotEmpty(varList)){
            varList.forEach(item->{
                if(item.getConfigId().equals(data.getId())){
                    data.addVarCode(item.getVarCode());
                }
            });
        }



        return data;
    }


}
