package com.xxh.cloud.datalabel.execute.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.bean.dto.DataLabelExecuteLogGetDTO;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.bean.vos.DataLabelExecuteLogVO;
import com.xxh.cloud.datalabel.executor.framework.modules.biz.service.DataLabelExecuteLogBizService;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Log4j2
@RestController
@RequestMapping("/sys/rule/label/log")
@Api(tags = "运营端,标签规则日志")
public class DataLabelExecuteLogManagerController {


    @Autowired
    private DataLabelExecuteLogBizService dataLabelExecuteLogBizService;


    @SaCheckPermission("sys:rule:label:log:getById")
    @PostMapping("/getById")
    @ApiOperation(value = "获取", response = DataLabelExecuteLogVO.class)
    public Result<DataLabelExecuteLogVO> getById(@RequestBody DataLabelExecuteLogGetDTO params) {
        ValidatorUtils.validateEntity(params);
        DataLabelExecuteLogVO data= dataLabelExecuteLogBizService.getDataLabelExecuteLogById(params.getId());
        return new Result<DataLabelExecuteLogVO>().ok(data);
    }





}
