package com.xxh.cloud.rule.basic.api.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class MethodExecuteDTO {

    /**
     * 规则ID
     * */
    private String ruleId;

    /**
     * 节点ID
     * */
    private String nodeId;


    /**
     * 节点名称
     * */
    private String nodeName;

    /**
     * 执行批次ID
     * */
    private String traceId;

    /**
     * 动作(函数组)ID
     * */
    private String actionId;

    /**
     * 方法(函数)编号
     * */
    private String methodCode;

    /**
     * 方法参数
     * */
    private List<MethodExecuteParamDTO> params;


    public MethodExecuteDTO(String ruleId,String nodeId,String traceId,String actionId,String methodCode){
        this.ruleId=ruleId;
        this.nodeId=nodeId;
        this.traceId=traceId;
        this.actionId=actionId;
        this.methodCode=methodCode;
    }


    public MethodExecuteDTO(){

    }

    public void addParam(MethodExecuteParamDTO item){
        if(this.params==null){
            this.params=new ArrayList<>();
        }
        if(item!=null){
            this.params.add(item);
        }
    }


}
