package com.xxh.cloud.rule.basic.context.bean;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;


/**
 * 诊断
 * */
@Getter
@Setter
public class RoamItemDwdDiagnosisReport {




    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "住院号")
    private String inPatientNo;


    @ApiModelProperty(value = "下诊断科室名称(原始)")
    private String departmentNameRaw;

    @ApiModelProperty(value = "下诊断科室名称(标准)")
    private String departmentNameStandard;

    @ApiModelProperty(value = "下诊断科室编码(原始)")
    private String departmentCodeRaw;

    @ApiModelProperty(value = "下诊断科室编码(标准)")
    private String departmentCodeStandard;

    @ApiModelProperty(value = "下诊断医生编号")
    private String doctorCode;

    @ApiModelProperty(value = "下诊断医生姓名")
    private String doctorName;

    @ApiModelProperty(value = "诊断时间")
    private Date diagnosisTime;

    @ApiModelProperty(value = "场景分类(原始)")
    private String sceneTypeRaw;

    @ApiModelProperty(value = "场景分类(标准)")
    private String sceneTypeStandard;

    @ApiModelProperty(value = "诊断业务分类")
    private String bizType;

    @ApiModelProperty(value = "诊断编码(原始)")
    private String diagnosisCodeRaw;

    @ApiModelProperty(value = "诊断编码(标准)")
    private String diagnosisCodeStandard;

    @ApiModelProperty(value = "诊断内容(原始)")
    private String diagnosisNameRaw;

    @ApiModelProperty(value = "诊断内容(标准)")
    private String diagnosisNameStandard;


    @ApiModelProperty(value = "是否主诊断")
    private String mainFlag;

    @ApiModelProperty(value = "是否确诊")
    private String confirmFlag;

    @ApiModelProperty(value = "对象类型")
    private String ot;

}
