package com.xxh.cloud.rule.basic.context.bean;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

/**
 * 出院
 * */
@Getter
@Setter
public class RoamItemDwdDischargeRecord {



    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "id")
    private String id;


    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "关联住院号")
    private String inPatientNo;


    @ApiModelProperty(value = "入住科室名称(原始)")
    private String admitDepartmentNameRaw;

    @ApiModelProperty(value = "入住科室名称(标准)")
    private String admitDepartmentNameStandard;

    @ApiModelProperty(value = "入住科室编码(原始)")
    private String admitDepartmentCodeRaw;

    @ApiModelProperty(value = "入住科室编码(标准)")
    private String admitDepartmentCodeStandard;


    @ApiModelProperty(value = "出院时间")
    private Date leaveDate;

    @ApiModelProperty(value = "icu天数")
    private Integer icuDays;


    @ApiModelProperty(value = "出院方式(原始)")
    private String leaveWayRaw;

    @ApiModelProperty(value = "出院方式名称(原始)")
    private String leaveWayNameRaw;

    @ApiModelProperty(value = "出院方式(标准)")
    private String leaveWayStandard;

    @ApiModelProperty(value = "出院小结(标准)")
    private List<String> contentStandard;

    @ApiModelProperty(value = "诊断编码(标准)")
    private List<String> diagnosisCodeStandard;


    @ApiModelProperty(value = "对象类型")
    private String ot;

}
