package com.xxh.cloud.rule.basic.context.bean;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

/**
 * 检查申请
 * */
@Getter
@Setter
public class RoamItemDwdExamineApply {


    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "检查申请单id")
    private String id;

    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "住院号")
    private String inPatientNo;


    @ApiModelProperty(value = "申请科室名称(原始)")
    private String departmentNameRaw;

    @ApiModelProperty(value = "申请科室名称(标准)")
    private String departmentNameStandard;

    @ApiModelProperty(value = "申请科室编码(原始)")
    private String departmentCodeRaw;

    @ApiModelProperty(value = "申请科室编码(标准)")
    private String departmentCodeStandard;

    @ApiModelProperty(value = "申请医生编号")
    private String doctorCode;

    @ApiModelProperty(value = "申请医生姓名")
    private String doctorName;

    @ApiModelProperty(value = "申请支付时间")
    private Date payDate;

    @ApiModelProperty(value = "申请时间")
    private Date applyDate;

    @ApiModelProperty(value = "场景分类(原始)")
    private String sceneTypeRaw;

    @ApiModelProperty(value = "场景分类(标准)")
    private String sceneTypeStandard;

    @ApiModelProperty(value = "检查项目(标准)")
    private List<String> itemsStandard;

    @ApiModelProperty(value = "医嘱诊断编号(标准)")
    private List<String> diagnosisCodeStandard;

    @ApiModelProperty(value = "对象类型")
    private String ot;


}
