package com.xxh.cloud.rule.basic.context.bean;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

/**
 * 检查预约
 */
@Getter
@Setter
public class RoamItemDwdExamineReserve {


    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "检查预约申请号")
    private String id;

    @ApiModelProperty(value = "申请流水号")
    private String applyId;


    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "关联住院号")
    private String inPatientNo;


    @ApiModelProperty(value = "申请科室名称(原始)")
    private String applyDepartmentNameRaw;


    @ApiModelProperty(value = "申请科室名称(标准)")
    private String applyDepartmentNameStandard;

    @ApiModelProperty(value = "申请科室编码(原始)")
    private String applyDepartmentCodeRaw;

    @ApiModelProperty(value = "申请科室编码(标准)")
    private String applyDepartmentCodeStandard;

    @ApiModelProperty(value = "医生编号")
    private String doctorCode;

    @ApiModelProperty(value = "医生姓名")
    private String doctorName;

    @ApiModelProperty(value = "申请时间")
    private Date applyDate;

    @ApiModelProperty(value = "预约时间")
    private Date bookDate;


    @ApiModelProperty(value = "检查项目(标准)")
    private List<String> itemsStandard;

    @ApiModelProperty(value = "对象类型")
    private String ot;

}
