package com.xxh.cloud.rule.basic.context.bean;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

/**
 * 预约住院
 * */
@Getter
@Setter
public class RoamItemDwdInpatientReserve {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "关联住院号")
    private String inPatientNo;


    @ApiModelProperty(value = "申请科室名称(原始)")
    private String applyDepartmentNameRaw;

    @ApiModelProperty(value = "申请科室名称(标准)")
    private String applyDepartmentNameStandard;

    @ApiModelProperty(value = "申请科室编码(原始)")
    private String applyDepartmentCodeRaw;

    @ApiModelProperty(value = "申请科室编码(标准)")
    private String applyDepartmentCodeStandard;

    @ApiModelProperty(value = "入住科室名称(原始)")
    private String admitDepartmentNameRaw;

    @ApiModelProperty(value = "入住科室名称(标准)")
    private String admitDepartmentNameStandard;

    @ApiModelProperty(value = "入住科室编码(原始)")
    private String admitDepartmentCodeRaw;

    @ApiModelProperty(value = "入住科室编码(标准)")
    private String admitDepartmentCodeStandard;


    @ApiModelProperty(value = "申请时间")
    private Date applyDate;

    @ApiModelProperty(value = "预约时间")
    private Date bookDate;

    @ApiModelProperty(value = "申请医生编号")
    private String doctorCode;

    @ApiModelProperty(value = "申请医生姓名")
    private String doctorName;

    @ApiModelProperty(value = "入院诊断编码(标准)")
    private List<String> diagnosisCodeStandard;

    @ApiModelProperty(value = "对象类型")
    private String ot;

}
