package com.xxh.cloud.rule.basic.context.bean;

import cn.hutool.core.util.StrUtil;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 检验报告单
 * */
@Getter
@Setter
public class RoamItemDwdLaboratoryReport {


    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "申请单流水号")
    private String applyId;

    @ApiModelProperty(value = "住院号")
    private String inPatientNo;


    @ApiModelProperty(value = "申请科室名称(原始)")
    private String departmentNameRaw;

    @ApiModelProperty(value = "申请科室名称(标准)")
    private String departmentNameStandard;

    @ApiModelProperty(value = "申请科室编码(原始)")
    private String departmentCodeRaw;

    @ApiModelProperty(value = "申请科室编码(标准)")
    private String departmentCodeStandard;

    @ApiModelProperty(value = "报告时间")
    private Date reportsTime;

    @ApiModelProperty(value = "复核时间")
    private Date checkTime;

    @ApiModelProperty(value = "申请时间")
    private Date applyTime;

    @ApiModelProperty(value = "采样时间")
    private Date inspectTime;


    @ApiModelProperty(value = "场景分类(原始)")
    private String sceneTypeRaw;

    @ApiModelProperty(value = "场景分类(标准)")
    private String sceneTypeStandard;

    @ApiModelProperty(value = "申请医生编号")
    private String applyDoctorCode;

    @ApiModelProperty(value = "申请医生姓名")
    private String applyDoctorName;


    @ApiModelProperty(value = "报告医生编号")
    private String doctorCode;

    @ApiModelProperty(value = "报告医生姓名")
    private String doctorName;


    @ApiModelProperty(value = "样本类别(原始)")
    private String sampleTypeRaw;

    @ApiModelProperty(value = "样本类别(标准)")
    private String sampleTypeStandard;


    @ApiModelProperty(value = "报告名称")
    private String reportName;

    @ApiModelProperty(value = "报告描述或备注(原始)")
    private String descriptionRaw;

    @ApiModelProperty(value = "报告描述或备注(标准)")
    private List<String> descriptionStandard;

    @ApiModelProperty(value = "初步结论(原始)")
    private String conclusionRaw;

    @ApiModelProperty(value = "初步结论(标准)")
    private List<String> conclusionStandard;

    @ApiModelProperty(value = "明细")
    private Map<String,RoamItemDwdLaboratoryReportItem> itemMap;

    @ApiModelProperty(value = "对象类型")
    private String ot;

    @ApiModelProperty(value = "活动编号")
    private String actNo;

    public void addItem(RoamItemDwdLaboratoryReportItem item){
        if(this.itemMap==null){
            this.itemMap=new HashMap<>();
        }
        if(item!=null){
            this.itemMap.put(item.getProjectIdStandard(),item);
        }
    }

    public RoamItemDwdLaboratoryReportItem getItem(String code){
        if(StrUtil.isEmpty(code)){
            return null;
        }
        if(itemMap==null){
            return null;
        }
        return itemMap.get(code);
    }



}
