package com.xxh.cloud.rule.basic.context.bean;

import cn.hutool.core.util.StrUtil;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 治疗
 */
@Getter
@Setter
public class RoamItemDwdRecipeTherapy {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "患者编号")
    private String patientId;

    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    @ApiModelProperty(value = "住院号")
    private String inPatientNo;

    @ApiModelProperty(value = "申请科室名称(原始)")
    private String departmentNameRaw;

    @ApiModelProperty(value = "申请科室名称(标准)")
    private String departmentNameStandard;

    @ApiModelProperty(value = "申请科室编码(原始)")
    private String departmentCodeRaw;

    @ApiModelProperty(value = "申请科室编码(标准)")
    private String departmentCodeStandard;

    @ApiModelProperty(value = "付费时间")
    private Date payTime;

    @ApiModelProperty(value = "处方时间")
    private Date recipeTime;


    @ApiModelProperty(value = "场景分类(原始)")
    private String sceneTypeRaw;

    @ApiModelProperty(value = "场景分类(标准)")
    private String sceneTypeStandard;

    @ApiModelProperty(value = "申请医生编号")
    private String doctorCode;

    @ApiModelProperty(value = "申请医生姓名")
    private String doctorName;


    @ApiModelProperty(value = "医嘱诊断编码(标准)")
    private List<String> diagnosisCodeStandard;


    @ApiModelProperty(value = "状态(原始)")
    private String statusRaw;

    @ApiModelProperty(value = "状态(标准)")
    private String statusStandard;


    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    @ApiModelProperty(value = "明细")
    private Map<String, RoamItemDwdRecipeTherapyItem> itemMap;

    @ApiModelProperty(value = "对象类型")
    private String ot;

    public void addItem(RoamItemDwdRecipeTherapyItem item) {
        if (this.itemMap == null) {
            this.itemMap = new HashMap<>();
        }
        if (item != null) {
            this.itemMap.put(item.getCodeStandard(), item);
        }
    }


    public RoamItemDwdRecipeTherapyItem getItem(String code){
        if(StrUtil.isEmpty(code)){
            return null;
        }
        if(itemMap==null){
            return null;
        }
        return itemMap.get(code);
    }





}
