package com.xxh.cloud.rule.basic.data;

import cn.hutool.core.util.StrUtil;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 规则数据
 * */
public class XXRuleDataBO {



    /**
     * 患者基本信息
     * */
    private XXRuleRoamHealthBaseDataBO baseData;

    /**
     * yyyymmdd:dayData
     * */
    private Map<String, XXRuleDataDayBO> dayDataMap;



    public XXRuleDataBO(XXRuleRoamHealthBaseDataBO baseData,Map<String, XXRuleDataDayBO> dayDataMap){
        this.baseData=baseData;
        this.dayDataMap=dayDataMap;
    }



    public XXRuleDataBO(XXRuleRoamHealthBaseDataBO baseData){
        this.baseData=baseData;
    }


    public XXRuleDataBO(){

    }


    /**
     * @param data: 以天为单位的业务数据集合
     * */
    public void addDayDataMap(XXRuleDataDayBO data){
        if(this.dayDataMap==null){
            this.dayDataMap=new HashMap<>();
        }

        if( data!=null && StrUtil.isNotEmpty(data.getDate()) && data.getDataList()!=null){
            this.dayDataMap.put(data.getDate(),data);
        }
    }


    /**
     * @param  date : yyyymmdd
     * @param  item: 业务数据
     * */
    public void addDayData(String date,XXRuleRoamHealthDataBO item){
        if(this.dayDataMap==null){
            this.dayDataMap=new HashMap<>();
        }

        if(item==null){
            return;
        }

        XXRuleDataDayBO dayData= this.dayDataMap.get(date);

        if(dayData==null){
            dayData=new XXRuleDataDayBO(date);
            dayData.addData(item);
            this.dayDataMap.put(date,dayData);
        }else {
            dayData.addData(item);
            this.dayDataMap.put(date,dayData);
        }
    }









}
