package com.xxh.cloud.rule.framework.modules.action.biz.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.framework.modules.action.biz.RuleActionMethodParameterInfoBizService;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionMethodParameterInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.dto.MethodParamListDTO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodParameterVO;
import com.xxh.cloud.rule.framework.modules.action.helper.RuleActionMethodHelper;
import com.xxh.cloud.rule.framework.modules.action.service.RuleActionMethodParameterInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class RuleActionMethodParameterInfoBizServiceImpl implements RuleActionMethodParameterInfoBizService {

    @Autowired
    private RuleActionMethodParameterInfoService ruleActionMethodParameterInfoService;


    @Override
    public Map<String, RuleActionMethodParameterVO> getMethodParaMap(MethodParamListDTO params) {
        ValidatorUtils.validateEntity(params);
        Map<String, RuleActionMethodParameterVO> data=new HashMap<>();
        List<RuleActionMethodParameterVO> list=this.getMethodParaList(params);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            data.put(RuleActionMethodHelper.getActionMethodParameterKey(
                    item.getActionId(),item.getMethodCode(),item.getCode()),item);
        });
        return data;
    }

    @Override
    public List<RuleActionMethodParameterVO> getMethodParaList(MethodParamListDTO params) {
        ValidatorUtils.validateEntity(params);
        List<RuleActionMethodParameterVO> data=new ArrayList<>();
        List<RuleActionMethodParameterInfo> list =  ruleActionMethodParameterInfoService.list();
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            data.add(RuleActionMethodHelper.getRuleActionMethodParameterVO(item));
        });
        return data;
    }


}
