package com.xxh.cloud.rule.framework.modules.action.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionMethodInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionMethodParameterInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodVO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodParamConfigVO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodParameterVO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.List;
import java.util.Map;

public class RuleActionHelper {


    /**
     * 动作方法 id
     * */
    public static String getRuleActionMethodId(){
        return StrUtil.format("M{}", IdUtil.getSnowflake(6,5).nextIdStr());
    }


    /**
     * 动作方法参数 id
     * */
    public static String getRuleActionMethodParameterId(){
        return StrUtil.format("MP{}", IdUtil.getSnowflake(6,6).nextIdStr());
    }


    public static RuleActionVO getRuleActionVO(RuleActionInfo entity){
        RuleActionVO data=new RuleActionVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }
   public static RuleActionVO getRuleActionVO(RuleActionInfo entity, Map<String, AdminUserBO>  userMap){
        RuleActionVO data=getRuleActionVO(entity);
        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }
        return data;
    }


}
