package com.xxh.cloud.rule.framework.modules.action.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionMethodInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.dos.RuleActionMethodParameterInfo;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodParamConfigVO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodParameterVO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodVO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.List;
import java.util.Map;

public class RuleActionMethodHelper {

    public static RuleActionMethodVO getRuleActionMethodVO(RuleActionMethodInfo entity){
        RuleActionMethodVO data=new RuleActionMethodVO();
        BeanUtil.copyProperties(entity,data,"params");
        return data;
    }

    public static RuleActionMethodVO getRuleActionMethodVO(RuleActionMethodInfo entity,
                                                           Map<String, RuleActionVO> actionMap,
                                                           Map<String, AdminUserBO> userMap){
        RuleActionMethodVO data=getRuleActionMethodVO(entity);
        if(MapUtil.isNotEmpty(userMap)) {
            if (StrUtil.isNotEmpty(data.getCreator())) {
                AdminUserBO user = userMap.get(data.getCreator());
                if (user != null) {
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if (StrUtil.isNotEmpty(data.getUpdater())) {
                AdminUserBO user = userMap.get(data.getUpdater());
                if (user != null) {
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }
        if(MapUtil.isNotEmpty(actionMap) && StrUtil.isNotEmpty(data.getActionId())){
            RuleActionVO action=actionMap.get(data.getActionId());
            if(action!=null){
                data.setActionName(action.getName());
            }
        }
        return data;
    }


    public static RuleActionMethodVO getRuleActionMethodVO(RuleActionMethodInfo entity,
                                                           List<RuleActionMethodParameterInfo> list,
                                                           Map<String, RuleActionVO> actionMap,
                                                           Map<String, AdminUserBO> userMap){
        RuleActionMethodVO data=getRuleActionMethodVO(entity,actionMap,userMap);
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                if(data.getId().equals(item.getMethodId())){
                    RuleActionMethodParameterVO dataItem = getRuleActionMethodParameterVO(item);
                    data.addParam(dataItem);
                }
            });
        }
        return data;
    }

    public static RuleActionMethodParameterVO getRuleActionMethodParameterVO(RuleActionMethodParameterInfo entity){
        if(entity==null){
            return null;
        }
        RuleActionMethodParameterVO data=new RuleActionMethodParameterVO();
        BeanUtil.copyProperties(entity,data,"paraCfg");
        if(StrUtil.isNotEmpty(entity.getParaCfg())){
            data.setParaCfg(JSON.parseObject(entity.getParaCfg(), RuleActionMethodParamConfigVO.class));
        }
        return data;
    }

    public static String getActionMethodParameterKey(String actionId,String methodCode,String paramCode){
        return StrUtil.format("APK_{}_{}_{}",actionId,methodCode,paramCode);
    }

}
