package com.xxh.cloud.rule.framework.modules.cache.helper;

import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;

import java.util.Collections;
import java.util.Set;

public class RuleCacheKeysHelper {

    //========================================

    /**
     * 动作数据 缓存主key
     * */
    public static String getRuleActionMainKey(){
        return "rule:action:info:*";
    }

    /**
     * 动作数据 缓存key
     * */
    public static String getRuleActionKey(String id){
        return StrUtil.format("rule:action:info:{}",id);
    }



    //========================================

    /**
     * 动作方法 缓存主key
     * */
    public static String getRuleActionMethodMainKey(){
        return "rule:method:info:*";
    }

    /**
     * 动作方法 缓存key
     * */
    public static String getRuleActionMethodKey(String id){
        return StrUtil.format("rule:method:info:{}",id);
    }

    //========================================

    /**
     * 规则分类 缓存主key
     * */
    public static String getRuleCategoryMainKey(){
        return "rule:category:info:*";
    }

    /**
     * 规则分类 缓存key
     * */
    public static String getRuleCategoryKey(String id){
        return StrUtil.format("rule:category:info:{}",id);
    }



    //========================================

    /**
     * 规则脚本 缓存主key
     * */
    public static String getRuleScriptMainKey(){
        return "rule:script:info:*";
    }

    /**
     * 规则脚本 缓存key
     * */
    public static String getRuleScriptKey(String ruleConfigId){
        return StrUtil.format("rule:script:info:{}",ruleConfigId);
    }



    //========================================

    /**
     *  运行规则脚本 缓存主key
     * */
    public static String getRuleScriptRunMainKey(){
        return "rule:script:run";
    }

    /**
     * 运行规则脚本 缓存key
     * */
    public static String getRuleScriptRunKey_Category(String categoryId){
        return StrUtil.format("category_o_{}",categoryId);
    }


    public static String getRuleScriptRunKey_CategoryList(Set<String> categoryIds){
        return StrUtil.format("category_s_{}", StrJoinSplitUtils.join(categoryIds));
    }

    public static String getRuleScriptRunKey_CategoryChild(String categoryId){
        return StrUtil.format("category_c_{}",categoryId);
    }


    public static String getRuleScriptRunKey_RelType(String relType){
        return StrUtil.format("rel_t_{}",relType);
    }

    public static String getRuleScriptRunKey_RelId(String relType, String relId){
        return StrUtil.format("rel_o_{}_{}",relType,relId);
    }

    public static String getRuleScriptRunKey_RelIds(String relType, Set<String> relIds){
        return StrUtil.format("rel_s_{}_{}",relType, StrJoinSplitUtils.join(relIds));
    }

}
