package com.xxh.cloud.rule.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.rule.framework.modules.action.biz.RuleActionInfoBizService;
import com.xxh.cloud.rule.framework.modules.action.entity.dto.RuleActionInfoListDTO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionVO;
import com.xxh.cloud.rule.framework.modules.action.service.RuleActionInfoService;
import com.xxh.cloud.rule.framework.modules.cache.helper.RuleCacheKeysHelper;
import com.xxh.cloud.rule.framework.modules.cache.service.RuleActionCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;

@Service
public class RuleActionCacheServiceImpl extends BasicCacheServiceImpl<RuleActionVO>  implements RuleActionCacheService {

    @Autowired
    private RuleActionInfoBizService ruleActionInfoBizService;

    @Override
    public String getCacheKey(String id) {
        return RuleCacheKeysHelper.getRuleActionKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return RuleCacheKeysHelper.getRuleActionMainKey();
    }

    @Override
    public Class<RuleActionVO> getJsonClazz() {
        return RuleActionVO.class;
    }

    @Override
    public String getId(RuleActionVO entity) {
        return entity.getId();
    }

    @Override
    public RuleActionVO getById2DB(String id) {
        return ruleActionInfoBizService.info2NullById(id);
    }

    @Override
    public List<RuleActionVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        RuleActionInfoListDTO params=new RuleActionInfoListDTO();
        params.setIds(ids);
        return ruleActionInfoBizService.list(params);
    }
}
