package com.xxh.cloud.rule.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.rule.framework.modules.action.biz.RuleActionMethodInfoBizService;
import com.xxh.cloud.rule.framework.modules.action.entity.dto.RuleActionMethodListDTO;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodVO;
import com.xxh.cloud.rule.framework.modules.action.service.RuleActionMethodInfoService;
import com.xxh.cloud.rule.framework.modules.cache.helper.RuleCacheKeysHelper;
import com.xxh.cloud.rule.framework.modules.cache.service.RuleActionMethodCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;

@Service
public class RuleActionMethodCacheServiceImpl extends BasicCacheServiceImpl<RuleActionMethodVO>  implements RuleActionMethodCacheService {


    @Autowired
    private RuleActionMethodInfoBizService ruleActionMethodInfoBizService;



    @Override
    public String getCacheKey(String id) {
        return RuleCacheKeysHelper.getRuleActionMethodKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return RuleCacheKeysHelper.getRuleActionMethodMainKey();
    }

    @Override
    public Class<RuleActionMethodVO> getJsonClazz() {
        return RuleActionMethodVO.class;
    }

    @Override
    public String getId(RuleActionMethodVO entity) {
        return entity.getId();
    }

    @Override
    public RuleActionMethodVO getById2DB(String id) {
        return ruleActionMethodInfoBizService.info2NullFullById(id);
    }

    @Override
    public List<RuleActionMethodVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        RuleActionMethodListDTO params=new RuleActionMethodListDTO();
        params.setIds(ids);
        params.setFull(true);
        return ruleActionMethodInfoBizService.list(params);
    }
}
