package com.xxh.cloud.rule.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.redis.BasicCacheServiceImpl;
import com.xxh.cloud.rule.framework.modules.cache.helper.RuleCacheKeysHelper;
import com.xxh.cloud.rule.framework.modules.cache.service.RuleCategoryCacheService;
import com.xxh.cloud.rule.framework.modules.rule.biz.RuleCategoryInfoBizService;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.RuleCategoryListDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleCategoryVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;

@Service
public class RuleCategoryCacheServiceImpl  extends BasicCacheServiceImpl<RuleCategoryVO> implements RuleCategoryCacheService {

    @Autowired
    private RuleCategoryInfoBizService ruleCategoryInfoBizService;


    @Override
    public String getCacheKey(String id) {
        return RuleCacheKeysHelper.getRuleCategoryKey(id);
    }

    @Override
    public String getCacheKeyPattern() {
        return RuleCacheKeysHelper.getRuleCategoryMainKey();
    }

    @Override
    public Class<RuleCategoryVO> getJsonClazz() {
        return RuleCategoryVO.class;
    }

    @Override
    public String getId(RuleCategoryVO entity) {
        return entity.getId();
    }

    @Override
    public RuleCategoryVO getById2DB(String id) {
        return ruleCategoryInfoBizService.info2NullById(id);
    }

    @Override
    public List<RuleCategoryVO> getListByIds2DB(Collection<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return null;
        }
        RuleCategoryListDTO params=new RuleCategoryListDTO();
        params.setIds(ids);
        return ruleCategoryInfoBizService.list(params);
    }
}
