package com.xxh.cloud.rule.framework.modules.rule.biz.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.core.constant.RuleConfigTypeEnum;
import com.xxh.cloud.rule.core.entity.flow.XXFlowNodeBO;
import com.xxh.cloud.rule.framework.modules.rule.biz.RuleDecisionFlowConfigInfoBizService;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleDecisionFlowConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.DecisionFlowConfigSave2EditDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.DecisionTreeConfigSave2EditDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleDecisionFlowConfigVO;
import com.xxh.cloud.rule.framework.modules.rule.helper.RuleDecisionFlowConfigHelper;
import com.xxh.cloud.rule.framework.modules.rule.service.RuleConfigInfoService;
import com.xxh.cloud.rule.framework.modules.rule.service.RuleDecisionFlowConfigInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class RuleDecisionFlowConfigInfoBizServiceImpl implements RuleDecisionFlowConfigInfoBizService {

    @Autowired
    private RuleConfigInfoService ruleConfigInfoService;
    @Autowired
    private RuleDecisionFlowConfigInfoService ruleDecisionFlowConfigInfoService;


    @Override
    public RuleDecisionFlowConfigVO infoById(String ruleConfigId) {
        RuleConfigInfo entity= ruleConfigInfoService.getById(ruleConfigId);
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }
        if(!RuleConfigTypeEnum.RCT_Decision_Flow.getCode().equals(entity.getType())){
            throw  new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR,"不支持的规则类型不能操作");
        }
        RuleDecisionFlowConfigInfo flowConfigEntity= ruleDecisionFlowConfigInfoService.getById(ruleConfigId);
        return RuleDecisionFlowConfigHelper.getRuleDecisionFlowConfigVO(entity,flowConfigEntity);
    }

    @Override
    public void save2Update(DecisionFlowConfigSave2EditDTO params) {
        ValidatorUtils.validateEntity(params);
        this.validate(params);
        RuleConfigInfo entity= ruleConfigInfoService.getById(params.getRuleConfigId());
        if(entity==null || YN.NO.getCode().equals(entity.getRowsStatus())){
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }

        if(YN.YES.getCode().equals(entity.getStatus())){
            throw new BusinessException(BusinessBaseErrorEnum.Illegal_Operation_ERROR,"已发布不能操作");
        }

        if(!RuleConfigTypeEnum.RCT_Decision_Flow.getCode().equals(entity.getType())){
            throw  new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR,"不支持的规则类型不能操作");
        }

        RuleDecisionFlowConfigInfo flowConfigEntity= ruleDecisionFlowConfigInfoService.getById(params.getRuleConfigId());
        if(flowConfigEntity==null){
            flowConfigEntity=RuleDecisionFlowConfigHelper.getRuleDecisionFlowConfigInfo_Add(params.getRuleConfigId(),params.getConfig());
            ruleDecisionFlowConfigInfoService.save(flowConfigEntity);
        }else {
            RuleDecisionFlowConfigHelper.getRuleDecisionFlowConfigInfo_Edit(flowConfigEntity,params.getConfig());
            ruleDecisionFlowConfigInfoService.updateById(flowConfigEntity);
        }
    }



    private void validate(DecisionFlowConfigSave2EditDTO params){
        //todo:
    }

}
