package com.xxh.cloud.rule.framework.modules.rule.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 规则配置备份表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_rule_config_back_up_info")
public class RuleConfigBackUpInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 规则配置ID
     */
     @ApiModelProperty(value = "规则配置ID")
      private String ruleConfigId;

    /**
     * 规则配置版本号
     */
     @ApiModelProperty(value = "规则配置版本号")
      private Integer ruleVersionNo;

    /**
     * 规则分类id
     */
     @ApiModelProperty(value = "规则分类id")
      private String categoryId;

    /**
     * 规则名称
     */
     @ApiModelProperty(value = "规则名称")
      private String name;

    /**
     * 规则分类
     */
     @ApiModelProperty(value = "规则分类")
      private String type;

    /**
     * 引擎业务分类
     */
     @ApiModelProperty(value = "引擎业务分类")
      private String bizType;

    /**
     * 触发事件ID
     */
     @ApiModelProperty(value = "触发事件ID")
      private String eventId;

    /**
     * 规则关联业务分类
     */
     @ApiModelProperty(value = "规则关联业务分类")
      private String relType;

    /**
     * 关联业务二级分类
     */
     @ApiModelProperty(value = "关联业务二级分类")
      private String relTwoType;

    /**
     * 规则关联业务ID
     */
     @ApiModelProperty(value = "规则关联业务ID")
      private String relId;

    /**
     * 规则来源
     */
     @ApiModelProperty(value = "规则来源")
      private String source;

    /**
     * 备份备注
     */
     @ApiModelProperty(value = "备份备注")
      private String backUpRemark;

    /**
     * 配置
     */
     @ApiModelProperty(value = "配置")
      private String config;



}
