package com.xxh.cloud.rule.framework.modules.rule.entity.dos;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 规则配置表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_rule_config_info")
public class RuleConfigInfo extends BaseEntity {





    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;


    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "分类id")
    private String categoryId;


    @ApiModelProperty(value = "版本号")
    private Integer versionNo;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "引擎系统分类")
    private String type;


    @ApiModelProperty(value = "引擎业务分类")
    private String bizType;

    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    @ApiModelProperty(value = "关联业务二级分类")
    private String relTwoType;

    @ApiModelProperty(value = "触发事件ID")
    private String eventId;


    @ApiModelProperty(value = "关联业务ID")
    private String relId;


    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 顺序
     */
    @ApiModelProperty(value = "顺序")
    private Integer orders;


    /**
     * 规则来源
     */
    @ApiModelProperty(value = "规则来源")
    private String source;

    @ApiModelProperty(value = "扩展字段1")
    private String extendOne;

    @ApiModelProperty(value = "扩展字段2")
    private String extendTwo;

    @ApiModelProperty(value = "扩展字段3")
    private String extendThree;


    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
    @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
    private String rowsStatus;


}
