package com.xxh.cloud.rule.framework.modules.rule.entity.dto;

import com.xxh.cloud.framework.common.constant.Constant;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.entity.base.NodeMethod;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;

@Getter
@Setter
public class DecisionTreeConfigItem {

        @ApiModelProperty(value = "节点编号",required = true)
        @NotEmpty(message = "节点编号不能为空")
        private String id;

        @ApiModelProperty(value = "节点分类(RuleNodeTypeEnum)",required = true)
        @NotEmpty(message = "节点分类不能为空")
        private String nodesType;


        @ApiModelProperty(value = "节点名称",required = true)
        @NotEmpty(message = "节点名称不能为空")
        private String nodesName;


        @ApiModelProperty(value = "前节点编号",required = true)
        @NotEmpty(message = "前节点编号不能为空")
        private String pid= Constant.RootParentNodeId;


        @ApiModelProperty(value = "条件节点配置")
        private NodeCondition nodesCondition;


        @ApiModelProperty(value = "动作方法节点配置")
        private NodeMethod nodesAction;



}
