package com.xxh.cloud.rule.framework.modules.rule.entity.dto;

import com.xxh.cloud.rule.core.constant.RuleConfigTypeEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotEmpty;
import java.util.List;

@Getter
@Setter
public class RuleConfigInfoSaveDTO {



        @ApiModelProperty(value = "id")
        private String id;

        @ApiModelProperty(value = "项目编号")
        private String projectCode;

        @ApiModelProperty(value = "名称",required = true)
        @NotEmpty(message = "名称不能为空")
        private String name;

        @ApiModelProperty(value = "分类ID")
        private String categoryId;

        @ApiModelProperty(value = "规则分类(RuleConfigTypeEnum)",required = true)
        @NotEmpty(message = "规则分类不能为空")
        private String type= RuleConfigTypeEnum.RCT_Decision_Flow.getCode();

        @ApiModelProperty(value = "引擎业务分类(RuleConfigBizTypeEnum)",required = true)
        @NotEmpty(message = "引擎业务分类不能为空")
        private String bizType;



        @ApiModelProperty(value = "触发事件ID")
        private String eventId;

        @ApiModelProperty(value = "关联业务分类[定义]")
        private String relType;

        @ApiModelProperty(value = "关联业务二级分类[定义]")
        private String relTwoType;

        @ApiModelProperty(value = "业务ID")
        private List<String> relId;

        @ApiModelProperty(value = "备注")
        private String remark;


        @ApiModelProperty(value = "顺序")
        private Integer orders=1;

        @ApiModelProperty(value = "来源")
        private String source;

        @ApiModelProperty(value = "扩展字段1")
        private String extendOne;

        @ApiModelProperty(value = "扩展字段2")
        private String extendTwo;

        @ApiModelProperty(value = "扩展字段3")
        private String extendThree;





}
