package com.xxh.cloud.rule.framework.modules.rule.entity.vos;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.*;

@Getter
@Setter
public class RuleConfigVO {


    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "项目编号")
    private String projectCode;


    @ApiModelProperty(value = "分类id")
    private String categoryId;


    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "分类")
    private String type;

    @ApiModelProperty(value = "引擎业务分类")
    private String bizType;


    @ApiModelProperty(value = "关联业务分类")
    private String relType;

    @ApiModelProperty(value = "关联业务二级分类")
    private String relTwoType;

    @ApiModelProperty(value = "关联业务ID")
    private List<String> relId;

    @ApiModelProperty(value = "触发事件ID")
    private String eventId;

    @ApiModelProperty(value = "状态")
    private String status;

    @ApiModelProperty(value = "备注")
    private String remark;


    @ApiModelProperty(value = "顺序")
    private Integer orders;


    @ApiModelProperty(value = "规则来源")
    private String source;


    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("更新者")
    private String updater;

    @ApiModelProperty("更新时间")
    private Date updateDate;


    @ApiModelProperty(value = "扩展字段1")
    private String extendOne;

    @ApiModelProperty(value = "扩展字段2")
    private String extendTwo;

    @ApiModelProperty(value = "扩展字段3")
    private String extendThree;


    //================================
    @ApiModelProperty(value = "分类名称")
    private String categoryName;

    @ApiModelProperty(value = "创建用户名")
    private String creatorUserName;

    @ApiModelProperty(value = "修改用户名")
    private String updaterUserName;

    @ApiModelProperty(value = "创建用户真实名称")
    private String creatorRealName;

    @ApiModelProperty(value = "修改用户真实名称")
    private String updaterRealName;


    @ApiModelProperty(value = "触发事件名称")
    private String eventName;

    @ApiModelProperty(value = "关联业务ID")
    private List<Map<String,String>> relList;

    public void addRelItem(Map<String,String> item){
        if(this.relList==null){
            this.relList=new ArrayList<>();
        }
        if(item!=null){
            this.relList.add(item);
        }
    }

    public void addRelItem(String code,String name){
        if(StrUtil.isNotEmpty(code) && StrUtil.isNotEmpty(name)){
            Map<String,String> item=new HashMap<>();
            item.put("code",code);
            item.put("name",name);
            this.addRelItem(item);
        }
    }

}
