package com.xxh.cloud.rule.framework.modules.rule.helper;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.tree.TreeUtils;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.entity.base.NodeMethod;
import com.xxh.cloud.rule.framework.modules.action.entity.vos.RuleActionMethodParameterVO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleDecisionTreeNodeConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.DecisionFlowConfigSave2EditDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleDecisionTreeConfigVO;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class DecisionTreeNodeConfigConvert {


    public static List<RuleDecisionTreeConfigVO> getTree(List<RuleDecisionTreeNodeConfigInfo> list, Map<String, RuleActionMethodParameterVO> ampMap){
        List<RuleDecisionTreeConfigVO> dataList=new ArrayList<>();

        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                dataList.add(getRuleActionMethodParameterModel(item,ampMap));
            });
        }

        List<RuleDecisionTreeConfigVO> data=  TreeUtils.build(dataList);
        return data;
    }


    public static RuleDecisionTreeConfigVO getRuleActionMethodParameterModel(RuleDecisionTreeNodeConfigInfo entity,
                                                                             Map<String, RuleActionMethodParameterVO> methodParameterMap){
        if(entity==null){
            return null;
        }
        RuleDecisionTreeConfigVO data=new RuleDecisionTreeConfigVO();
        data.setId(entity.getId());
        data.setRuleConfigId(entity.getRuleConfigId());
        data.setPid(entity.getPid());
        data.setNodesType(entity.getNodeType());
        data.setNodesName(entity.getNodeName());
        if(StrUtil.isNotEmpty(entity.getNodeCondition())){
            data.setNodesCondition(JSON.parseObject(entity.getNodeCondition(), NodeCondition.class));
        }
        if(StrUtil.isNotEmpty(entity.getNodeAction())){
            data.setNodesAction(JSON.parseObject(entity.getNodeAction(), NodeMethod.class));
        }
        return data;
    }


    public static void main(String[] args) {
        String str="{\"ruleConfigId\":\"1694601542278078464\",\"config\":{\"type\":\"start\",\"content\":\"触发条件\",\"nodeId\":\"dttnSh1\",\"prevId\":null,\"isInterflow\":null,\"conditionType\":\"condition\",\"properties\":{\"title\":\"开始节点\",\"ruleType\":\"condition\",\"conditionExeType\":null,\"conditions\":null,\"action\":{\"actionId\":null,\"actionName\":null,\"methodCode\":null,\"methodName\":null,\"params\":null,\"exeType\":\"all\",\"exeRatio\":0,\"auto\":null,\"advanceRatio\":0,\"executorType\":null,\"executorIds\":null,\"checkWay\":null,\"checkRatio\":0}},\"childNode\":{\"type\":\"approver\",\"content\":\"请设置动作节点\",\"properties\":{\"title\":\"动作节点\"},\"nodeId\":\"uKHpSh1\",\"prevId\":\"dttnSh1\",\"childNode\":{\"type\":\"approver\",\"content\":\"请设置动作节点\",\"nodeId\":\"zutnSh1\",\"prevId\":\"uKHpSh1\",\"isInterflow\":null,\"conditionType\":null,\"properties\":{\"title\":\"动作节点\",\"ruleType\":\"action\",\"conditionExeType\":null,\"conditions\":null,\"action\":{\"actionId\":\"com1\",\"actionName\":\"\",\"methodCode\":\"add\",\"methodName\":\"患者新增检验项目\",\"params\":[{\"paramCode\":\"user_no\",\"paramName\":\"患者编号\",\"paramType\":\"\",\"ovtype\":\"variable\",\"ovtwoType\":\"mds_operation\",\"ovo\":{\"memo\":\"\",\"val\":\"00.0300\"},\"ovs\":[]},{\"paramCode\":\"project_no\",\"paramName\":\"项目编号\",\"paramType\":\"\",\"ovtype\":\"variable\",\"ovtwoType\":\"mds_therapy\",\"ovo\":{\"memo\":\"\",\"val\":\"3\"},\"ovs\":[]}],\"exeType\":\"all\",\"exeRatio\":0,\"auto\":\"\",\"advanceRatio\":0,\"executorType\":\"\",\"executorIds\":[],\"checkWay\":\"\",\"checkRatio\":0}},\"childNode\":null,\"conditionNodes\":null}},\"conditionNodes\":[{\"type\":\"condition\",\"content\":\"请设置条件\",\"properties\":{\"title\":\"条件\",\"conditions\":{\"type\":\"property\",\"relation\":\"\",\"children\":null,\"property\":{\"mdCode\":\"LTI_CH00001\",\"mdName\":\"葡萄糖[120分钟]\",\"mdTypeCode\":\"\",\"mdTypeName\":\"\",\"dateType\":\"standard\",\"deptCodes\":[],\"deptCode\":\"\",\"deptName\":\"\",\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"lxtjNum\":\"\",\"rytjNum\":\"\",\"op\":\"rise\",\"opChild\":\"\",\"oval\":\"10\",\"ovalMany\":[],\"ovalTwo\":\"\",\"sampleCode\":\"\",\"sampleName\":\"\",\"ynType\":\"Y\",\"restriction\":\"N\",\"mdType\":\"laboratory_project\",\"rawType\":\"d\"},\"id\":\"kFKpSh1\"},\"ruleType\":\"condition\",\"conditionExeType\":\"\",\"initiator\":null,\"priority\":0,\"condition\":{\"type\":\"property\",\"relation\":\"\",\"children\":null,\"property\":{\"mdCode\":\"LTI_CH00001\",\"mdName\":\"葡萄糖[120分钟]\",\"mdTypeCode\":\"\",\"mdTypeName\":\"\",\"dateType\":\"standard\",\"deptCodes\":[],\"deptCode\":\"\",\"deptName\":\"\",\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"lxtjNum\":\"\",\"rytjNum\":\"\",\"op\":\"rise\",\"opChild\":\"\",\"oval\":\"10\",\"ovalMany\":[],\"ovalTwo\":\"\",\"sampleCode\":\"\",\"sampleName\":\"\",\"ynType\":\"Y\",\"restriction\":\"N\",\"mdType\":\"laboratory_project\",\"rawType\":\"d\"},\"id\":\"kFKpSh1\"}},\"nodeId\":\"zsHpSh1\",\"prevId\":\"dttnSh1\"},{\"type\":\"condition\",\"content\":\"请设置条件\",\"properties\":{\"title\":\"条件\",\"conditions\":[],\"ruleType\":\"condition\",\"conditionExeType\":\"\",\"initiator\":null,\"priority\":1},\"nodeId\":\"owHpSh1\",\"prevId\":\"dttnSh1\"}]}}";

//        System.out.println(str);
        DecisionFlowConfigSave2EditDTO entity= JSON.parseObject(str, DecisionFlowConfigSave2EditDTO.class);
    }


}
