package com.xxh.cloud.rule.framework.modules.rule.helper;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleDecisionTreeNodeConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.DecisionTreeConfigItem;

import java.util.ArrayList;
import java.util.List;

public class DecisionTreeNodeConfigHelper {


    public static List<RuleDecisionTreeNodeConfigInfo> getRuleDecisionTreeNodeConfigInfoList(RuleConfigInfo entity, List<DecisionTreeConfigItem> nodes){
        List<RuleDecisionTreeNodeConfigInfo> data=new ArrayList<>();
        for(DecisionTreeConfigItem node:nodes){
            data.add(DecisionTreeNodeConfigHelper.getRuleDecisionTreeNodeConfigInfo(entity,node));
        }
        return data;
    }



    public static RuleDecisionTreeNodeConfigInfo getRuleDecisionTreeNodeConfigInfo(RuleConfigInfo entity, DecisionTreeConfigItem item){
        RuleDecisionTreeNodeConfigInfo data=new RuleDecisionTreeNodeConfigInfo();
        data.setId(item.getId());
        data.setRuleConfigId(entity.getId());
        data.setNodeType(item.getNodesType());
        data.setNodeName(item.getNodesName());
        data.setPid(item.getPid());
        if(item.getNodesCondition()!=null){
            data.setNodeCondition(JSON.toJSONString(item.getNodesCondition()));
        }
        if(item.getNodesAction()!=null){
            data.setNodeAction(JSON.toJSONString(item.getNodesAction()));
        }
        return data;
    }




}
