package com.xxh.cloud.rule.framework.modules.rule.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleCategoryInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleCategoryVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class RuleCategoryHelper {



    public static String getRuleCategoryId(){
        return IdUtil.getSnowflake(6,7).nextIdStr();
    }

    public static RuleCategoryVO getRuleCategoryVO(RuleCategoryInfo entity){
        RuleCategoryVO data=new RuleCategoryVO();
        BeanUtil.copyProperties(entity,data);
        return data;
    }

    public static RuleCategoryVO getRuleCategoryVO(RuleCategoryInfo entity,Map<String, AdminUserBO> userMap){
        RuleCategoryVO data=getRuleCategoryVO(entity);

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }

        return data;
    }


}
