package com.xxh.cloud.rule.framework.modules.rule.helper;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardDiseaseBO;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardEventBO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleCategoryVO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleConfigVO;
import com.xxh.cloud.user.client.api.bean.bos.AdminUserBO;

import java.util.Map;

public class RuleConfigConvert {



    public static String getRuleConfigId(){
        return IdUtil.getSnowflake(6,8).nextIdStr();
    }

    public static RuleConfigVO getRuleConfigVO(RuleConfigInfo entity){
        RuleConfigVO data=new RuleConfigVO();
        BeanUtil.copyProperties(entity,data,"relId");
        if(StrUtil.isNotEmpty(entity.getRelId())){
            data.setRelId(StrJoinSplitUtils.split2List(entity.getRelId()));
        }
        return data;
    }

    public static RuleConfigVO getRuleConfigVO(RuleConfigInfo entity,
                                               Map<String, RuleCategoryVO> categoryMap,
                                               Map<String, AdminUserBO> userMap,
                                               Map<String, StandardEventBO> eventMap,
                                               Map<String, StandardDiseaseBO> diseaseMap){

        RuleConfigVO data=getRuleConfigVO(entity);

        if(MapUtil.isNotEmpty(userMap)){
            if(StrUtil.isNotEmpty(data.getCreator())){
                AdminUserBO user= userMap.get(data.getCreator());
                if(user!=null){
                    data.setCreatorUserName(user.getUserName());
                    data.setCreatorRealName(user.getRealName());
                }
            }
            if(StrUtil.isNotEmpty(data.getUpdater())){
                AdminUserBO user= userMap.get(data.getUpdater());
                if(user!=null){
                    data.setUpdaterUserName(user.getUserName());
                    data.setUpdaterRealName(user.getRealName());
                }
            }
        }

        if(MapUtil.isNotEmpty(categoryMap) && StrUtil.isNotEmpty(data.getCategoryId())){
            RuleCategoryVO category=categoryMap.get(data.getCategoryId());
            if(category!=null){
                data.setCategoryName(category.getName());
            }
        }

        if(MapUtil.isNotEmpty(eventMap) && StrUtil.isNotEmpty(data.getEventId())){
            StandardEventBO event = eventMap.get(data.getEventId());
            if(event!=null){
                data.setEventName(event.getName());
            }
        }

        if(MapUtil.isNotEmpty(diseaseMap) && CollUtil.isNotEmpty(data.getRelId())){
            for(String relId:data.getRelId()){
                StandardDiseaseBO disease = diseaseMap.get(relId);
                if(disease!=null){
                    data.addRelItem(disease.getId(),disease.getName());
                }
            }
        }
        return data;
    }


}
