package com.xxh.cloud.rule.framework.modules.rule.helper;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.rule.core.entity.flow.XXFlowNodeBO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.dos.RuleDecisionFlowConfigInfo;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleDecisionFlowConfigVO;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

public class RuleDecisionFlowConfigHelper {

    public static RuleDecisionFlowConfigVO getRuleDecisionFlowConfigVO(RuleConfigInfo entity, RuleDecisionFlowConfigInfo flowConfigEntity){
        RuleDecisionFlowConfigVO data=new RuleDecisionFlowConfigVO();
        data.setId(entity.getId());
        data.setCategoryId(entity.getCategoryId());
        data.setName(entity.getName());
        data.setType(entity.getType());
        data.setStatus(entity.getStatus());
        data.setSource(entity.getSource());

        if(flowConfigEntity!=null){
            data.setCreator(flowConfigEntity.getCreator());
            data.setCreateDate(flowConfigEntity.getCreateDate());
            data.setUpdater(flowConfigEntity.getUpdater());
            data.setUpdateDate(flowConfigEntity.getUpdateDate());
            if(StrUtil.isNotEmpty(flowConfigEntity.getContent())){
                data.setConfig(JSON.parseObject(flowConfigEntity.getContent(),XXFlowNodeBO.class));
            }
        }

        return data;
    }


    public static RuleDecisionFlowConfigInfo getRuleDecisionFlowConfigInfo_Add(String id,XXFlowNodeBO config){
        RuleDecisionFlowConfigInfo flowConfigEntity=new RuleDecisionFlowConfigInfo();
        flowConfigEntity.setId(id);
        flowConfigEntity.setRuleConfigId(id);
        flowConfigEntity.setContent(JSON.toJSONString(config));
        return flowConfigEntity;
    }

    public static void getRuleDecisionFlowConfigInfo_Edit(RuleDecisionFlowConfigInfo flowConfigEntity,XXFlowNodeBO config){
        flowConfigEntity.setContent(JSON.toJSONString(config));
    }

    /**
     *
     * */
    private static String en(){
        return null;
    }

    /**
     *
     * */
    private static String de(){
        return null;
    }



}
