package com.xxh.cloud.rule.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.framework.modules.rule.biz.RuleDecisionFlowConfigInfoBizService;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.DecisionFlowConfigSave2EditDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.RuleConfigInfoByIdDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleDecisionFlowConfigVO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleDecisionTreeConfigVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Log4j2
@RestController
@RequestMapping("/sys/rule/flowConfig")
@Api(tags = "运营端,决策流规则配置管理")
public class RuleConfigFlowManagerController {

    @Autowired
    private RuleDecisionFlowConfigInfoBizService ruleDecisionFlowConfigInfoBizService;


    @SaCheckPermission("sys:rule:flowConfig:info")
    @PostMapping("/info")
    @ApiOperation(value = "决策流配置明细", response = RuleDecisionFlowConfigVO.class)
    public Result<RuleDecisionFlowConfigVO> info(@RequestBody RuleConfigInfoByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        RuleDecisionFlowConfigVO data=ruleDecisionFlowConfigInfoBizService.infoById(params.getId());
        return new Result<RuleDecisionFlowConfigVO>().ok(data);
    }


    @SaCheckPermission("sys:rule:flowConfig:save2Update")
    @PostMapping("/save2Update")
    @ApiOperation(value = "新增和修改决策流", response = String.class)
    public Result<String> save2Update(@RequestBody DecisionFlowConfigSave2EditDTO params) {
        ValidatorUtils.validateEntity(params);
        ruleDecisionFlowConfigInfoBizService.save2Update(params);
        return new Result<String>().ok("ok");
    }




}
