package com.xxh.cloud.rule.sys.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.framework.modules.rule.biz.RuleConfigBackUpInfoBizService;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.RuleConfigBackUpAddDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.RuleConfigBackUpGetDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.RuleConfigBackUpListDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleConfigBackUpVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Log4j2
@RestController
@RequestMapping("/sys/rule/backupConfig")
@Api(tags = "运营端,规则配置备份管理")
public class RuleConfigInfoBackUpManagerController {



    @Autowired
    private RuleConfigBackUpInfoBizService ruleConfigBackUpInfoBizService;


    @SaCheckPermission("sys:rule:backupConfig:list")
    @PostMapping("/list")
    @ApiOperation(value = "列表", response = RuleConfigBackUpVO.class)
    public Result<List<RuleConfigBackUpVO>> list(@RequestBody RuleConfigBackUpListDTO params) {
        ValidatorUtils.validateEntity(params);
        List<RuleConfigBackUpVO> data= ruleConfigBackUpInfoBizService.list(params);
        return new Result<List<RuleConfigBackUpVO>>().ok(data);
    }


//    @SaCheckPermission("sys:rule:backupConfig:backUp")
    @PostMapping("/backUp")
    @ApiOperation(value = "备份", response = RuleConfigBackUpVO.class)
    public Result<RuleConfigBackUpVO> backUp(@RequestBody RuleConfigBackUpAddDTO params) {
        ValidatorUtils.validateEntity(params);
        RuleConfigBackUpVO data= ruleConfigBackUpInfoBizService.backUp(params);
        return new Result<RuleConfigBackUpVO>().ok(data);
    }


    @SaCheckPermission("sys:rule:backupConfig:get")
    @PostMapping("/get")
    @ApiOperation(value = "备份明细", response = RuleConfigBackUpVO.class)
    public Result<RuleConfigBackUpVO> get(@RequestBody RuleConfigBackUpGetDTO params) {
        ValidatorUtils.validateEntity(params);
        RuleConfigBackUpVO data= ruleConfigBackUpInfoBizService.infoById(params.getId());
        return new Result<RuleConfigBackUpVO>().ok(data);
    }

    @SaCheckPermission("sys:rule:backupConfig:redo")
    @PostMapping("/redo")
    @ApiOperation(value = "备份还原", response = RuleConfigBackUpVO.class)
    public Result<String> redo(@RequestBody RuleConfigBackUpGetDTO params) {
        ValidatorUtils.validateEntity(params);
        //todo:
        return new Result<String>().ok(null);
    }



}
