package com.xxh.cloud.rule.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.framework.modules.rule.biz.RuleDecisionTreeConfigInfoBizService;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.DecisionTreeConfigSave2EditDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.dto.RuleConfigInfoByIdDTO;
import com.xxh.cloud.rule.framework.modules.rule.entity.vos.RuleDecisionTreeConfigVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

//@SaCheckPermission("sys:rule:treeConfig")
@Log4j2
@RestController
@RequestMapping("/sys/rule/treeConfig")
@Api(tags = "运营端,决策树规则配置管理")
public class RuleConfigTreeManagerController {

    @Autowired
    private RuleDecisionTreeConfigInfoBizService ruleDecisionTreeNodeConfigInfoService;



    @SaCheckPermission("sys:rule:treeConfig:tree")
    @PostMapping("/tree")
    @ApiOperation(value = "树", response = RuleDecisionTreeConfigVO.class)
    public Result<List<RuleDecisionTreeConfigVO>> tree(@RequestBody RuleConfigInfoByIdDTO params) {
        ValidatorUtils.validateEntity(params);
        List<RuleDecisionTreeConfigVO> data= ruleDecisionTreeNodeConfigInfoService.tree(params.getId());
        return new Result<List<RuleDecisionTreeConfigVO>>().ok(data);
    }


    @SaCheckPermission("sys:rule:treeConfig:save2Update")
    @PostMapping("/save")
    @ApiOperation(value = "新增和修改", response = String.class)
    public Result<String> save2Update(@RequestBody DecisionTreeConfigSave2EditDTO params) {
        ValidatorUtils.validateEntity(params);
        ruleDecisionTreeNodeConfigInfoService.save2Update(params);
        return new Result<String>().ok("ok");
    }




}
