package com.xxh.cloud.rule.execute.inference.client.api;

import com.xxh.cloud.rule.execute.inference.client.bean.bos.*;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.*;

import java.util.List;

public interface RuleExecute2WorkFlowClientService {




    /**
     * 查询流程节点任务结果
     * */
    public WorkFlowNodeTaskResultBO getWorkFlowNodeTaskResult(String nodeTaskId);

    /**
     * 待执行的自动执行节点
     * @param date: yyyyMMdd
     * */
    public List<FlowEventTriggerNodeTaskResultBO> getTriggerNodeTaskByDay(String date);


    /**
     * 处理定时节点任务，超过截止时间未处理的任务
     * */
    public void processTriggerNodeTask2Timeout();

    /**
     * 执行所有流程
     * */
    public WorkFlowExecuteProcessAllResultBO executeWorkFlowAll(WorkFlowExecuteAllDTO params);


    /**
     * 开始执行流程
     * */
    public List<WorkFlowExecuteResultBO> startExecute(WorkFlowExecuteByRuleDTO params);


    /**
     * 处理流程节点任务
     * */
    public WorkFlowExecuteProcessResultBO processNode(WorkFlowNodeTaskExecuteDTO params);


    /**
     * 处理定时任务
     * */
    public List<WorkFlowExecuteResultBO> processTriggerNode(WorkFlowTriggerNodeTaskExecuteDTO params);




    

}
