package com.xxh.cloud.rule.core.constant;

/**
 * 条件操作符(规则)
 * */
public enum RuleOpEnum {

    EQ("eq","等于"),
    NE("ne","不等于"),
    GT("gt","大于"),
    GE("ge","大于等于"),
    LT("lt","小于"),
    LE("le","小于等于"),

    Between("between","开区间"), //两个数字值, 不包含两点 （）
    BetweenClosedLeft("between_cl","左闭区间"),//两个数字值,
    BetweenClosedRight("between_cr","右闭区间"), //两个数字值,
    BetweenClosed("between_c","闭区间"),//两个数字值, 包含两点  []
    BetweenNot("between_not","不在区间"), //两个数字值, 两点也不在

    IsNull("is_null","空"),
    IsNotNull("is_not_null","不为空"),

    In("in","存在(中)(任意一个)"), //多值
//    In_Num("in_num","存在(中)(任意指定个数)"), //值(个数,多值)

    NotIn("not_in"," 不存在(中)(所有)"), //多值
//    NotIn_Num("not_in_num"," 不存在(中)(任意指定个数)"), //值(个数,多值)

    Like("like","(中)包含"), //单值
    LikeAny("like_any","(中)包含任意一个"), //多值
    LikeAll("like_all","(中)包含所有"), //多值
    LikeNum("like_num","(中)包含指定个数"), //值(个数,多值)


    NotLike("not_like","(中)不包含"), //单值
    NotLikeAny("not_like_any","(中)不包含任意一个"), //多值
    NotLikeAll("not_like_all","(中)不包含所有"), //多值
    NotLikeNum("not_like_num","(中)不包含指定个数") //值(个数,多值)

    ;

    private String code;
    private String msg;
    private RuleOpEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }
    public String getCode() {
        return code;
    }
    public String getMsg() {
        return msg;
    }







}
