package com.xxh.cloud.rule.core.context;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.IdUtil;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteDTO;
import com.xxh.cloud.rule.basic.api.bean.dto.WorkFlowNodeExecuteDTO;
import com.xxh.cloud.rule.core.executor.condition.context.ConditionContextItemBO;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

@Getter
@Setter
public class XXRuleNodeLogBean {


    private String id;

    private String type;

    private String nodeId;

    private String nodeName;

    private String nodeType;

    private String nodeRuleType;

    private Date start;

    private Date end;

    private long timeNum;

    private boolean flag;

    private List<ConditionContextItemBO> conditionList;

    private MethodExecuteDTO methodResult;

    private WorkFlowNodeExecuteDTO workFlowResult;


    public XXRuleNodeLogBean(String nodeId,String nodeName,String nodeType,String nodeRuleType,Date start,Date end,List<ConditionContextItemBO> conditionList,boolean flag){
        this.id=IdUtil.getSnowflake(1,1).nextIdStr();
        this.type="条件";
        this.nodeId=nodeId;
        this.nodeName=nodeName;
        this.nodeType=nodeType;
        this.nodeRuleType=nodeRuleType;
        this.start=start;
        this.end=end;
        this.flag=flag;
        this.conditionList=conditionList;
    }



    public XXRuleNodeLogBean(String nodeId,String nodeName,String nodeType,String nodeRuleType,Date start,Date end, WorkFlowNodeExecuteDTO workFlowResult,boolean flag){
        this.id=IdUtil.getSnowflake(1,1).nextIdStr();
        this.type="工作流执行动作";
        this.nodeId=nodeId;
        this.nodeName=nodeName;
        this.nodeType=nodeType;
        this.nodeRuleType=nodeRuleType;
        this.start=start;
        this.end=end;
        this.workFlowResult=workFlowResult;
        this.flag=flag;
    }

    public XXRuleNodeLogBean(String nodeId,String nodeName,String nodeType,String nodeRuleType,Date start,Date end, MethodExecuteDTO methodResult){
        this.id=IdUtil.getSnowflake(1,1).nextIdStr();
        this.type="推理流执行动作";
        this.nodeId=nodeId;
        this.nodeName=nodeName;
        this.nodeType=nodeType;
        this.nodeRuleType=nodeRuleType;
        this.start=start;
        this.end=end;
        this.methodResult=methodResult;
        this.flag=true;
    }



    public XXRuleNodeLogBean(){

    }


//    public static void main(String[] args) {
//        //new  Date().getTime();
//
//        System.out.println(IdUtil.getSnowflake(1,1).nextIdStr());
//        System.out.println(IdUtil.getSnowflake(1,1).nextIdStr());
//        System.out.println(IdUtil.getSnowflake(1,1).nextIdStr());
//
//        ThreadUtil.safeSleep(1000);
//        System.out.println("============================");
//        System.out.println(IdUtil.getSnowflake(1,1).nextIdStr());
//        System.out.println(IdUtil.getSnowflake(1,1).nextIdStr());
//        System.out.println(IdUtil.getSnowflake(1,1).nextIdStr());
//    }

}
