package com.xxh.cloud.rule.core.context;

import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

/**
 * 节点引用变量定义
 * */
@Getter
@Setter
public class XXRuleVariable2NodeBO {


    /**
     * 节点ID
     * */
    private String nodeId;

    /**
     * 节点分类
     * */
    private String nodeType;

    /**
     * 节点规则分类
     * */
    private String nodeRuleType;


    /**
     * 节点参数列表
     * */
    private List<XXRuleVariableBO> vars;


    public XXRuleVariable2NodeBO(){

    }


    public XXRuleVariable2NodeBO(String nodeId, String nodeType, String nodeRuleType){
        this.nodeId=nodeId;
        this.nodeType=nodeType;
        this.nodeRuleType=nodeRuleType;
    }


    public void addVar(XXRuleVariableBO var){
        if(this.vars==null){
            this.vars=new ArrayList<>();
        }
        if(var!=null){
            this.vars.add(var);
        }
    }

    /**
     * 条件属性:新增变量
     * */
    public void addVarByConditon(String contionOneName, String contionOneCode,String paramType, String paramCode, String paramName){
        XXRuleVariableBO var=new XXRuleVariableBO("",contionOneName,contionOneCode,paramType,paramCode,paramName);
        this.addVar(var);
    }


    /**
     * 方法(条件方法、执行方法):新增变量
     * */
    public void addVarByMethod(String actionId, String methodCode, String paramType, String paramCode, String paramName){
        XXRuleVariableBO var=new XXRuleVariableBO(actionId,methodCode,paramType,paramCode,paramName);
        this.addVar(var);
    }




}
