package com.xxh.cloud.rule.core.entity.base;

import com.xxh.cloud.rule.core.constant.ConditionNodeTypeEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

/**
 * 条件节点
 * */
@Getter
@Setter
public class NodeCondition {

    /**
     * 节点ID
     * */
    private String id;


    /**
     * 节点分类  - ConditionNodeTypeEnum
     * */
    @ApiModelProperty(value = "节点分类  - ConditionNodeTypeEnum")
    private String type;
    /**
     *  关系节点(数干节点) - 关系类型 - ConditionRelationTypeEnum
     * */
    @ApiModelProperty(value = "关系节点(数干节点) - 关系类型 - ConditionRelationTypeEnum")
    private String relation ;

    /**
     * 关系节点(数干节点) - 子关系条件
     * */
    @ApiModelProperty(value = "关系节点(数干节点) - 子关系条件")
    private List<NodeCondition> children;


//    /**
//     * 基础属性条件(叶子节点)
//     * */
//    @ApiModelProperty(value = "属性条件(叶子节点)")
//    private PropertyConditionBaseBean property;

    /**
     * 健康属性条件(叶子节点)
     * */
    @ApiModelProperty(value = "属性条件(叶子节点)")
    private PropertyConditionHealthBean property;

    /**
     * 方法条件(叶子节点)
     * */
    @ApiModelProperty(value = "方法条件(叶子节点)")
    private MethodBaseBean method;


    public NodeCondition(String type){
        this.type=type;
    }

    public NodeCondition(ConditionNodeTypeEnum type){
        this.type=type.getCode();
    }

    public NodeCondition(){

    }

    public void addChildren(NodeCondition item){
        if(this.children==null){
            this.children=new ArrayList<>();
        }
        if(item!=null){
            this.children.add(item);
        }
    }


    /**
     * 校验
     * */
    public boolean validate(){
        return true;
    }


}
