package com.xxh.cloud.rule.core.entity.base;

import com.xxh.cloud.rule.core.constant.NodeCheckWay;
import com.xxh.cloud.rule.core.constant.NodeTriggerTypeEnum;
import com.xxh.cloud.rule.core.constant.XXActionNodeInterExeTypeEnum;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * 方法节点
 * */
@Getter
@Setter
public class NodeMethod extends MethodBaseBean {


    @ApiModelProperty(value = "分流动作执行方式: 每次都执行、随机分配执行[XXActionNodeInterExeTypeEnum]")
    private String exeType= XXActionNodeInterExeTypeEnum.ANE_All.getCode();

    @ApiModelProperty(value = "分流动作-随机分配执行比例")
    private int exeRatio=0;

    //todo: del
    @ApiModelProperty(value = "是否自动执行(YN)")
    private String auto;

    @ApiModelProperty(value = "进度设置")
    private int advanceRatio;

    @ApiModelProperty(value = "执行人/审批人分类[指定人员、指定岗位、指定部门主管、发起人、表单变量](NodeExecutorType)")
    private String executorType;

    @ApiModelProperty(value = "执行对象")
    private List<ValueBean> executorIds;

    @ApiModelProperty(value = "审批方式[或签、会签](NodeCheckWay)")
    private String checkWay;

    @ApiModelProperty(value = "会签比例")
    private int checkRatio;

    //定时触发
    @ApiModelProperty(value = "是否定时触发")
    private String cronTriggerYN;


    @ApiModelProperty(value = "开始时间:审核后数量")
    private int triggerStartNum;

    @ApiModelProperty(value = "截止时间:审核后数量")
    private int triggerEndNum;

    @ApiModelProperty(value = "截止时间:审核后数量单位[DateTimeUnitTypeEnum]")
    private String triggerEndUnit;

    @ApiModelProperty(value = "触发时间类型[仅触发一次，循环触发][NodeTriggerTypeEnum]")
    private String triggerType;

    @ApiModelProperty(value = "循环触发数量")
    private int triggerLoopNum;

    @ApiModelProperty(value = "循环触发数量单位[DateTimeUnitTypeEnum]")
    private String triggerLoopUnit;

    /**
     * 校验
     * */
    public boolean validate(){
        return true;
    }


}
