package com.xxh.cloud.rule.core.entity.base;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardBizTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardTypeEnum;
import com.xxh.cloud.rule.core.constant.HealthDateLimitUnitEnum;
import com.xxh.cloud.rule.core.constant.HealthDateRangeTypeEnum;
import com.xxh.cloud.rule.core.executor.condition.healthOperate.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *  健康项目属性条件(叶子节点)
 * */
@Getter
@Setter
public class PropertyConditionHealthBean {


    @ApiModelProperty("排除/纳入分类(Y:纳入 N:排除)")
    private String ynType= YN.YES.getCode();

    @ApiModelProperty("数据类型[MetadataStandardBizTypeEnum](标准数据 原始数据)")
    private String dataType = MetadataStandardBizTypeEnum.Msbt_Standard.getCode();


    @ApiModelProperty("标准数据分类编号")
    private String mdTypeCode;

    @ApiModelProperty("标准数据分类名称")
    private String mdTypeName;

    @ApiModelProperty("标准数据编号")
    private String mdCode;

    @ApiModelProperty("标准数据名称")
    private String mdName;

    @ApiModelProperty("标准数据类型[MetadataStandardTypeEnum]")
    private String mdType;


//    @ApiModelProperty("原始数据类型[MetadataStandardTypeEnum] -del")
//    private String rawType;
//
//    @ApiModelProperty("样本编号 - del")
//    private String sampleCode;
//
//    @ApiModelProperty("样本名称 - del")
//    private String sampleName;


    @ApiModelProperty("标准数据范围[活动]")
    private String mdRange;


    @ApiModelProperty("一级操作符[MetadataResultTypeEnum](结果、区间、上升、下降、叙述结果)")
    private String op ;

    @ApiModelProperty("二级操作符[MetadataStandardResultTypeNarrateEnum](叙述结果:包含)")
    private String opChild;

    @ApiModelProperty("值(区间开始)")
    private String oval;

    @ApiModelProperty("值2(区间结束)")
    private String ovalTwo;

    @ApiModelProperty("值多")
    private List<String> ovalMany;




    /**
     *  EMR
     * */
    @ApiModelProperty("部位")
    private String partCode;

    @ApiModelProperty("持续时间操作符")
    private String durationOp;

    @ApiModelProperty("持续时间值(区间开始)")
    private String durationVal;

    @ApiModelProperty("持续时间值2(区间结束)")
    private String durationValTwo;

    @ApiModelProperty("持续时间单位")
    private String durationUnit;


    @ApiModelProperty("单次时间操作符")
    private String oneTimeOp;

    @ApiModelProperty("单次时间值(区间开始)")
    private String oneTimeVal;

    @ApiModelProperty("单次时间值2(区间结束)")
    private String oneTimeValTwo;

    @ApiModelProperty("单次时间单位")
    private String oneTimeUnit;


    //=================================================条件属性,限制条件

    @ApiModelProperty("是否有限制条件(YN)")
    private String restriction;

    @ApiModelProperty("时间范围分类[绝对值/相对值](HealthDateRangeTypeEnum)")
    private String dtRangeType;


    @ApiModelProperty("时间范围单位[HealthDateLimitUnitEnum](小时、天、周、月)")
    private String dtLimitUnit;

    @ApiModelProperty("时间范围-开始(前多少)")
    private String dtLimitStart;

    @ApiModelProperty("时间范围-结束(前多少[0:至今])")
    private String dtLimitEnd;

    @ApiModelProperty("满足任意条件次数")
    private int rytjNum;

    @ApiModelProperty("连续几次满足")
    private int lxtjNum;


    @ApiModelProperty("就诊部门/未就诊部门(Y N)")
    private String ynDept= YN.YES.getCode();
    
    @ApiModelProperty("所属部门编号(多)")
    private List<String> deptCodes;

//    @ApiModelProperty("所属部门名称")
//    private String deptName;









}
