package com.xxh.cloud.rule.core.executor.condition.context;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;
/**
 * 条件上下文明细（每个条件规则）
 * */
@Getter
@Setter
public class ConditionContextItemBO {

    /**
     * id
     * */
    private String id;

    /**
     *  ConditionNodeTypeEnum
     * */
    @ApiModelProperty(value = "条件节点类型 - ConditionNodeTypeEnum")
    private String type;


    /**
     *   关系类型 - ConditionRelationTypeEnum
     * */
    @ApiModelProperty(value = "关系类型 - ConditionRelationTypeEnum")
    private String relation ;

    /**
     * id
     * */
    private String pid;


    /**
     * 条件判断结果状态
     * */
    private String status;

    /**
     * 条件判断数据
     * */
    private List<ConditionContextDataItemBO> data;



    public ConditionContextItemBO(String id, String type,String pid){
        this.id=id;
        this.type=type;
        this.pid=pid;
    }

    public ConditionContextItemBO(String id, String type,String pid,boolean flag,List<XXOperateResult> resultList){
        this.id=id;
        this.type=type;
        this.pid=pid;
        this.status=flag? YN.YES.getCode() : YN.NO.getCode();
        if(this.data==null){
            this.data=new ArrayList<>();
        }
        if(CollUtil.isNotEmpty(resultList)){
            resultList.forEach(item->{
                this.data.add(item.getConditionData());
            });
        }
    }

    public ConditionContextItemBO(String id, String type,String pid,boolean flag){
        this.id=id;
        this.type=type;
        this.pid=pid;
        this.status=flag? YN.YES.getCode() : YN.NO.getCode();
    }





    public ConditionContextItemBO(String id, String type,String relation,String pid,boolean flag){
        this.id=id;
        this.type=type;
        this.relation=relation;
        this.pid=pid;
        this.status=flag? YN.YES.getCode() : YN.NO.getCode();
    }

    public ConditionContextItemBO(){

    }




    public void addData(ConditionContextDataItemBO item){
        if(this.data==null){
            this.data=new ArrayList<>();
        }
        if(item!=null){
            this.data.add(item);
        }
    }

    public void addResult(List<XXOperateResult> resultList){

    }




}
