package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.constant.XXRuleRoamConstant;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdEmrCheckBasic;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdEmrSymptom;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.executor.condition.operate.IXXOperateValue;
import com.xxh.cloud.rule.core.executor.condition.operate.XXOperate;
import com.xxh.cloud.rule.core.executor.condition.operate.XXOperateFactory;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class OPXXHBasicOpNone extends XXHOperateDefault{



    private XXOperateResult emr(String date ,XXRuleRoamHealthItem item ,PropertyConditionHealthBean property , XXOperate xxOperate,Float emrVal,String propVal){
        IXXOperateValue ixxOperateValue=new IXXOperateValue(MetadataStandardTypeEnum.MT_Decimal.getCode(), emrVal, propVal);
        boolean flag= xxOperate.operate(ixxOperateValue);
        if(flag){
            ConsoleUtils.log("++++++ 电子病历 体格检查 基础检查 判断结果: true");
            List<XXRuleRoamHealthItem> conditions=new ArrayList<>();
            conditions.add(item);
            return new XXOperateResult(true,date,conditions,property);
        }else {
            ConsoleUtils.log("++++++ 电子病历 体格检查 基础检查 判断结果: false");
        }
        return null;
    }


    private XXOperateResult emr(String date ,XXRuleRoamHealthItem item ,PropertyConditionHealthBean property , XXOperate xxOperate,Integer emrVal,String propVal){
        IXXOperateValue ixxOperateValue=new IXXOperateValue(MetadataStandardTypeEnum.MT_Decimal.getCode(), emrVal, propVal);
        boolean flag= xxOperate.operate(ixxOperateValue);
        if(flag){
            ConsoleUtils.log("++++++ 电子病历 体格检查 基础检查 判断结果: true");
            List<XXRuleRoamHealthItem> conditions=new ArrayList<>();
            conditions.add(item);
            return new XXOperateResult(true,date,conditions,property);
        }else {
            ConsoleUtils.log("++++++ 电子病历 体格检查 基础检查 判断结果: false");
        }
        return null;
    }


    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {
        ConsoleUtils.log("+++++条件属性配置 基础信息:{}", JSON.toJSONString(property));

        if(RuleCondtionDataTypeEnum.Physical_Sign.getCode().equals(property.getMdTypeCode())){
            //todo:
            for(XXRuleRoamHealthItem item:values){
                RoamItemDwdEmrCheckBasic dwdEmrCheckBasic=(RoamItemDwdEmrCheckBasic) item.getMdv();
                if(dwdEmrCheckBasic!=null){

                    XXOperate xxOperate= XXOperateFactory.getInstall(property.getOp());

                    if(RuleCondtionDataTypeEnum.EMR_BMI.getCode().equals(property.getMdCode())){ //BMI
                        if(dwdEmrCheckBasic.getBmi()!=null && StrUtil.isNotEmpty(property.getOval())){
                            XXOperateResult operateResult= this.emr(date,item,property,xxOperate,dwdEmrCheckBasic.getBmi(),property.getOval());
                            if(operateResult!=null){
                                return operateResult;
                            }
                        }

                    }else if(RuleCondtionDataTypeEnum.EMR_Height.getCode().equals(property.getMdCode())){ //身高
                        if(dwdEmrCheckBasic.getHeight()!=null && StrUtil.isNotEmpty(property.getOval())){
                            XXOperateResult operateResult= this.emr(date,item,property,xxOperate,dwdEmrCheckBasic.getHeight(),property.getOval());
                            if(operateResult!=null){
                                return operateResult;
                            }
                        }
                    }else if(RuleCondtionDataTypeEnum.EMR_Weight.getCode().equals(property.getMdCode())){ //体重
                        if(dwdEmrCheckBasic.getWeight()!=null && StrUtil.isNotEmpty(property.getOval())){
                            XXOperateResult operateResult= this.emr(date,item,property,xxOperate,dwdEmrCheckBasic.getWeight(),property.getOval());
                            if(operateResult!=null){
                                return operateResult;
                            }
                        }
                    }else if(RuleCondtionDataTypeEnum.EMR_BloodPressure.getCode().equals(property.getMdCode())){ //血压
                        if(StrUtil.isNotEmpty(dwdEmrCheckBasic.getBloodPressure()) && StrUtil.isNotEmpty(property.getOval())){
//                            XXOperateResult operateResult= this.emr(date,item,property,xxOperate,dwdEmrCheckBasic.getBloodPressure(),property.getOval());
//                            if(operateResult!=null){
//                                return operateResult;
//                            }
                        }
                    }else if(RuleCondtionDataTypeEnum.EMR_HeartRate.getCode().equals(property.getMdCode())){ //心率
                        if(dwdEmrCheckBasic.getHeartRate()!=null && StrUtil.isNotEmpty(property.getOval())){
                            XXOperateResult operateResult= this.emr(date,item,property,xxOperate,dwdEmrCheckBasic.getHeartRate(),property.getOval());
                            if(operateResult!=null){
                                return operateResult;
                            }
                        }
                    }else if(RuleCondtionDataTypeEnum.EMR_Temperature.getCode().equals(property.getMdCode())){ //体温
                        if(dwdEmrCheckBasic.getTemperature()!=null && StrUtil.isNotEmpty(property.getOval())){
                            XXOperateResult operateResult= this.emr(date,item,property,xxOperate,dwdEmrCheckBasic.getTemperature(),property.getOval());
                            if(operateResult!=null){
                                return operateResult;
                            }
                        }
                    }

                }
            }

        }else if(RuleCondtionDataTypeEnum.MDT_Patient.getCode().equals(property.getMdTypeCode())){
            XXRuleRoamHealthItem ruleRoamHealthItem= baseData.get(property.getMdCode());
            if(ruleRoamHealthItem!=null){
                ConsoleUtils.log("++++++ 条件数据内容 基础信息 :"+JSON.toJSONString(ruleRoamHealthItem));
                XXOperate xxOperate= XXOperateFactory.getInstall(property.getOp());

                IXXOperateValue ixxOperateValue;
                if(XXRuleRoamConstant.Basic_Key_age.equals(property.getMdCode())){
                    ixxOperateValue=new IXXOperateValue(MetadataStandardTypeEnum.MT_Int.getCode(),ruleRoamHealthItem.getMdv(),property.getOval());
                }else {
                    ixxOperateValue=new IXXOperateValue(MetadataStandardTypeEnum.MT_String.getCode(),ruleRoamHealthItem.getMdv(),property.getOval());
                }

                boolean flag= xxOperate.operate(ixxOperateValue);
                if(flag){
                    ConsoleUtils.log("++++++ 基础信息 判断结果: true");
                    List<XXRuleRoamHealthItem> conditions=new ArrayList<>();
                    conditions.add(ruleRoamHealthItem);
                    return new XXOperateResult(true,date,conditions,property);
                }else {
                    ConsoleUtils.log("++++++ 基础信息 判断结果: false");
                }
            }
        }




        return new XXOperateResult(false);
    }

}
