package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdEmrSymptom;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdExamineReserve;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import jdk.nashorn.internal.runtime.regexp.JoniRegExp;

import java.util.List;
import java.util.Map;

public class OPXXHEmr_Symptom  extends XXHOperateDefault{


    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values, Map<String, XXRuleRoamHealthItem> baseData) {

        if(RuleCondtionDataTypeEnum.EMR_SymptomZS.getCode().equals(property.getMdTypeCode())){
            for(XXRuleRoamHealthItem item:values){
                RoamItemDwdEmrSymptom dwdEmrSymptom=(RoamItemDwdEmrSymptom) item.getMdv();
                if(dwdEmrSymptom!=null){
                    boolean flag= this.check(property,dwdEmrSymptom);
                    System.out.println("+++++ 主诉(症状) 执行结果:"+flag);
                    if(flag){
                        return new XXOperateResult(true,date,item,property);
                    }
                }
            }
        }


        if(RuleCondtionDataTypeEnum.EMR_SymptomJWS.getCode().equals(property.getMdTypeCode())){
            for(XXRuleRoamHealthItem item:values){
                RoamItemDwdEmrSymptom dwdEmrSymptom=(RoamItemDwdEmrSymptom) item.getMdv();
                if(dwdEmrSymptom!=null){
                    boolean flag= this.check(property,dwdEmrSymptom);
                    System.out.println("+++++ 既往史(症状) 执行结果:"+flag);
                    if(flag){
                        return new XXOperateResult(true,date,item,property);
                    }
                }
            }
        }

        if(RuleCondtionDataTypeEnum.EMR_SymptomXBS.getCode().equals(property.getMdTypeCode())){
            for(XXRuleRoamHealthItem item:values){
                RoamItemDwdEmrSymptom dwdEmrSymptom=(RoamItemDwdEmrSymptom) item.getMdv();
                if(dwdEmrSymptom!=null){
                    boolean flag= this.check(property,dwdEmrSymptom);
                    System.out.println("+++++ 现病史(症状) 执行结果:"+flag);
                    if(flag){
                        return new XXOperateResult(true,date,item,property);
                    }
                }
            }
        }

        return new XXOperateResult(false);
    }


    private boolean check(PropertyConditionHealthBean property,RoamItemDwdEmrSymptom symptom){

        System.out.println("------------------------");
        System.out.println(JSON.toJSONString(property));
        System.out.println(JSON.toJSONString(symptom));

        if(property==null){
            return false;
        }
        if(symptom==null){
            return false;
        }

        if(StrUtil.isEmpty(property.getMdCode())){
            return false;
        }


        boolean flag1=false;

        if(StrUtil.isNotEmpty(symptom.getCode()) && property.getMdCode().equals(symptom.getCode())){
            flag1=true;
        }else {
            flag1=false;
        }

        boolean flag2=true;
        if(StrUtil.isNotEmpty(property.getPartCode())){
            if(StrUtil.isNotEmpty(symptom.getPart()) && property.getPartCode().equals(symptom.getPart())){
                flag2=true;
            }else {
                flag2=false;
            }
        }


        boolean flag3=true;
        if(StrUtil.isNotEmpty(property.getDurationOp()) && StrUtil.isNotEmpty(property.getDurationVal())){
            flag3 =this.checkTime(symptom,property.getDurationOp(),property.getDurationVal(),property.getDurationValTwo(),property.getDurationUnit());
        }

        boolean flag4=true;
        if(StrUtil.isNotEmpty(property.getOneTimeOp()) && StrUtil.isNotEmpty(property.getOneTimeVal())){
            flag4 = this.checkTime(symptom,property.getOneTimeOp(),property.getOneTimeVal(),property.getOneTimeValTwo(),property.getOneTimeUnit());
        }

        System.out.println(StrUtil.format("+++++ 单条数据执行:症状={} ,部位={} ,持续时间={} ,单次时间={}",flag1,flag2,flag3,flag4));

        if(flag1 && flag2 && flag3 && flag4){
            return true;
        }else {
            return false;
        }

    }


    private boolean checkTime(RoamItemDwdEmrSymptom symptom,String op ,String val1,String val2,String unit){




        return false;
    }





}
