package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdInChangeRecord;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.log.RuleLogUtils;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class OPXXHIn_Change extends XXHOperateDefault{
    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values, Map<String, XXRuleRoamHealthItem> baseData) {
        if(StrUtil.isEmpty(property.getOp()) || StrUtil.isEmpty(property.getOval())){
            return new XXOperateResult(false);
        }


        if(CollUtil.isEmpty(values)){
            return new XXOperateResult(false);
        }


        System.out.println("+++++++++++++++ 转科室条件 +++++++++++++++++++++++");
        System.out.println("+++++++++++ 数据开始 ...... ");
        System.out.println(JSON.toJSONString(values));
        System.out.println("+++++++++++ 数据结束 ...... ");

        System.out.println("+++++++++++条件配置开始 ...... ");
        System.out.println(JSON.toJSONString(property));
        System.out.println("+++++++++++条件配置结束 ...... ");



        Set<String> deptCodes=new HashSet<>();
        for(XXRuleRoamHealthItem item:values){
            if(item.getMdv()!=null){
                RoamItemDwdInChangeRecord inChangeRecord= (RoamItemDwdInChangeRecord) item.getMdv();


                if(MetadataStandardResultTypeEnum.MSRT_In_Dept.getCode().equals(property.getOp())){
                    if(MetadataStandardResultTypeEnum.MSRT_In_Dept.getCode().equals(inChangeRecord.getDataType())){
                        if(StrUtil.isNotEmpty(inChangeRecord.getChangeCode())){
                            deptCodes.add(inChangeRecord.getChangeCode());
                        }
                    }
                }else if(MetadataStandardResultTypeEnum.MSRT_Out_Dept.getCode().equals(property.getOp())){
                    if(MetadataStandardResultTypeEnum.MSRT_Out_Dept.getCode().equals(inChangeRecord.getDataType())){
                        if(StrUtil.isNotEmpty(inChangeRecord.getChangeCode())){
                            deptCodes.add(inChangeRecord.getChangeCode());
                        }
                    }
                }
            }
        }

        if(deptCodes.contains(property.getOval())){
            System.out.println("+++++++++++++ 执行结果: TRUE");
            return new XXOperateResult(true);
        }else {
            System.out.println("+++++++++++++ 执行结果: FALSE");
            return new XXOperateResult(false);
        }

    }


}
