package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.*;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;

import java.util.List;
import java.util.Map;

/**
 *  无操作符
 * */
public class OPXXHOpNone extends XXHOperateDefault{


    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {


        for(XXRuleRoamHealthItem item:values){
            if(item.getMdv()!=null){
                //预约检查
                if(RuleCondtionDataTypeEnum.Reserve_Examine.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdExamineReserve examineReserve=(RoamItemDwdExamineReserve) item.getMdv();
                    ConsoleUtils.log(" +++++ 条件数据内容 预约检查:"+JSON.toJSONString(examineReserve));

                    if(examineReserve!=null && CollUtil.isNotEmpty(examineReserve.getItemsStandard()) && examineReserve.getItemsStandard().contains(property.getMdCode()) ){
                        ConsoleUtils.log(" +++++ 预约检查条件判断结果: true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 预约检查件判断结果: false");
                    }
                }

                //申请检查 ok
                if(RuleCondtionDataTypeEnum.Apply_Examine.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdExamineApply examineApply=(RoamItemDwdExamineApply) item.getMdv();
                    ConsoleUtils.log(" +++++ 条件数据内容 申请检查:"+JSON.toJSONString(examineApply));
                    if(examineApply!=null && CollUtil.isNotEmpty(examineApply.getItemsStandard())
                            && examineApply.getItemsStandard().contains(property.getMdCode())){
                        ConsoleUtils.log(" +++++ 申请检查件判断结果 true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 申请检查件判断结果 false");
                    }
                }

                //申请检验 ok
                if(RuleCondtionDataTypeEnum.Apply_Laboratory_Project.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdLaboratoryApply laboratoryApply=(RoamItemDwdLaboratoryApply) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 申请检验:"+JSON.toJSONString(laboratoryApply));
                    RoamItemDwdLaboratoryApplyItem laboratoryApplyItem = laboratoryApply.getItem(property.getMdCode());
                    if(laboratoryApplyItem!=null){
                        ConsoleUtils.log(" +++++ 申请检验件判断结果 true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 申请检验件判断结果 false");
                    }
                }

                //申请病理 [同申请检查] ok
                if(RuleCondtionDataTypeEnum.Apply_Pathology.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdExamineApply examineApply=(RoamItemDwdExamineApply) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 申请病理:"+JSON.toJSONString(examineApply));
                    if(examineApply!=null && CollUtil.isNotEmpty(examineApply.getItemsStandard()) && examineApply.getItemsStandard().contains(property.getMdCode())){
                        ConsoleUtils.log(" +++++ 申请病理件判断结果 true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 申请病理件判断结果 false");
                    }
                }

                //申请手术 ok
                if(RuleCondtionDataTypeEnum.Apply_Operation.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdOperationApply operationApply=(RoamItemDwdOperationApply) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 申请手术:"+JSON.toJSONString(operationApply));
                    RoamItemDwdOperationApplyItem operationApplyItem = operationApply.getItem(property.getMdCode());
                    if(operationApplyItem!=null){
                        ConsoleUtils.log(" +++++ 申请手术件判断结果 true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 申请手术件判断结果 false");
                    }
                }


                //手术记录 ok
                if(RuleCondtionDataTypeEnum.OperationRecord.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdOperationRecord operationRecord=(RoamItemDwdOperationRecord) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 手术记录:"+JSON.toJSONString(operationRecord));
                    RoamItemDwdOperationRecordItem operationApplyItem = operationRecord.getItem(property.getMdCode());
                    if(operationApplyItem!=null){
                        ConsoleUtils.log(" +++++ 手术记录件判断结果 true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 手术记录件判断结果 false");
                    }
                }



                //申请治疗(治疗记录) ok
                if(RuleCondtionDataTypeEnum.Therapy.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdRecipeTherapy recipeTherapy=(RoamItemDwdRecipeTherapy) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 申请治疗:"+JSON.toJSONString(recipeTherapy));
                    RoamItemDwdRecipeTherapyItem therapyItem = recipeTherapy.getItem(property.getMdCode());
                    if(therapyItem!=null){
                        ConsoleUtils.log(" +++++ 申请治疗件判断结果 true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log(" +++++ 申请治疗件判断结果 false");
                    }
                }

                //todo:申请护理[无]

                //门诊用药 ok
                if(RuleCondtionDataTypeEnum.Medicine_MZ.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdRecipeMedicine recipeMedicine=(RoamItemDwdRecipeMedicine) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 门诊用药:"+JSON.toJSONString(recipeMedicine));
                    if("MZ".equals(recipeMedicine.getSceneTypeStandard())){
                        RoamItemDwdRecipeMedicineItem medicineItem = recipeMedicine.getItem(property.getMdCode());
                        if(medicineItem!=null){
                            ConsoleUtils.log(" +++++ 门诊用药件判断结果 true");
                            return new XXOperateResult(true,date,item,property);
                        }else {
                            ConsoleUtils.log(" +++++ 门诊用药件判断结果 false");
                        }
                    }
                }

                //急诊用药
                if(RuleCondtionDataTypeEnum.Medicine_JZ.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdRecipeMedicine recipeMedicine=(RoamItemDwdRecipeMedicine) item.getMdv();
                    if("JZ".equals(recipeMedicine.getSceneTypeStandard())){
                        RoamItemDwdRecipeMedicineItem medicineItem = recipeMedicine.getItem(property.getMdCode());
                        if(medicineItem!=null){
                            return new XXOperateResult(true,date,item,property);
                        }
                    }
                }

                //住院用药
                if(RuleCondtionDataTypeEnum.Medicine_ZY.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdRecipeMedicine recipeMedicine=(RoamItemDwdRecipeMedicine) item.getMdv();
                    if("ZY".equals(recipeMedicine.getSceneTypeStandard())){
                        RoamItemDwdRecipeMedicineItem medicineItem = recipeMedicine.getItem(property.getMdCode());
                        if(medicineItem!=null){
                            return new XXOperateResult(true,date,item,property);
                        }
                    }
                }

                //出院带药
                if(RuleCondtionDataTypeEnum.Medicine_CY.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdRecipeMedicine recipeMedicine=(RoamItemDwdRecipeMedicine) item.getMdv();
                    if("CY".equals(recipeMedicine.getSceneTypeStandard())){
                        RoamItemDwdRecipeMedicineItem medicineItem = recipeMedicine.getItem(property.getMdCode());
                        if(medicineItem!=null){
                            return new XXOperateResult(true,date,item,property);
                        }
                    }
                }

                //门急诊就诊  OK
                if(RuleCondtionDataTypeEnum.VisitRecord.getCode().equals(property.getMdTypeCode())){
                    System.out.println("============");
                    RoamItemDwdVisitRecord visitRecord=(RoamItemDwdVisitRecord) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 门急诊就诊:"+JSON.toJSONString(visitRecord));
                    if(property.getMdCode().equals(visitRecord.getSceneTypeStandard())){
                        ConsoleUtils.log("++++++ 门急诊就诊件判断结果: true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log("++++++ 门急诊就诊件判断结果: false");
                        return new XXOperateResult(false,date,item,property);
                    }
                }

                //预约挂号
                if(RuleCondtionDataTypeEnum.Reserve_RegisterRecord.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdRegisterRecord registerRecord=(RoamItemDwdRegisterRecord) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 预约挂号:"+JSON.toJSONString(registerRecord));
                    if(property.getMdCode().equals(registerRecord.getSceneTypeStandard())){
                        ConsoleUtils.log("++++++ 预约挂号件判断结果: true");
                        return new XXOperateResult(true,date,item,property);
                    }else {
                        ConsoleUtils.log("++++++ 预约挂号件判断结果: false");
                        return new XXOperateResult(false,date,item,property);
                    }
                }

                //预约住院[含诊断]
                if(RuleCondtionDataTypeEnum.Reserve_Inpatient.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdInpatientReserve inpatientReserve=(RoamItemDwdInpatientReserve) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 预约住院[含诊断] :"+JSON.toJSONString(inpatientReserve));
                    //主诊断
                    boolean flag= NarrateUtils.check(inpatientReserve.getDiagnosisCodeStandard(),property.getOpChild(),property.getOvalMany());
                    if(flag){
                        ConsoleUtils.log("++++++ 预约住院[含诊断] 判断结果: true");
                        return new XXOperateResult(true,date,values,property);
                    }else {
                        ConsoleUtils.log("++++++ 预约住院[含诊断] 判断结果: false");
                        return new XXOperateResult(false,date,values,property);
                    }
                }

                //预约住院[不含诊断]
                if(RuleCondtionDataTypeEnum.Reserve_Inpatient_Not.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdInpatientReserve inpatientReserve=(RoamItemDwdInpatientReserve) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 预约住院[不含诊断] :"+JSON.toJSONString(inpatientReserve));
                    boolean flag= true;
                    if(flag){
                        ConsoleUtils.log("++++++ 预约住院[不含诊断] 判断结果: true");
                        return new XXOperateResult(true,date,values,property);
                    }else {
                        ConsoleUtils.log("++++++ 预约住院[不含诊断] 判断结果: false");
                        return new XXOperateResult(false,date,values,property);
                    }
                }


                //住院登记[含诊断]
                if(RuleCondtionDataTypeEnum.Inpatient.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdInpatientRecord inpatientRecord=(RoamItemDwdInpatientRecord) item.getMdv();

                    ConsoleUtils.log("++++++ 条件数据内容 住院登记[含诊断]:"+JSON.toJSONString(inpatientRecord));
                    //主诊断
                    boolean flag= NarrateUtils.check(inpatientRecord.getDiagnosisCodeStandard(),property.getOpChild(),property.getOvalMany());
                    if(flag){
                        ConsoleUtils.log("++++++ 住院登记[含诊断]判断结果: true");
                        return new XXOperateResult(true,date,values,property);
                    }else {
                        ConsoleUtils.log("++++++ 住院登记[含诊断]判断结果: false");
                    }
                }

                //入院记录[不含诊断]
                if(RuleCondtionDataTypeEnum.Inpatient_Not.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdInpatientRecord inpatientRecord=(RoamItemDwdInpatientRecord) item.getMdv();
                    ConsoleUtils.log("++++++ 条件数据内容 住院登记[不含诊断]:"+JSON.toJSONString(inpatientRecord));
                    //主诊断
                    boolean flag=true;
                    if(flag){
                        ConsoleUtils.log("++++++ 住院登记[不含诊断]判断结果: true");
                        return new XXOperateResult(true,date,values,property);
                    }else {
                        ConsoleUtils.log("++++++ 住院登记[不含诊断]判断结果: false");
                    }
                }

            }

        }






        return new XXOperateResult(false);
    }
}
