package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdLaboratoryReport;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdLaboratoryReportItem;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;

import java.util.List;
import java.util.Map;

/**
 * 区间
 * */
public class OPXXHRange extends XXHOperateDefault{

    @Override
    public XXOperateResult op(String date,PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {
        if(StrUtil.isEmpty(property.getOval()) || StrUtil.isEmpty(property.getOvalTwo())){
            return new XXOperateResult(false);
        }

        for(XXRuleRoamHealthItem item:values){
            if(item.getMdv()!=null){
                if(RuleCondtionDataTypeEnum.Report_Laboratory.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdLaboratoryReport laboratoryReport=(RoamItemDwdLaboratoryReport) item.getMdv();
                    RoamItemDwdLaboratoryReportItem laboratoryReportItem = laboratoryReport.getItem(property.getMdCode());


                    //  boolean flag=property.getYnType().equals(YN.YES.getCode())?operateResultBO.isFlag():!operateResultBO.isFlag();


                    //property.getYnType()

                    //todo:活动
                    if(StrUtil.isNotEmpty(property.getMdRange())){ //有活动
                        if(StrUtil.isNotEmpty(laboratoryReport.getActNo())  && property.getMdRange().equals(laboratoryReport.getActNo()) ){
                            if(laboratoryReportItem!=null ){
                                ConsoleUtils.log("++++区间条件内容:{}",JSON.toJSONString(laboratoryReportItem));
                                boolean flag=this.check(laboratoryReportItem,property.getOval(),property.getOvalTwo());

//                                boolean YNFlag;
//                                if(YN.YES.getCode().equals(property.getYnType())){
//                                    YNFlag=flag;
//                                }else {
//                                    YNFlag=!flag;
//                                }

                                if(flag){
                                    ConsoleUtils.log("++++++++++区间判断 true");
                                    return new XXOperateResult(true,date,item,property);
                                }else {
                                    ConsoleUtils.log("++++++++++区间判断 false");
                                }
                            }
                        }
                    }else { //无活动
                        if(laboratoryReportItem!=null ){
                            ConsoleUtils.log("++++区间条件内容:{}",JSON.toJSONString(laboratoryReportItem));
                            boolean flag=this.check(laboratoryReportItem,property.getOval(),property.getOvalTwo());
                            if(flag){
                                ConsoleUtils.log("++++++++++区间判断 true");
                                return new XXOperateResult(true,date,item,property);
                            }else {
                                ConsoleUtils.log("++++++++++区间判断 false");
                            }
                        }
                    }

                }
            }
        }

        return new XXOperateResult(false);
    }




    private boolean check(RoamItemDwdLaboratoryReportItem laboratoryReportItem,String val1,String val2 ){

        //todo:检验报告,区间使用原始值 2024-04-10
        System.out.println("+++++ 区间判断数据 : "+JSON.toJSONString(laboratoryReportItem));


        if(StrUtil.isEmpty(laboratoryReportItem.getInspectResultRaw())){
            System.out.println("+++++ 原始数据值不存在");
            return false;
        }

        ConsoleUtils.log("++++++++++区间判断,计算参数: 数据值= {}  开始值 = {}  截止值 = {}",laboratoryReportItem.getInspectResultRaw(),val1,val2);

        Double inspectResultRaw= Convert.toDouble(laboratoryReportItem.getInspectResultRaw());
        if(inspectResultRaw==null){
            System.out.println("+++++ 原始数据值转数值错误,内容 = "+laboratoryReportItem.getInspectResultRaw());
            return false;
        }

        double val = inspectResultRaw.doubleValue();

        Double  min= Convert.toDouble(val1);
        Double  max= Convert.toDouble(val2);

        if(val >= min.doubleValue() && val <= max.doubleValue()){
            return true;
        }else {
            return false;
        }

    }







//
//
//    @Override
//    public boolean operate_str(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        XXHOperateValue operateValue=getValue(data,property);
//        if(operateValue==null || operateValue.getVal()==null){
//            return false;
//        }
//        if(StrUtil.isEmpty(property.getOval()) || StrUtil.isEmpty(property.getOvalTwo())){
//            return false;
//        }
//
//        String leftVal = Convert.toStr(operateValue.getVal());
//        String rightVal1 =property.getOval();
//        String rightVal2 = property.getOvalTwo();
//
//        int compare1 = rightVal1.compareTo(leftVal);
//        int compare2 = leftVal.compareTo(rightVal2);
//        if(compare1<=0 && compare2<=0){
//            return true;
//        }else {
//            return false;
//        }
//    }
//
//    @Override
//    public boolean operate_int(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        XXHOperateValue operateValue=getValue(data,property);
//        if(operateValue==null || operateValue.getVal()==null){
//            return false;
//        }
//        if(StrUtil.isEmpty(property.getOval()) || StrUtil.isEmpty(property.getOvalTwo())){
//            return false;
//        }
//        Integer leftVal = Convert.toInt(operateValue.getVal());
//        Integer rightVal1 = Convert.toInt(property.getOval());
//        Integer rightVal2 = Convert.toInt(property.getOvalTwo());
//        if(rightVal1.intValue()<=leftVal.intValue() && leftVal.intValue()<=rightVal2.intValue()){
//            return true;
//        }else {
//            return false;
//        }
//    }
//
//    @Override
//    public boolean operate_double(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        XXHOperateValue operateValue=getValue(data,property);
//        if(operateValue==null || operateValue.getVal()==null){
//            return false;
//        }
//        if(StrUtil.isEmpty(property.getOval()) || StrUtil.isEmpty(property.getOvalTwo())){
//            return false;
//        }
//
//        Double leftVal = Convert.toDouble(operateValue.getVal());
//        Double rightVal1 = Convert.toDouble(property.getOval());
//        Double rightVal2 = Convert.toDouble(property.getOvalTwo());
//
//        if(rightVal1.doubleValue()<=leftVal.doubleValue() && leftVal.doubleValue()<=rightVal2.doubleValue()){
//            return true;
//        }else {
//            return false;
//        }
//    }
//
//    @Override
//    public boolean operate_datetime(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        //todo:
//        return false;
//    }


}
