package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeNarrateEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.*;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.log.RuleLogUtils;

import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;

/**
 * 叙述结果
 * */
public class OPXXHResultNarrate extends XXHOperateDefault{


    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {

        if(StrUtil.isEmpty(property.getOpChild()) || CollUtil.isEmpty(property.getOvalMany())){
            RuleLogUtils.addRuleLog("",property,"二级操作符或配置的多值为空");
            return new XXOperateResult(false);
        }


        for(XXRuleRoamHealthItem item:values){
            if(item.getMdv()!=null){
                //病理报告 [ 检查报告]
                if(RuleCondtionDataTypeEnum.Report_Pathology.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdExamineReport examineReport = (RoamItemDwdExamineReport)item.getMdv();
                    ConsoleUtils.log("++++检查报告,叙述结果条件内容:{}",JSON.toJSONString(examineReport));
                    ConsoleUtils.log("关键字:{}",property.getOvalMany());

                    //todo:活动
                    boolean nextFlag=false;
                    if(StrUtil.isNotEmpty(property.getMdRange())) { //有活动
                        if(StrUtil.isNotEmpty(examineReport.getActNo())  && property.getMdRange().equals(examineReport.getActNo()) ){
                            nextFlag=true;
                        }
                    }else {
                        nextFlag=true;
                    }

                    if(nextFlag){
                        if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate.getCode().equals(property.getOp())){
                            boolean flag= NarrateUtils.check(examineReport.getReportResultStandard(),property.getOpChild(),property.getOvalMany());
                            if(flag){
                                return new XXOperateResult(true,date,item,property);
                            }
                        }
                    }

                }



                //出院小结
                if(RuleCondtionDataTypeEnum.DischargeSummary.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdDischargeRecord dwdDischargeRecord=(RoamItemDwdDischargeRecord) item.getMdv();
                    ConsoleUtils.log("++++出院小结条件内容:{}",JSON.toJSONString(dwdDischargeRecord));
                    if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate.getCode().equals(property.getOp())){
                        ConsoleUtils.log("关键字:{}",property.getOvalMany());
                        boolean flag= NarrateUtils.check(dwdDischargeRecord.getContentStandard(),property.getOpChild(),property.getOvalMany());
                        if(flag){
                            return new XXOperateResult(true,date,item,property);
                        }
                    }
                }

                //手术文书
                if(RuleCondtionDataTypeEnum.OperationText.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdOperationRecord operationRecord=(RoamItemDwdOperationRecord) item.getMdv();
                    ConsoleUtils.log("++++手术文书条件内容:{}",JSON.toJSONString(operationRecord));
                    if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate.getCode().equals(property.getOp())){
                        ConsoleUtils.log("关键字:{}",property.getOvalMany());
                        boolean flag= NarrateUtils.check(operationRecord.getContentStandard(),property.getOpChild(),property.getOvalMany());
                        if(flag){
                            return new XXOperateResult(true,date,item,property);
                        }
                    }
                }

                //检验报告
                if(RuleCondtionDataTypeEnum.Report_Laboratory.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdLaboratoryReport laboratoryReport=(RoamItemDwdLaboratoryReport) item.getMdv();
                    RoamItemDwdLaboratoryReportItem laboratoryReportItem = laboratoryReport.getItem(property.getMdCode());
                    ConsoleUtils.log("++++检验报告,叙述结果条件内容:{}",JSON.toJSONString(laboratoryReportItem));
                    ConsoleUtils.log("关键字:{}",property.getOvalMany());


                    //todo:活动
                    boolean nextFlag=false;
                    if(StrUtil.isNotEmpty(property.getMdRange())) { //有活动
                        if(StrUtil.isNotEmpty(laboratoryReport.getActNo())  && property.getMdRange().equals(laboratoryReport.getActNo()) ){
                            nextFlag=true;
                        }
                    }else {
                        nextFlag=true;
                    }

                    if(nextFlag){
                        if(laboratoryReportItem!=null){
                            boolean flag= NarrateUtils.check(laboratoryReportItem.getResultNarrate(),MetadataStandardResultTypeNarrateEnum.OP_Contain_Any.getCode(),property.getOvalMany());
                            if(flag){
                                return new XXOperateResult(true,date,item,property);
                            }
                        }
                    }

                }



            }

        }
        return new XXOperateResult(false);
    }








//
//    @Override
//    public boolean operate_str(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        XXHOperateValue operateValue=getValue(data,property);
//        if(operateValue==null || operateValue.getVal()==null){
//            return false;
//        }
//
//        if(StrUtil.isEmpty(property.getOpChild()) || CollUtil.isEmpty(property.getOvalMany())){
//            RuleLogUtils.addRuleLog("",property,"二级操作符或配置的多值为空");
//            return false;
//        }
//
//        if(MapUtil.isEmpty(keywordsMap)){
//            return false;
//        }
//
//        String content = Convert.toStr(operateValue.getVal());
//
//        if(MetadataStandardResultTypeNarrateEnum.OP_Contain.getCode().equals(property.getOpChild())){
//            for(String oval:property.getOvalMany()){
//                String pattern= keywordsMap.get(oval);
//                if(StrUtil.isEmpty(pattern)){
//                    RuleLogUtils.addRuleLog("",property,StrUtil.format("关键字[{}],无配置",oval));
//                    return false;
//                }
//                boolean isMatch = Pattern.matches(pattern, content);
//                if(!isMatch){
//                    return false;
//                }
//            }
//            return true;
//        }else if(MetadataStandardResultTypeNarrateEnum.OP_Contain_Any.getCode().equals(property.getOpChild())){
//            for(String oval:property.getOvalMany()){
//                String pattern= keywordsMap.get(oval);
//                if(StrUtil.isEmpty(pattern)){
//                    RuleLogUtils.addRuleLog("",property,StrUtil.format("关键字[{}],无配置",oval));
//                    return false;
//                }
//                boolean isMatch = Pattern.matches(pattern, content);
//                if(isMatch){
//                    return true;
//                }
//            }
//            return false;
//        }else if(MetadataStandardResultTypeNarrateEnum.OP_NotContain.getCode().equals(property.getOpChild())){
//            for(String oval:property.getOvalMany()){
//                String pattern= keywordsMap.get(oval);
//                if(StrUtil.isEmpty(pattern)){
//                    RuleLogUtils.addRuleLog("",property,StrUtil.format("关键字[{}],无配置",oval));
//                    return false;
//                }
//                boolean isMatch = Pattern.matches(pattern, content);
//                if(isMatch){
//                    return false;
//                }
//            }
//            return true;
//        }else if(MetadataStandardResultTypeNarrateEnum.OP_NotContain_Any.getCode().equals(property.getOpChild())){
//            for(String oval:property.getOvalMany()){
//                String pattern= keywordsMap.get(oval);
//                if(StrUtil.isEmpty(pattern)){
//                    RuleLogUtils.addRuleLog("",property,StrUtil.format("关键字[{}],无配置",oval));
//                    return false;
//                }
//                boolean isMatch = Pattern.matches(pattern, content);
//                if(!isMatch){
//                    return true;
//                }
//            }
//            return false;
//        }else {
//            RuleLogUtils.addRuleLog("",property,StrUtil.format("不支持的二级操作符[{}],(MetadataStandardResultTypeNarrateEnum)",property.getOpChild()));
//            return false;
//        }
//
//    }
//
//
//
//    @Override
//    public boolean operate_int(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        return this.operate_str(data,property,keywordsMap);
//    }
//
//    @Override
//    public boolean operate_double(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        return this.operate_str(data,property,keywordsMap);
//    }
//
//    @Override
//    public boolean operate_datetime(XXRuleRoamHealthItem data, PropertyConditionHealthBean property,Map<String,String> keywordsMap) {
//        return false;
//    }





}
