package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdDiagnosisReport;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdDischargeRecord;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdExamineReport;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdInpatientReserve;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.log.RuleLogUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 主诊断
 * 预诊断
 * */
public class OPXXHResultNarrateDiagnose  extends XXHOperateDefault{

    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {
        if(StrUtil.isEmpty(property.getOpChild()) || CollUtil.isEmpty(property.getOvalMany())){
            RuleLogUtils.addRuleLog("",property,"二级操作符或配置的多值为空");
            return new XXOperateResult(false);
        }

        //诊断
        if(RuleCondtionDataTypeEnum.Diagnosis.getCode().equals(property.getMdTypeCode())){
            ConsoleUtils.log("+++++++++++ 历史诊断条件内容:{}",JSON.toJSONString(values));
            List<String> icdList=new ArrayList<>();

            for(XXRuleRoamHealthItem item:values){
                if(item.getMdv()!=null){
                    RoamItemDwdDiagnosisReport diagnosisReport = (RoamItemDwdDiagnosisReport)item.getMdv();

                    if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain.getCode().equals(property.getOp())){
                        //主诊断(不限)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                        }
                    }
                    else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_CB.getCode().equals(property.getOp())){
                        //主诊断(初步诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "cbzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }

                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_MZ.getCode().equals(property.getOp())){
                        //主诊断(门诊诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "mzzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }

                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_RY.getCode().equals(property.getOp())){
                        //主诊断(入院诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "ryzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }

                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_CY.getCode().equals(property.getOp())){
                        //主诊断(出院诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "cyzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }

                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_XZ.getCode().equals(property.getOp())){
                        //主诊断(修正诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "xzzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }

                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_SW.getCode().equals(property.getOp())){
                        //主诊断(死亡诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "1".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "swzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    }

                    else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre.getCode().equals(property.getOp())){
                        //预诊断(不限)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                        }
                    }

                    else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_CB.getCode().equals(property.getOp())){
                        //预诊断(初步诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "cbzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    } else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_MZ.getCode().equals(property.getOp())){
                        //预诊断(门诊诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "mzzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    } else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_RY.getCode().equals(property.getOp())){
                        //预诊断(入院诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "ryzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_CY.getCode().equals(property.getOp())){
                        //预诊断(出院诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "cyzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_XZ.getCode().equals(property.getOp())){
                        //预诊断(修正诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "xzzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_SW.getCode().equals(property.getOp())){
                        //预诊断(死亡诊断)
                        if(StrUtil.isNotEmpty(diagnosisReport.getMainFlag()) && "0".equals(diagnosisReport.getMainFlag())){
                            if(StrUtil.isNotEmpty(diagnosisReport.getSceneTypeStandard()) && "swzd".equals(diagnosisReport.getSceneTypeStandard())){
                                icdList.add(diagnosisReport.getDiagnosisCodeStandard());
                            }
                        }
                    }


                }
            }




            if(icdList.size()>0){

                if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain.getCode().equals(property.getOp())){
                    //主诊断(不限)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(不限) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }

                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_CB.getCode().equals(property.getOp())){
                    //主诊断(初步诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(初步诊断) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_MZ.getCode().equals(property.getOp())){
                    //主诊断(门诊诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(门诊诊断) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_RY.getCode().equals(property.getOp())){
                    //主诊断(入院诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(入院诊断) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_CY.getCode().equals(property.getOp())){
                    //主诊断(出院诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(出院诊断) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_XZ.getCode().equals(property.getOp())){
                    //主诊断(修正诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(修正诊断) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_SW.getCode().equals(property.getOp())){
                    //主诊断(死亡诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++主诊断(死亡诊断) : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }

                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre.getCode().equals(property.getOp())){
                    //预诊断(不限)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(不限)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_CB.getCode().equals(property.getOp())){
                    //预诊断(初步诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(初步诊断)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_MZ.getCode().equals(property.getOp())){
                    //预诊断(门诊诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(门诊诊断)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_RY.getCode().equals(property.getOp())){
                    //预诊断(入院诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(入院诊断)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_CY.getCode().equals(property.getOp())){
                    //预诊断(出院诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(出院诊断)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_XZ.getCode().equals(property.getOp())){
                    //预诊断(修正诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(修正诊断)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }
                else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_SW.getCode().equals(property.getOp())){
                    //预诊断(死亡诊断)
                    boolean flag= NarrateUtils.check(icdList,property.getOpChild(),property.getOvalMany());
                    System.out.println("++++++++++预诊断(死亡诊断)  : "+JSON.toJSONString(icdList));
                    System.out.println(property.getMdTypeName());
                    System.out.println(StrUtil.format("flag = {} , op ={} ,val ={}",flag,property.getOpChild(),property.getOvalMany()));
                    if(flag){
                        return new XXOperateResult(true,date,values,property);
                    }
                }

            }


            return new XXOperateResult(false);
        }


        //预约住院
        if(RuleCondtionDataTypeEnum.Reserve_Inpatient.getCode().equals(property.getMdTypeCode())){
            for(XXRuleRoamHealthItem item:values) {
                if (item.getMdv() != null) {
                    RoamItemDwdInpatientReserve inpatientReserve=(RoamItemDwdInpatientReserve) item.getMdv();
                    ConsoleUtils.log("+++++++++++ 条件内容 预约住院[诊断] :"+JSON.toJSONString(inpatientReserve));
                    //主诊断
                    boolean flag= NarrateUtils.check(inpatientReserve.getDiagnosisCodeStandard(),property.getOpChild(),property.getOvalMany());
                    if(flag){
                        ConsoleUtils.log(" +++++  预约住院[诊断条件判断结果: true");
                        return new XXOperateResult(true,date,values,property);
                    }else {
                        ConsoleUtils.log(" +++++  预约住院[诊断条件判断结果: false");
                        return new XXOperateResult(false,date,values,property);
                    }
                }
            }
        }

        //出院
        if(RuleCondtionDataTypeEnum.Discharge.getCode().equals(property.getMdTypeCode())){
            for(XXRuleRoamHealthItem item:values) {
                if (item.getMdv() != null) {
                    RoamItemDwdDischargeRecord discharge=(RoamItemDwdDischargeRecord) item.getMdv();
                    ConsoleUtils.log("+++++++++++ 条件内容 出院[诊断] :"+JSON.toJSONString(discharge));
                    //主诊断
                    boolean flag= NarrateUtils.check(discharge.getDiagnosisCodeStandard(),property.getOpChild(),property.getOvalMany());
                    if(flag){
                        ConsoleUtils.log(" +++++  出院[诊断条件判断结果: true");
                        return new XXOperateResult(true,date,values,property);
                    }else {
                        ConsoleUtils.log(" +++++  出院[诊断条件判断结果: false");
                        return new XXOperateResult(false,date,values,property);
                    }
                }
            }
        }




        return new XXOperateResult(false);
    }
}
