package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdExamineReport;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdRecipePathologyReport;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.log.RuleLogUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.Map;


/**
 * 报告提示
 * 报告所见
 * */
public class OPXXHResultNarrateReport  extends XXHOperateDefault{

    private static final Logger logger = LoggerFactory.getLogger(OPXXHResultNarrateReport.class);



    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {
        if(StrUtil.isEmpty(property.getOpChild()) || CollUtil.isEmpty(property.getOvalMany())){
            RuleLogUtils.addRuleLog("",property,"二级操作符或配置的多值为空");
            return new XXOperateResult(false);
        }
        logger.debug("++++++ 检验报告 条件参数: {}",JSON.toJSONString(property));
        for(XXRuleRoamHealthItem item:values){
            if(item.getMdv()!=null){
                //检查报告
                if(RuleCondtionDataTypeEnum.Report_Examine.getCode().equals(property.getMdTypeCode())){

                    RoamItemDwdExamineReport examineReport = (RoamItemDwdExamineReport)item.getMdv();
                    logger.debug("+++++检验报告 : {}", JSON.toJSONString(examineReport));

                    //todo:活动
                    boolean nextFlag=false;
                    if(StrUtil.isNotEmpty(property.getMdRange())) { //有活动
                        if(StrUtil.isNotEmpty(examineReport.getActNo())  && property.getMdRange().equals(examineReport.getActNo()) ){
                            nextFlag=true;
                        }
                    }else {
                        nextFlag=true;
                    }

                    if(nextFlag){
                        if(StrUtil.isNotEmpty(examineReport.getReportNameStandard()) && examineReport.getReportNameStandard().equals(property.getMdCode())){
                            if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_ReportTip.getCode().equals(property.getOp())){
                                boolean flag= NarrateUtils.check(examineReport.getReportResultStandard(),property.getOpChild(),property.getOvalMany());
                                logger.debug("++++++检验报告 : {}",flag);
                                if(flag){
                                    return new XXOperateResult(true,date,item,property);
                                }
                            }else if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_ReportSee.getCode().equals(property.getOp())){
                                boolean flag= NarrateUtils.check(examineReport.getReportDescriptionStandard(),property.getOpChild(),property.getOvalMany());
                                logger.debug("++++++检验报告 : {}",flag);
                                if(flag){
                                    return new XXOperateResult(true,date,item,property);
                                }
                            }
                        }
                    }

                }

            }
        }

        return new XXOperateResult(false);
    }






}
