package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdLaboratoryReport;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdLaboratoryReportItem;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;

import java.util.List;
import java.util.Map;

/**
 * 二分类结果
 * */
public class OPXXHResultTwoCategory extends XXHOperateDefault{

    @Override
    public XXOperateResult op(String date, PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData) {
        if(StrUtil.isEmpty(property.getOval())){
            return new XXOperateResult(false);
        }
        for(XXRuleRoamHealthItem item:values){
            if(item.getMdv()!=null){
                if(RuleCondtionDataTypeEnum.Report_Laboratory.getCode().equals(property.getMdTypeCode())){
                    RoamItemDwdLaboratoryReport laboratoryReport=(RoamItemDwdLaboratoryReport) item.getMdv();
                    RoamItemDwdLaboratoryReportItem laboratoryReportItem = laboratoryReport.getItem(property.getMdCode());

                    //todo:活动
                    if(StrUtil.isNotEmpty(property.getMdRange())) { //有活动
                        if(StrUtil.isNotEmpty(laboratoryReport.getActNo())  && property.getMdRange().equals(laboratoryReport.getActNo()) ){
                            if(laboratoryReportItem!=null){
                                ConsoleUtils.log("++++二分类结果条件内容:{}",JSON.toJSONString(laboratoryReportItem));
                                boolean flag=this.check(laboratoryReportItem,property.getOval());
                                if(flag){
                                    ConsoleUtils.log("++++++++++二分类判断 true");
                                    return new XXOperateResult(true,date,item,property);
                                }else {
                                    ConsoleUtils.log("++++++++++二分类判断 false");
                                }
                            }
                        }
                    }else {

                        if(laboratoryReportItem!=null){
                            ConsoleUtils.log("++++二分类结果条件内容:{}",JSON.toJSONString(laboratoryReportItem));
                            boolean flag=this.check(laboratoryReportItem,property.getOval());
                            if(flag){
                                ConsoleUtils.log("++++++++++二分类判断 true");
                                return new XXOperateResult(true,date,item,property);
                            }else {
                                ConsoleUtils.log("++++++++++二分类判断 false");
                            }
                        }
                    }


                }
            }
        }

        return new XXOperateResult(false);
    }

    private boolean check(RoamItemDwdLaboratoryReportItem dataItem,String val){
        if(dataItem==null || StrUtil.isEmpty(dataItem.getResultTwoCategoryCode()) || StrUtil.isEmpty(val)){
            ConsoleUtils.log("++++++++++二分类结果计算参数,参数为空。 返回 false");
            return false;
        }
        ConsoleUtils.log("++++++++++二分类结果计算参数 {}  ; {}",JSON.toJSONString(dataItem),val);

        if(dataItem.getResultTwoCategoryCode().equals(val)){
            return true;
        }else {
            return false;
        }
    }


}
