package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.constant.XXRuleRoamConstant;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItemHelper;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdExamineReport;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdLaboratoryReport;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public abstract class XXHOperateDefault implements XXHOperate{


    @Override
    public XXOperateResult operate(String date, Map<String, XXRuleRoamHealthItem> data,Map<String,XXRuleRoamHealthItem> baseData, PropertyConditionHealthBean property) {

        //1.
        List<XXRuleRoamHealthItem> healthItemDataList= this.getRuleRoamHealthData_Day(data,property);
        if(CollUtil.isEmpty(healthItemDataList)){
            XXOperateResult resultNot= new XXOperateResult(false);
//            resultNot.setExeLog();
//            System.out.println("");
            return resultNot;
        }
        //2.
        System.out.println("+++++++++执行时间有数据:  "+date);
        XXOperateResult result=this.op(date,property,healthItemDataList,baseData);
        return result;
    }




    public abstract XXOperateResult op(String date,PropertyConditionHealthBean property, List<XXRuleRoamHealthItem> values,Map<String,XXRuleRoamHealthItem> baseData);






    /**
     * 每日数据: 根据元数据获取元数据对应的数据
     * */
    public List<XXRuleRoamHealthItem> getRuleRoamHealthData_Day(Map<String, XXRuleRoamHealthItem> data, PropertyConditionHealthBean property){
        if(MapUtil.isEmpty(data)){
            return null;
        }

        List<XXRuleRoamHealthItem> returnList=new ArrayList<>();

        //报告
        //检验报告
        //RoamItemDwdLaboratoryReport
        if(RuleCondtionDataTypeEnum.Report_Laboratory.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Report_Laboratory.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //检查报告
        //RoamItemDwdExamineReport
        if(RuleCondtionDataTypeEnum.Report_Examine.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Report_Examine.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //病理报告
        //RoamItemDwdRecipePathologyReport
        if(RuleCondtionDataTypeEnum.Report_Pathology.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Report_Pathology.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //体检报告
        if(RuleCondtionDataTypeEnum.Report_PhysicalExamine.getCode().equals(property.getMdTypeCode())){
        }

        //医生操作
        //申请检查 RoamItemDwdExamineApply
        if(RuleCondtionDataTypeEnum.Apply_Examine.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Apply_Examine.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //申请检验 RoamItemDwdLaboratoryApply
        if(RuleCondtionDataTypeEnum.Apply_Laboratory_Project.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Apply_Laboratory_Project.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //申请病理 RoamItemDwdRecipePathologyApply
        if(RuleCondtionDataTypeEnum.Apply_Pathology.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Apply_Pathology.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }


        //申请住院
        if(RuleCondtionDataTypeEnum.Apply_Inpatient.getCode().equals(property.getMdTypeCode())){
        }

        //申请出院
        if(RuleCondtionDataTypeEnum.Apply_Discharge.getCode().equals(property.getMdTypeCode())){
        }

        //申请手术 RoamItemDwdOperationApply
        if(RuleCondtionDataTypeEnum.Apply_Operation.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Apply_Operation.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //申请治疗(治疗记录) RoamItemDwdRecipeTherapy
        if(RuleCondtionDataTypeEnum.Therapy.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Therapy.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //申请护理
        if(RuleCondtionDataTypeEnum.Apply_Nurse.getCode().equals(property.getMdTypeCode())){
        }

        //门诊用药
        //急诊用药
        //住院用药
        //出院带药 RoamItemDwdRecipeMedicine
        if(RuleCondtionDataTypeEnum.Medicine_MZ.getCode().equals(property.getMdTypeCode())
            || RuleCondtionDataTypeEnum.Medicine_JZ.getCode().equals(property.getMdTypeCode())
            || RuleCondtionDataTypeEnum.Medicine_ZY.getCode().equals(property.getMdTypeCode())
            || RuleCondtionDataTypeEnum.Medicine_CY.getCode().equals(property.getMdTypeCode()) ){

            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Medicine_MZ.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //下诊断  RoamItemDwdDiagnosisReport
        //历史诊断
        if(RuleCondtionDataTypeEnum.Diagnosis.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Diagnosis.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //执行手术 RoamItemDwdOperationRecord
        //手术文书
        if(RuleCondtionDataTypeEnum.OperationRecord.getCode().equals(property.getMdTypeCode())
            || RuleCondtionDataTypeEnum.OperationText.getCode().equals(property.getMdTypeCode()) ){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.OperationRecord.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //患者信息
        //病历
        if(RuleCondtionDataTypeEnum.Medical_Record.getCode().equals(property.getMdTypeCode())){
        }



        //量表结果
        if(RuleCondtionDataTypeEnum.ScaleResult.getCode().equals(property.getMdTypeCode())){
            //无
        }

        //量表问题
        if(RuleCondtionDataTypeEnum.ScaleItemResult.getCode().equals(property.getMdTypeCode())){
            //无
        }

        //患者基础信息
        if(RuleCondtionDataTypeEnum.MDT_Patient.getCode().equals(property.getMdTypeCode())){
            //特殊处理
        }

        //患者就医记录
        //门急诊就诊 RoamItemDwdVisitRecord
        if(RuleCondtionDataTypeEnum.VisitRecord.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.VisitRecord.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //预约挂号 RoamItemDwdRegisterRecord
        if(RuleCondtionDataTypeEnum.Reserve_RegisterRecord.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.RegisterRecord.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //预约检查 RoamItemDwdExamineReserve
        if(RuleCondtionDataTypeEnum.Reserve_Examine.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Reserve_Examine.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //预约住院 RoamItemDwdInpatientReserve
        if(RuleCondtionDataTypeEnum.Reserve_Inpatient.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Reserve_Inpatient.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //预约住院 RoamItemDwdInpatientReserve
        if(RuleCondtionDataTypeEnum.Reserve_Inpatient_Not.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Reserve_Inpatient_Not.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }



        //住院登记 RoamItemDwdInpatientRecord
        if(RuleCondtionDataTypeEnum.Inpatient.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Inpatient.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //住院登记 RoamItemDwdInpatientRecord
        if(RuleCondtionDataTypeEnum.Inpatient_Not.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Inpatient_Not.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }


        //出院 RoamItemDwdDischargeRecord
        //出院小结
        if(RuleCondtionDataTypeEnum.Discharge.getCode().equals(property.getMdTypeCode())
           || RuleCondtionDataTypeEnum.DischargeSummary.getCode().equals(property.getMdTypeCode()) ){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Discharge.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //在线问诊
        if(RuleCondtionDataTypeEnum.Online_Inquiry.getCode().equals(property.getMdTypeCode())){
        }

        //转病区
        if(RuleCondtionDataTypeEnum.Change_Ward.getCode().equals(property.getMdTypeCode())){
        }

        //转科室
        if(RuleCondtionDataTypeEnum.Change_Dept.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Change_Dept.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //患者就医事件
        //事件  RoamItemDwdEvent
        if(RuleCondtionDataTypeEnum.MDS_Event.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.MDS_Event.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //运营数据

        //标签 RoamItemDwdLabel
        if(RuleCondtionDataTypeEnum.Label.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Label.getCode())){
                    XXRuleRoamHealthItem addRuleRoamHealthItem = data.get(key);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }



        //患者基本信息
        if(RuleCondtionDataTypeEnum.MDT_Patient.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                XXRuleRoamHealthItem addRuleRoamHealthItem = data.get(key);
                if(addRuleRoamHealthItem!=null){
                    returnList.add(addRuleRoamHealthItem);
                }
            }
        }


        //体征
        if(RuleCondtionDataTypeEnum.Physical_Sign.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.Physical_Sign.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //主诉(症状)
        if(RuleCondtionDataTypeEnum.EMR_SymptomZS.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.EMR_SymptomZS.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }

        //既往史(症状)
        if(RuleCondtionDataTypeEnum.EMR_SymptomJWS.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.EMR_SymptomJWS.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }


        //现病史(症状)
        if(RuleCondtionDataTypeEnum.EMR_SymptomXBS.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.EMR_SymptomXBS.getCode())){
                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
                }
            }
        }




//        if(RuleCondtionDataTypeEnum.MDT_Patient.getCode().equals(property.getMdTypeCode())){
//            for(String key:data.keySet()){
//                XXRuleRoamHealthItem addRuleRoamHealthItem = data.get(key);
//                if(addRuleRoamHealthItem!=null){
//                    returnList.add(addRuleRoamHealthItem);
//                }
//            }
//        }




        //运营数据
        //量表结果
        if(RuleCondtionDataTypeEnum.ScaleResult.getCode().equals(property.getMdTypeCode())){
            for(String key:data.keySet()){
                if(XXRuleRoamHealthItemHelper.isKeyPrefix(key,RuleCondtionDataTypeEnum.ScaleResult.getCode())){
                    XXRuleRoamHealthItem addRuleRoamHealthItem = data.get(key);
                    if(addRuleRoamHealthItem!=null){
                        returnList.add(addRuleRoamHealthItem);
                    }
//                    XXRuleRoamHealthItem xxRuleRoamHealthItem = data.get(key);
//                    XXRuleRoamHealthItem addRuleRoamHealthItem = this.validateDept(xxRuleRoamHealthItem,property);
//                    if(addRuleRoamHealthItem!=null){
//                        returnList.add(addRuleRoamHealthItem);
//                    }
                }
            }
        }



        return returnList;
    }



    public XXRuleRoamHealthItem validateDept(XXRuleRoamHealthItem data,PropertyConditionHealthBean property){
        if(StrUtil.isNotEmpty(property.getRestriction()) && YN.YES.getCode().equals(property.getRestriction())){
            if(StrUtil.isNotEmpty(property.getYnDept()) && CollUtil.isNotEmpty(property.getDeptCodes())){
                if(StrUtil.isEmpty(data.getDeptCode())){
                    return null;
                }
                if(!property.getDeptCodes().contains(data.getDeptCode())){
                        return null;
                }
            }
        }
        return data;
    }


//    //todo:del
//    public XXRuleRoamHealthItem getRuleRoamHealthData(Map<String, XXRuleRoamHealthItem> data, PropertyConditionHealthBean property){
//        if(MapUtil.isEmpty(data)){
//           return null;
//        }

//        XXRuleRoamHealthItem healthItem= data.get(property.getMdCode());
//        if(healthItem==null){
//            return null;
//        }
//
//
//
//        //判断部门
//        if(StrUtil.isNotEmpty(property.getRestriction()) && YN.YES.getCode().equals(property.getRestriction())){
//            if(StrUtil.isNotEmpty(property.getYnDept()) && CollUtil.isNotEmpty(property.getDeptCodes())){
//                if(StrUtil.isEmpty(healthItem.getDeptCode())){
//                    return null;
//                }
//                if(YN.YES.getCode().equals(property.getYnDept())){ //包含
//                    if(!property.getDeptCodes().contains(healthItem.getDeptCode())){
//                        return null;
//                    }
//                }else {  //排除
//                    if(property.getDeptCodes().contains(healthItem.getDeptCode())){
//                        return null;
//                    }
//                }
//            }
//
//        }
//
//        return  healthItem;
//    }


    /**
     *
     * */
    public XXHOperateValue getValue(XXRuleRoamHealthItem dataItem,PropertyConditionHealthBean property){
        if(dataItem==null){
            return null;
        }
        //标准值
//        return new XXHOperateValue(dataItem.getMdv(),dataItem.getMdvStatus(), dataItem.getMdvStatusRatio(),dataItem.getMdvStatusNum(),
//                dataItem.getMdvStartNum(),dataItem.getMdvEndNum());

        //todo:
        return null;

    }






}
