package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.utils.XXEnumUtil;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeEnum;

public class XXHOperateFactory {


    public static XXHOperate getInstall(MetadataStandardResultTypeEnum op){
        switch (op){
            case MSRT_Range: //区间
                return new OPXXHRange();

            case MSRT_Rise: //上升
                return new OPXXHRise();

            case MSRT_Decline: //下降
                return new OPXXHDecline();

            case MSRT_ResultValue: //结果值
                return new OPXXHResultValue();

            case MSRT_ResultTwoCategory: //二分类结果
                return new OPXXHResultTwoCategory();

            case MSRT_ResultNarrate: //叙述结果
                return new OPXXHResultNarrate();

            case  MSRT_ResultNarrate_ReportTip: //报告提示
            case  MSRT_ResultNarrate_ReportSee: //报告所见
                return new OPXXHResultNarrateReport();

            case  MSRT_ResultNarrate_DiagnoseMain: //主诊断(不限)
            case  MSRT_ResultNarrate_DiagnoseMain_CB: //主诊断(初步诊断)
            case  MSRT_ResultNarrate_DiagnoseMain_MZ: //主诊断(门诊诊断)
            case  MSRT_ResultNarrate_DiagnoseMain_RY: //主诊断(入院诊断)
            case  MSRT_ResultNarrate_DiagnoseMain_CY: //主诊断(出院诊断)
            case  MSRT_ResultNarrate_DiagnoseMain_XZ: //主诊断(修正诊断)
            case  MSRT_ResultNarrate_DiagnoseMain_SW: //主诊断(死亡诊断)
            case  MSRT_ResultNarrate_DiagnosePre: //预诊断(不限)
            case  MSRT_ResultNarrate_DiagnosePre_CB: //预诊断(初步诊断)
            case  MSRT_ResultNarrate_DiagnosePre_MZ ://预诊断(门诊诊断)
            case  MSRT_ResultNarrate_DiagnosePre_RY: //预诊断(入院诊断)
            case  MSRT_ResultNarrate_DiagnosePre_CY: //预诊断(出院诊断)
            case  MSRT_ResultNarrate_DiagnosePre_XZ://预诊断(修正诊断)
            case  MSRT_ResultNarrate_DiagnosePre_SW://预诊断(死亡诊断)

                return new OPXXHResultNarrateDiagnose();

            case  MSRT_ResultNarrate_Current: //当前
            case  MSRT_ResultNarrate_History: //历史
                return new OPXXHInLabel();

            case  MSRT_Scale_EQ: //量表等于
                return new OPXXHEqHealth();
            case MSRT_Scale_NE: //量表不等于
                return new OPXXHNeHealth();
            case  MSRT_None: //无
                return new OPXXHOpNone();
            case MSRT_EQ:
            case MSRT_NE:
            case MSRT_GT:
            case MSRT_GE:
            case MSRT_LT:
            case MSRT_LE:
                return new OPXXHBasicOpNone();
            case MSRT_In_Dept:
            case MSRT_Out_Dept:
                return new OPXXHIn_Change();
            case EMR_Symptom:
                return new OPXXHEmr_Symptom();
        }
        throw  new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR, StrUtil.format("不支持的操作符, 操作符:code ={} ,name={}",op.getCode(),op.getMsg()));
    }




    public static XXHOperate getInstall(String op){
        if(StrUtil.isEmpty(op)){
            return new OPXXHOpNone();
        }
        MetadataStandardResultTypeEnum typeOP = XXEnumUtil.getEnum(MetadataStandardResultTypeEnum.class,op);
        if(typeOP==null){
            System.out.println(StrUtil.format("++++++ 不支持的操作符, 操作符:{}",op));
            throw  new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR, StrUtil.format("不支持的操作符, 操作符:{}",op));
        }
        return getInstall(typeOP);
    }








}
