package com.xxh.cloud.rule.core.executor.condition.healthOperate;

import cn.hutool.core.lang.Console;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.rule.basic.constant.XXRuleRoamConstant;
import com.xxh.cloud.rule.core.context.XXOperateResult;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.executor.condition.context.ConditionContext;
import com.xxh.cloud.rule.core.executor.condition.context.ConditionContextItemBO;
import com.xxh.cloud.rule.core.utils.DateBetweenUtils;

import java.util.*;

public class XXHOperateUtils {


    public static boolean operate(XXRuleContext context, ConditionContext conditionContext, NodeCondition condition, PropertyConditionHealthBean property, String parentId) {
        XXHOperate xxhOperate= XXHOperateFactory.getInstall(property.getOp());

        if(StrUtil.isEmpty(property.getRestriction())){
            property.setRestriction(YN.NO.getCode());
        }

        if(YN.YES.getCode().equals(property.getRestriction())){ //有限制条件
            XXHOperateResultBO operateResultBO;

            if(StrUtil.isNotEmpty(property.getDtRangeType())){
                //限制时间段
                List<String> dateList= DateBetweenUtils.between(property.getDtRangeType(), property.getDtLimitUnit(), property.getDtLimitStart(),property.getDtLimitEnd());
                operateResultBO= condition_Yes(xxhOperate,context,conditionContext, dateList,context.getRoam(),property);
            }else {
                //不限制时间段
                List<String> dateList=XXHOperateUtils.getDateDayList(context.getRoam());
                operateResultBO= condition_Yes(xxhOperate,context,conditionContext, dateList,context.getRoam(),property);
            }

            //todo:待改到子模块判断 anros 24-10-10
            boolean flag=property.getYnType().equals(YN.YES.getCode())?operateResultBO.isFlag():!operateResultBO.isFlag();


            if(flag){
                conditionContext.addConditionItem(
                        new ConditionContextItemBO(condition.getId(),condition.getType(),parentId,flag,operateResultBO.getResultList())
                );
            }
            return flag;

        }else { //无限制条件
            List<String> dateList=XXHOperateUtils.getDateDayList(context.getRoam());
            XXHOperateResultBO operateResultBO=condition_Not(xxhOperate,context,conditionContext,dateList,context.getRoam(),property);

            //todo:待改到子模块判断 anros 24-10-10
            boolean flag=property.getYnType().equals(YN.YES.getCode())?operateResultBO.isFlag():!operateResultBO.isFlag();

            if(flag){
                conditionContext.addConditionItem(
                        new ConditionContextItemBO(condition.getId(),condition.getType(),parentId,flag,operateResultBO.getResultList())
                );
            }
            return flag;
        }
    }


    /**
     * 不限制
     * */
    private static XXHOperateResultBO condition_Not(XXHOperate xxhOperate,XXRuleContext context,ConditionContext conditionContext,List<String> dateList,XXRuleRoam roam, PropertyConditionHealthBean property){
        for(String date:dateList){
             Map<String, XXRuleRoamHealthItem> ruleRoamHealthItemMap = roam.getDayHealth(date);
             Map<String,XXRuleRoamHealthItem> baseRoamHealthItemMap= roam.getBasicHealthData();
             XXOperateResult result= xxhOperate.operate(date,ruleRoamHealthItemMap,baseRoamHealthItemMap,property);
             if(result.isFlag()){
                 return new XXHOperateResultBO(true,result);
             }
         }
        return new XXHOperateResultBO(false);
    }



    /**
     * 限制
     * */
    private static XXHOperateResultBO condition_Yes(XXHOperate xxhOperate,XXRuleContext context,ConditionContext conditionContext, List<String> dateList,XXRuleRoam roam, PropertyConditionHealthBean property){
        int okNum=0; //满足任意条件次数
        int lxNum=0;  //连续几次满足
        List<XXOperateResult> operateResultList=new ArrayList<>();

        if(roam==null){
            System.out.println("-----------------roam is null");
            return new XXHOperateResultBO(false);
        }

        for(String date:dateList){
            if(StrUtil.isNotEmpty(date)){
                Map<String, XXRuleRoamHealthItem> ruleRoamHealthItemMap = roam.getDayHealth(date);
                Map<String,XXRuleRoamHealthItem> baseRoamHealthItemMap= roam.getBasicHealthData();
                XXOperateResult result= xxhOperate.operate(date,ruleRoamHealthItemMap,baseRoamHealthItemMap,property);
                if(result.isFlag()){
                    okNum++;
                    lxNum++;
                    operateResultList.add(result);
                }else {
                    lxNum=0;
                }

                if(okNum >= property.getRytjNum() && lxNum>=property.getLxtjNum()){
                    return new XXHOperateResultBO(true,operateResultList);
                }
            }
        }
        return new XXHOperateResultBO(false);
    }




    /**
     * 优化
     * */
    //todo:优化
    @Deprecated
    private static List<String> getDateDayList(XXRuleRoam roam){
        List<String> data=new ArrayList<>();
        Enumeration<String> enu= roam.keys();
        while (enu.hasMoreElements()) {
              data.add(enu.nextElement());
//            String val=  enu.nextElement();
//            if(!XXRuleRoamConstant.Basic_key.equals(val)){
//                data.add(val);
//            }
        }
        Collections.sort(data, new Comparator<String>() {
            @Override
            public int compare(String str1, String str2) {
                return str2.compareTo(str1);
            }
        });
        return data;
    }


}
