package com.xxh.cloud.rule.core.executor.condition.operate;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.rule.core.exception.XXCommonErrorEnum;

import java.util.List;

/**
 * 闭区间(包含两点)
 * */
public class XXBetweenClose extends XXOperateDefault{

    @Override
    public void check(IXXOperateValue params) {
        if(StrUtil.isEmpty(params.getType())){
            throw new BusinessException(XXCommonErrorEnum.Not_Support_OP);
        }

        //todo:
    }

    @Override
    public boolean operate_str(IXXOperateValue params) {
        if(params.getLeftVal()==null){
            return false;
        }
        if(params.getRightOneVal()==null){
            return false;
        }
        if(params.getRightTwoVal()==null){
            return false;
        }

        String leftVal = Convert.toStr(params.getLeftVal());
        String rightVal1 = Convert.toStr(params.getRightOneVal());
        String rightVal2 = Convert.toStr(params.getRightTwoVal());
        int compare1 = rightVal1.compareTo(leftVal);
        int compare2 = leftVal.compareTo(rightVal2);
        if(compare1<=0 && compare2<=0){
           return true;
        }else {
           return false;
        }
    }



    @Override
    public boolean operate_int(IXXOperateValue params) {
        if(params.getLeftVal()==null){
            return false;
        }
        if(params.getRightOneVal()==null){
            return false;
        }
        if(params.getRightTwoVal()==null){
            return false;
        }
        Integer leftVal = Convert.toInt(params.getLeftVal());
        Integer rightVal1 = Convert.toInt(params.getRightOneVal());
        Integer rightVal2 = Convert.toInt(params.getRightTwoVal());

        if(rightVal1.intValue()<=leftVal.intValue() && leftVal.intValue()<=rightVal2.intValue()){
            return true;
        }else {
            return false;
        }
    }

    @Override
    public boolean operate_double(IXXOperateValue params) {
        if(params.getLeftVal()==null){
            return false;
        }
        if(params.getRightOneVal()==null){
            return false;
        }
        if(params.getRightTwoVal()==null){
            return false;
        }
        Double leftVal = Convert.toDouble(params.getLeftVal());
        Double rightVal1 = Convert.toDouble(params.getRightOneVal());
        Double rightVal2 = Convert.toDouble(params.getRightTwoVal());

        if(rightVal1.doubleValue()<=leftVal.doubleValue() && leftVal.doubleValue()<=rightVal2.doubleValue()){
            return true;
        }else {
            return false;
        }
    }

    @Override
    public boolean operate_datetime(IXXOperateValue params) {
        return this.operate_str(params);
    }


}
