package com.xxh.cloud.rule.core.executor.condition.operate;

import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardTypeEnum;
import com.xxh.cloud.rule.core.exception.XXCommonErrorEnum;

import java.util.List;

public abstract class XXOperateDefault implements XXOperate{

    @Override
    public boolean operate(IXXOperateValue params) {
        this.check(params);
        if( MetadataStandardTypeEnum.MT_Dict.getCode().equals(params.getType()) ) {
            return this.operate_str(params);
        }else if( MetadataStandardTypeEnum.MT_String.getCode().equals(params.getType()) ){
            return this.operate_str(params);
        }else if( MetadataStandardTypeEnum.MT_Text.getCode().equals(params.getType()) ){
            return this.operate_str(params);
        } else if( MetadataStandardTypeEnum.MT_Int.getCode().equals(params.getType()) ){
            return this.operate_int(params);
        }else if( MetadataStandardTypeEnum.MT_Decimal.getCode().equals(params.getType()) ){
            return  this.operate_double(params);
        }else if( MetadataStandardTypeEnum.MT_DateTime.getCode().equals(params.getType()) ){
            return  this.operate_datetime(params);
        }else {
            throw new BusinessException(XXCommonErrorEnum.Not_Support_OP);
        }
    }

    @Override
    public boolean operate(String dataType,Object leftVal,Object rightOneVal, Object rightTwoVal, List<Object> rightVals){
        IXXOperateValue params=new IXXOperateValue(dataType,leftVal,rightOneVal,rightTwoVal);
        params.setRightVals(rightVals);
        return operate(params);
    }

    public abstract void check(IXXOperateValue params);

    public abstract boolean operate_str(IXXOperateValue params);

    public abstract boolean operate_int(IXXOperateValue params);

    public abstract boolean operate_double(IXXOperateValue params);

    public abstract boolean operate_datetime(IXXOperateValue params);




}
