package com.xxh.cloud.rule.core.executor.condition.operate;

import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.utils.XXEnumUtil;
import com.xxh.cloud.rule.core.constant.RuleOpEnum;

public class XXOperateFactory {


    public static XXOperate getInstall(RuleOpEnum op){
        switch (op){

            case EQ:
                return new XXEQ();
            case NE:
                return new XXNE();
            case GT:
                return new XXGT();
            case GE:
                return new XXGE();
            case LT:
                return new XXLT();
            case LE:
                return new XXLE();


            case Between:
                return new XXBetweenOpen();
            case BetweenClosed:
                return new XXBetweenClose();
            case BetweenClosedLeft:
                return new XXBetweenLeft();
            case BetweenClosedRight:
                return new XXBetweenRight();
            case BetweenNot:
                return new XXBetweenNot();
            case IsNull:
                return new XXIsNull();
            case  IsNotNull:
                return new XXIsNotNull();
            case In:
                return new XXIn();
            case NotIn:
                return new XXInNot();
            case Like:
                return new XXLike();
            case LikeAny:
                return new XXLikeAny();
            case LikeAll:
                return new XXLikeAll();
            case LikeNum:
                return new XXLikeNum();
            case NotLike:
                return new XXNotLike();
            case NotLikeAny:
                return new XXNotLikeAny();
            case NotLikeAll:
                return new XXNotLikeAll();
            case NotLikeNum:
                return new XXNotLikeNum();
        }
        throw  new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR, StrUtil.format("不支持的操作符, 操作符:code ={} ,name={}",op.getCode(),op.getMsg()));
    }


    public static XXOperate getInstall(String op){
        RuleOpEnum ruleOp = XXEnumUtil.getEnum(RuleOpEnum.class,op);
        if(ruleOp==null){
            throw  new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR, StrUtil.format("不支持的操作符, 操作符:{}",op));
        }
        return getInstall(ruleOp);
    }




//    public static void main(String[] args) {
//        String leftVal ="Bd5";
//        String rightVal="Ad5";
//
//        int compare = leftVal.compareTo(rightVal);
//        System.out.println(compare);
//    }

}
