package com.xxh.cloud.rule.core.executor.condition.process;


import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.rule.core.constant.ConditionNodeTypeEnum;
import com.xxh.cloud.rule.core.constant.ConditionRelationTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.entity.base.MethodBaseBean;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionBaseBean;
import com.xxh.cloud.rule.core.entity.base.PropertyConditionHealthBean;
import com.xxh.cloud.rule.core.executor.condition.context.ConditionContext;
import com.xxh.cloud.rule.core.executor.condition.context.ConditionContextItemBO;
import com.xxh.cloud.rule.core.executor.condition.healthOperate.XXHOperateUtils;
import com.xxh.cloud.rule.core.executor.condition.operate.XXOperate;
import com.xxh.cloud.rule.core.executor.condition.operate.XXOperateFactory;
import com.xxh.cloud.rule.core.executor.data.PropertyBaseGetUtils;
import org.apache.commons.collections.map.HashedMap;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 获取所有条件
 * */
public class DefaultConditionNodeExecuteAllProcess extends AbstractConditionNodeProcess{
    @Override
    public boolean process(XXRuleContext context ,ConditionContext conditionContext, String nodeId, String nodeName, String nodeType, String nodeRuleType, NodeCondition condition) {

        //1.
        List<NodeCondition> returnConditionList=new ArrayList<>();
        this.handle(context,condition,returnConditionList);

        //2.
        Map<String,Boolean> resultMap=new HashedMap();
        for(NodeCondition nodeCondition:returnConditionList){
            boolean flag =this.condition_property(context,conditionContext,nodeCondition,nodeCondition.getProperty(),"0"); //属性条件
            resultMap.put(nodeCondition.getId(),flag);
        }

        //3.
        return true;
    }

    
    /**
     *  遍历条件,获取变量
     * */
    private void handle(XXRuleContext context,NodeCondition condition,List<NodeCondition> returnConditionList){
        if(ConditionNodeTypeEnum.Property.getCode().equals(condition.getType())){

//            condition.getProperty()
            returnConditionList.add(condition);
        } else if(ConditionNodeTypeEnum.Relation.getCode().equals(condition.getType())){ //关系
//            condition.getId()
//            condition.getType()
//            condition.getRelation()
            for(NodeCondition childCondition: condition.getChildren()){
                handle(context,childCondition,returnConditionList);
            }
        }
    }


    private boolean condition3(NodeCondition condition,Map<String,Boolean> resultMap){
        if(condition==null ){
            return false;
        }
        if(StrUtil.isEmpty(condition.getType())){
            return false;
        }

        if(ConditionNodeTypeEnum.Property.getCode().equals(condition.getType())){
            //System.out.println(">>>>>  执行节点开始");
            boolean flag =resultMap.get(condition.getId());
            return flag;
        } else { //关系条件

            //且:所有T，返回T
            if(ConditionRelationTypeEnum.And.getCode().equals(condition.getRelation())){
                System.out.println(">>>>> And 开始");
                for(NodeCondition childCondition: condition.getChildren()){
                    boolean flag =  condition3(childCondition,resultMap);
                    if(flag==false){
                        //记录关系节点日志
                        System.out.println(">>>>> And 截止 false");
                        return false;
                    }
                }
                //记录关系节点日志
                System.out.println(">>>>> And 截止 true");
                return true;
            }

            //或:有一个T，返回T
            if(ConditionRelationTypeEnum.Or.getCode().equals(condition.getRelation())){
                System.out.println(">>>>> Or 开始");
                for(NodeCondition childCondition : condition.getChildren()){
                    boolean flag = condition3(childCondition,resultMap);
                    if(flag){
                        //记录关系节点日志
//                        conditionContext.addConditionItem(new ConditionContextItemBO(condition.getId(),condition.getType(),condition.getRelation(),conditionParentId,true));
                        System.out.println(">>>>> Or 截止 true");
                        return true;
                    }
                }
                //记录关系节点日志
//                conditionContext.addConditionItem(new ConditionContextItemBO(condition.getId(),condition.getType(),condition.getRelation(),conditionParentId,false));
                System.out.println(">>>>> Or 截止 false");
                return false;
            }
            return false;
        }
    }



    /**
     * 判断属性条件
     * */
    private boolean condition_property(XXRuleContext context,ConditionContext conditionContext,NodeCondition condition, Object object,String conditionParentId){
        if(object instanceof PropertyConditionBaseBean){
            PropertyConditionBaseBean property=(PropertyConditionBaseBean)object;
            return this.condition_property_Base(context,conditionContext,condition,property,conditionParentId);
        }else if(object instanceof PropertyConditionHealthBean){
            PropertyConditionHealthBean property=(PropertyConditionHealthBean)object;
            return this.condition_property_Health(context,conditionContext,condition,property,conditionParentId);
        }else {
            throw new BusinessException(BusinessBaseErrorEnum.Run_Rule_ERROR,"不支持的条件属性配置");
        }
    }

    /**
     *  判断属性条件 - 基础
     * */
    private boolean condition_property_Base(XXRuleContext context,ConditionContext conditionContext,NodeCondition condition, PropertyConditionBaseBean property,String conditionParentId){
        //操作符对象
        XXOperate xxOperate= XXOperateFactory.getInstall(property.getOp());
        //左值
        Object leftValObj= context.getRoam().get(property.getVarCode());
        //比较操作
        boolean flag= xxOperate.operate(property.getVarType(),
                leftValObj,
                PropertyBaseGetUtils.getValueBeanObj(context,property.getVarType(),property.getOvo()),
                PropertyBaseGetUtils.getValueBeanObj(context,property.getVarType(),property.getOvt()),
                PropertyBaseGetUtils.getValueBeanList(context,property.getVarType(),property.getOvs())
        );
        //todo:条件路径日志
        return flag;
    }

    /**
     *  判断属性条件 - 健康
     * */
    private boolean condition_property_Health(XXRuleContext context,ConditionContext conditionContext,NodeCondition condition, PropertyConditionHealthBean property,String conditionParentId){
        boolean flag= XXHOperateUtils.operate(context,conditionContext,condition,property,conditionParentId);
        return flag;
    }


    /**
     * 判断方法条件 - [不支持]
     * */
    private boolean condition_method(XXRuleContext context,ConditionContext conditionContext, MethodBaseBean method){
        //todo:未实现
        return true;
    }








}
