package com.xxh.cloud.rule.core.executor.condition.process;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.rule.core.constant.ConditionNodeTypeEnum;
import com.xxh.cloud.rule.core.constant.ValueTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.context.XXRuleVariable2NodeBO;
import com.xxh.cloud.rule.core.entity.base.*;
import com.xxh.cloud.rule.core.executor.condition.context.ConditionContext;

/**
 * 条件节点处理-获取条件中的变量
 * 遍历所有条件节点，获取条件中的变量
 * */
public class DefaultConditionNodeVariableProcess extends AbstractConditionNodeProcess{


    @Override
    public boolean process(XXRuleContext context ,ConditionContext conditionContext, String nodeId, String nodeName, String nodeType, String nodeRuleType, NodeCondition condition) {
        XXRuleVariable2NodeBO ruleVariable2Node=new XXRuleVariable2NodeBO(nodeId,nodeType,nodeRuleType);
        this.handle(context,ruleVariable2Node,condition);
        context.getVariable().put(nodeId,ruleVariable2Node);
        return true;
    }


    /**
     *  遍历条件,获取变量
     * */
    private void handle(XXRuleContext context,XXRuleVariable2NodeBO ruleVariable2Node,NodeCondition condition){
        if(ConditionNodeTypeEnum.Property.getCode().equals(condition.getType())){
             this.process_condition_property(context,ruleVariable2Node,condition.getProperty()); //属性条件
        } else if(ConditionNodeTypeEnum.Relation.getCode().equals(condition.getType())){ //关系
            for(NodeCondition childCondition: condition.getChildren()){
                handle(context,ruleVariable2Node,childCondition);
            }
        }
    }

    /**
     * 基础属性条件
     * */
    private void process_condition_property(XXRuleContext context, XXRuleVariable2NodeBO ruleVariable2Node, PropertyConditionBaseBean property){
        ruleVariable2Node.addVarByConditon("","",property.getVarType(),property.getVarCode(),property.getVarName());
        if(ValueTypeEnum.VT_Variable.getCode().equals(property.getVarType())){
            if(property.getOvo()!=null){
                ruleVariable2Node.addVarByConditon(null,null,null,property.getOvo().getVal(),property.getOvo().getMemo());
            }
        }
    }


    /**
     * 健康属性条件
     * */
    private void process_condition_property(XXRuleContext context, XXRuleVariable2NodeBO ruleVariable2Node, PropertyConditionHealthBean property){
        ruleVariable2Node.addVarByConditon(property.getMdTypeName(),property.getMdTypeCode(),ValueTypeEnum.VT_Variable.getCode(),property.getMdCode(),property.getMdName());
    }





}
