package com.xxh.cloud.rule.core.executor.data;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.rule.core.constant.ValueTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.entity.base.ValueBean;

import java.util.ArrayList;
import java.util.List;

/**
 * 基础数据获取
 * */
public class PropertyBaseGetUtils {




    /**
     *  转移到工具类中：单值
     * */
    public static Object getValueBeanObj(XXRuleContext context, String dataType, ValueBean val){
        if(val==null){
            return null;
        }
        if(StrUtil.isEmpty(val.getVal())){
            return val.getVal();
        }

        if(ValueTypeEnum.VT_Fixed.getCode().equals(dataType)){
            return val.getVal();
        }else {
            return context.getRoam().equals(val.getVal());
        }
    }



    /**
     *  转移到工具类中：多值
     * */
    public static List<Object> getValueBeanList(XXRuleContext context, String dataType, List<ValueBean>  vals){
        if(CollUtil.isEmpty(vals)){
            return null;
        }
        List<Object> data=new ArrayList<>();
        for(ValueBean val:vals){
            Object dataVal=getValueBeanObj(context,dataType,val);
            if(dataVal!=null){
                data.add(dataVal);
            }
        }
        return data;
    }




}
