package com.xxh.cloud.rule.core.executor.method;

import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteDTO;
import com.xxh.cloud.rule.core.constant.MethodExecuteWayEnum;
import com.xxh.cloud.rule.core.context.XXRuleNodeLogBean;
import com.xxh.cloud.rule.core.entity.base.MethodBaseBean;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.executor.method.process.*;

import java.util.Date;

public class MethodExecutor {




    /**
     * 获取方法执行器
     * */
    public static InferenceMethodNodeExecuteProcess getInstallExecute(){
        return  new InferenceMethodNodeExecuteProcess();
    }



    /**
     * 执行方法
     * */
    public static boolean processExecute(XXRuleContext context, String nodeId, String nodeName, String nodeType, String nodeRuleType,MethodBaseBean method){
        //节点执行时间= 节点执行结束时间 - 节点执行开始时间
        Date startDate= new Date();
        InferenceMethodNodeExecuteProcess process= MethodExecutor.getInstallExecute();
        MethodExecuteDTO methodExecuteDTO=process.doResult(context,nodeId,nodeName,nodeType,nodeRuleType,method);
        Date endDate= new Date();

        if(MethodExecuteWayEnum.MEW_Call==context.getMethodExecuteWay()){
            call(context,nodeId,nodeName,nodeType,methodExecuteDTO);
        }else if(MethodExecuteWayEnum.MEW_MQ==context.getMethodExecuteWay()){
            mq(context,nodeId,nodeName,nodeType,methodExecuteDTO);
        }else {
            context.addReturnMethod(methodExecuteDTO);
        }
        //记录条件节点执行日志
        context.addNodeLog(new XXRuleNodeLogBean(nodeId,nodeName,nodeType,nodeRuleType,startDate,endDate,methodExecuteDTO));
        return true;
    }

    private static void call(XXRuleContext context, String nodeId, String nodeName, String nodeType, MethodExecuteDTO param){
        //todo:
        context.getMethodExecuteByCallApi().process(param);
    }

    private static void mq(XXRuleContext context, String nodeId, String nodeName, String nodeType, MethodExecuteDTO param){
        //todo:
        context.getMethodExecuteByMQApi().process(param);
    }















}
