package com.xxh.cloud.rule.core.executor.method.process;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.map.MapUtil;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteDTO;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteParamDTO;
import com.xxh.cloud.rule.core.constant.ValueTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.core.entity.base.MethodBaseBean;
import com.xxh.cloud.rule.core.entity.base.MethodBaseParamBean;
import com.xxh.cloud.rule.core.executor.method.utils.MethodExecuteUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Map;

/**
 * 推理引擎动作方法执行
 * */
public class InferenceMethodNodeExecuteProcess{

    private static final Logger logger = LoggerFactory.getLogger(InferenceMethodNodeExecuteProcess.class);

    public MethodExecuteDTO doResult(XXRuleContext context, String nodeId, String nodeName, String nodeType, String nodeRuleType, MethodBaseBean method) {
        MethodExecuteDTO methodExecute=new MethodExecuteDTO(context.getRuleId(),nodeId,context.getTraceId(),method.getActionId(),method.getMethodCode());
        for(MethodBaseParamBean param : method.getParams()){
            MethodExecuteParamDTO methodExecuteParamDTO=  MethodExecuteUtils.getMethodExecuteParam(context.getRoam(),param);
            methodExecute.addParam(methodExecuteParamDTO);
        }
        return methodExecute;
    }




}
