package com.xxh.cloud.rule.core.executor.method.process;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.rule.core.constant.ValueTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.context.XXRuleVariable2NodeBO;
import com.xxh.cloud.rule.core.entity.base.MethodBaseBean;
import com.xxh.cloud.rule.core.entity.base.MethodBaseParamBean;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 方法参数获取执行
 * */
public class VariableMethodNodeProcess {

    private static final Logger logger = LoggerFactory.getLogger(VariableMethodNodeProcess.class);


    public boolean doResult(XXRuleContext context, String nodeId, String nodeName, String nodeType, String nodeRuleType, MethodBaseBean method) {
        XXRuleVariable2NodeBO ruleVariable2Node=new XXRuleVariable2NodeBO(nodeId,nodeType,nodeRuleType);

        if(CollUtil.isEmpty(method.getParams())){
            return true;
        }

        for(MethodBaseParamBean param : method.getParams()){
            if(ValueTypeEnum.VT_Variable.getCode().equals(param.getOvtype()) || ValueTypeEnum.VT_Constant.getCode().equals(param.getOvtype()) ){
                if(param.getOvo()!=null){
                    ruleVariable2Node.addVarByMethod(
                            method.getActionId(),
                            method.getMethodCode(),
                            param.getOvtype(),
                            param.getOvo().getVal(),
                            param.getOvo().getMemo()
                    );
                }
            }
        }

        context.getVariable().put(nodeId,ruleVariable2Node);
        return true;
    }


}
