package com.xxh.cloud.rule.core.executor.workflow;

import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteDTO;
import com.xxh.cloud.rule.basic.api.bean.dto.WorkFlowNodeExecuteDTO;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.context.XXRuleNodeLogBean;
import com.xxh.cloud.rule.core.entity.base.MethodBaseBean;
import com.xxh.cloud.rule.core.entity.base.NodeMethod;
import com.xxh.cloud.rule.core.entity.flow.XXFlowNodeBO;
import com.xxh.cloud.rule.core.executor.method.process.WorkFlowMethodNodeExecuteProcess;
import io.swagger.annotations.ApiModelProperty;
import jdk.nashorn.internal.runtime.regexp.JoniRegExp;

import java.util.Date;

public class WorkFlowExecutor {

    /**
     * 获取方法执行器
     * */
    public static WorkFlowMethodNodeExecuteProcess getInstallExecute(){
        return  new WorkFlowMethodNodeExecuteProcess();
    }



    /**
     * 执行方法
     * */
    public static boolean processWorkFlow(XXRuleContext context, String nodeId, String nodeType,String nodeRuleType,String nodeName,
                                          String nodeContent,String prevNodeId , NodeMethod action){
        //节点执行时间= 节点执行结束时间 - 节点执行开始时间
        Date startDate= new Date();
        WorkFlowMethodNodeExecuteProcess process= WorkFlowExecutor.getInstallExecute();
        WorkFlowNodeExecuteDTO workFlowExecuteDTO=process.doResult(context,nodeId,nodeType,nodeRuleType,nodeName,nodeContent,prevNodeId,action);
        Date endDate= new Date();

        //判断是否执行下个节点
        boolean nextFlag=false;
         if(YN.YES.getCode().equals(workFlowExecuteDTO.getIsTrigger())){
             nextFlag=false;
         }else {
             nextFlag=true;
         }

//        if(YN.YES.getCode().equals(workFlowExecuteDTO.getIsExecutor())){
//            nextFlag=false;
//        }else {
//            if(YN.YES.getCode().equals(workFlowExecuteDTO.getIsTrigger())){
//                nextFlag=false;
//            }else {
//                nextFlag=true;
//            }
//        }

        //返回节点信息
        context.addReturnWorkFlowNode(workFlowExecuteDTO);

        //记录条件节点执行日志
        context.addNodeLog(new XXRuleNodeLogBean(nodeId,nodeName,nodeType,nodeRuleType,startDate,endDate,workFlowExecuteDTO,true));
        return nextFlag;
    }








}
