package com.xxh.cloud.rule.execute.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 工作流任务表
 * </p>
 *
 * @author anros
 * @since 2023-09-17
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_flow_task_info")
public class FlowTaskInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 紧急程度
     */
     @ApiModelProperty(value = "紧急程度")
      private String flowUrgent;

    /**
     * 重要等级
     */
     @ApiModelProperty(value = "重要等级")
      private String grade;

    /**
     * 项目编号
     */
     @ApiModelProperty(value = "项目编号")
      private String projectCode;

    /**
     * 流程规则配置ID
     */
     @ApiModelProperty(value = "流程规则配置ID")
      private String ruleFlowId;

    /**
     * 流程规则名称
     */
     @ApiModelProperty(value = "流程规则名称")
      private String ruleFlowName;

    /**
     * 流程规则分类ID
     */
     @ApiModelProperty(value = "流程规则分类ID")
      private String ruleFlowCategoryId;

    /**
     * 流程规则版本号
     */
     @ApiModelProperty(value = "流程规则版本号")
      private Integer ruleFlowVersion;

    /**
     * 流程规则业务分类
     */
     @ApiModelProperty(value = "流程规则业务分类")
      private String ruleFlowBizType;

    /**
     * 流程开始时间
     */
     @ApiModelProperty(value = "流程开始时间")
      private Date startTime;

    /**
     * 流程截止时间
     */
     @ApiModelProperty(value = "流程截止时间")
      private Date endTime;

    /**
     * 流程状态
     */
     @ApiModelProperty(value = "流程状态")
      private String status;

    /**
     * 完成情况
     */
     @ApiModelProperty(value = "完成情况")
      private Integer completion;

    /**
     * 描述
     */
     @ApiModelProperty(value = "描述")
      private String description;

    /**
     * 当前步骤节点编号
     */
     @ApiModelProperty(value = "当前步骤节点编号")
      private String thisStepNo;

    /**
     * 当前步骤节点名称
     */
     @ApiModelProperty(value = "当前步骤节点名称")
      private String thisStepName;

    /**
     * 当前步骤任务ID
     */
     @ApiModelProperty(value = "当前步骤任务ID")
      private String thisStepId;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientUserId;

    /**
     * 逻辑删除标记(Y:正常,N:删除)
     */
     @ApiModelProperty(value = "逻辑删除标记(Y:正常,N:删除)")
      private String rowsStatus;


}
