package com.xxh.cloud.rule.execute.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 工作流步骤节点任务表
 * </p>
 *
 * @author anros
 * @since 2023-09-17
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_flow_task_node_info")
public class FlowTaskNodeInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
    private String id;

    /**
     * 任务ID
     */
    @ApiModelProperty(value = "任务ID")
    private String taskId;


    @ApiModelProperty(value = "流程规则配置ID")
    private String ruleFlowId;

    /**
     * 节点编码
     */
    @ApiModelProperty(value = "节点编码")
    private String nodeCode;

    /**
     * 节点名称
     */
    @ApiModelProperty(value = "节点名称")
    private String nodeName;

    /**
     * 节点类型
     */
    @ApiModelProperty(value = "节点类型")
    private String nodeType;

    /**
     * 节点规则类型
     */
    @ApiModelProperty(value = "节点规则类型")
    private String nodeRuleType;

    /**
     * 节点完成进度
     */
    @ApiModelProperty(value = "节点完成进度")
    private Integer nodeAdvanceRatio;

    /**
     * 节点审批方式
     */
    @ApiModelProperty(value = "节点审批方式")
    private String nodeCheckWay;

    /**
     * 节点会签比例
     */
    @ApiModelProperty(value = "节点会签比例")
    private Integer nodeCheckRatio;

    /**
     * 上一节点
     */
    @ApiModelProperty(value = "上一节点")
    private String nodeUp;

    /**
     * 下一节点
     */
    @ApiModelProperty(value = "下一节点")
    private String nodeNext;

    /**
     * 描述
     */
    @ApiModelProperty(value = "描述")
    private String description;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;

    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startTime;

    /**
     * 截止时间
     */
    @ApiModelProperty(value = "截止时间")
    private Date endTime;

    /**
     * 是否定时触发
     */
    @ApiModelProperty(value = "是否定时触发")
    private String isCronTrigger;

    /**
     * 定时触发配置
     */
    @ApiModelProperty(value = "定时触发配置")
    private String triggerConfig;

    @ApiModelProperty(value = "定时触发执行状态")
    private String triggerStatus;

    @ApiModelProperty(value = "定时触发时间列表")
    private String triggerDateList;

    @ApiModelProperty(value = "定时触发已执行时间列表")
    private String triggerDateListYes;

    @ApiModelProperty(value = "定时触发未执行时间列表")
    private String triggerDateListNo;

    @ApiModelProperty(value = "定时触发开始时间")
    private Date triggerDateStart;

    @ApiModelProperty(value = "定时触发截止时间")
    private Date triggerDateEnd;

    /**
     * 执行动作配置
     */
    @ApiModelProperty(value = "执行动作配置")
    private String actionConfig;

    /**
     * 发起人用户ID
     */
    @ApiModelProperty(value = "发起人用户ID")
    private String startUserId;

    /**
     * 是否有执行人
     */
    @ApiModelProperty(value = "是否有执行人")
    private String isExecuteUser;

    /**
     * 所有执行人用户ID
     */
    @ApiModelProperty(value = "所有执行人用户ID")
    private String executeUserIds;

    /**
     * 已执行人用户ID
     */
    @ApiModelProperty(value = "已执行人用户ID")
    private String executeYesUserIds;

    /**
     * 待执行人用户ID
     */
    @ApiModelProperty(value = "待执行人用户ID")
    private String executeNoUserIds;


}
