package com.xxh.cloud.rule.execute.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 工作流任务处理信息表
 * </p>
 *
 * @author anros
 * @since 2023-09-17
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_flow_task_operator_info")
public class FlowTaskOperatorInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 任务ID
     */
     @ApiModelProperty(value = "任务ID")
      private String taskId;

    /**
     * 任务步骤ID
     */
     @ApiModelProperty(value = "任务步骤ID")
      private String taskNodeId;

    /**
     * 节点编码
     */
     @ApiModelProperty(value = "节点编码")
      private String nodeCode;

    /**
     * 节点名称
     */
     @ApiModelProperty(value = "节点名称")
      private String nodeName;

    /**
     * 节点类型
     */
     @ApiModelProperty(value = "节点类型")
      private String nodeType;

    /**
     * 处理人ID
     */
     @ApiModelProperty(value = "处理人ID")
      private String handleUserId;

    /**
     * 处理状态
     */
     @ApiModelProperty(value = "处理状态")
      private String handleStatus;

    /**
     * 处理时间
     */
     @ApiModelProperty(value = "处理时间")
      private Date handleTime;

    /**
     * 处理意见
     */
     @ApiModelProperty(value = "处理意见")
      private String handleRemark;

    /**
     * 处理附件
     */
     @ApiModelProperty(value = "处理附件")
      private String handleAttachment;

    /**
     * 处理回退节点
     */
     @ApiModelProperty(value = "处理回退节点")
      private String handleReturnNode;

    /**
     * 处理转交人用户ID
     */
     @ApiModelProperty(value = "处理转交人用户ID")
      private String handleTransferUserIds;

    /**
     * 处理抄送人用户ID
     */
     @ApiModelProperty(value = "处理抄送人用户ID")
      private String handleCopyUserIds;

    /**
     * 描述
     */
     @ApiModelProperty(value = "描述")
      private String description;

    /**
     * 草稿数据
     */
     @ApiModelProperty(value = "草稿数据")
      private String draftData;


}
