package com.xxh.cloud.rule.execute.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 规则推理日志主信息表
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("r_rule_inference_execute_main_log")
public class RuleInferenceExecuteMainLog extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者ID
     */
     @ApiModelProperty(value = "患者ID")
      private String patientId;

    /**
     * 流程规则配置ID
     */
     @ApiModelProperty(value = "流程规则配置ID")
      private String ruleId;

    /**
     * 流程规则名称
     */
     @ApiModelProperty(value = "流程规则名称")
      private String ruleName;

    /**
     * 流程规则分类ID
     */
     @ApiModelProperty(value = "流程规则分类ID")
      private String ruleCategoryId;

    /**
     * 流程规则版本号
     */
     @ApiModelProperty(value = "流程规则版本号")
      private Integer ruleVersion;



    /**
     * 操作开始时间
     */
     @ApiModelProperty(value = "操作开始时间")
      private Date startDate;


    /**
     * 操作结束时间
     */
    @ApiModelProperty(value = "操作结束时间")
    private Date endDate;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Integer timeNum;

    /**
     * 调用方式
     */
     @ApiModelProperty(value = "调用方式")
      private String callWay;

    /**
     * 调用人
     */
     @ApiModelProperty(value = "调用人")
      private String caller;


}
