package com.xxh.cloud.rule.execute.framework.modules.cache.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import com.xxh.cloud.rule.core.entity.flow.XXFlowRuleBO;
import com.xxh.cloud.rule.execute.framework.modules.cache.RuleWorkFlowCacheService;
import com.xxh.cloud.rule.execute.framework.modules.meta.service.FlowRuleConfigGetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

@Service
public class RuleWorkFlowCacheServiceImpl implements RuleWorkFlowCacheService {

    @Autowired
    private FlowRuleConfigGetService flowRuleConfigGetService;

    @Autowired
    private RedisUtils redisUtils;

    @Override
    public XXFlowRuleBO getWorkFlowRule(String ruleConfigId) {
        //todo:待实现，用缓存
        return this.getWorkFlowRule2DB(ruleConfigId);
    }

    @Override
    public Map<String, XXFlowRuleBO> getWorkFlowRuleMap(List<String> ruleConfigIds) {
        //todo:待实现，用缓存
        return this.getWorkFlowRuleMap2DB(ruleConfigIds);
    }

    @Override
    public List<XXFlowRuleBO> getWorkFlowRuleList(List<String> ruleConfigIds) {
        //todo:待实现，用缓存
        return this.getWorkFlowRuleList2DB(ruleConfigIds);
    }

    @Override
    public void removeWorkFlowRule(String ruleConfigId, String bizType) {
        //todo:待实现
    }

    @Override
    public List<String> getWorkFlowRuleId2InferenceNot(Set<String> notExistIds) {
        //todo:待实现，用缓存
        return this.getWorkFlowRuleId2InferenceNot2DB(notExistIds);
    }

    @Override
    public List<String> getWorkFlowRuleId2WorkFlowNot(Set<String> notExistIds) {
        //todo:待实现，用缓存
        return this.getWorkFlowRuleId2WorkFlowNot2DB(notExistIds);
    }

    @Override
    public List<String> getWorkFlowRuleId2EventWorkFlowNot(Set<String> notExistIds) {
        //todo:待实现，用缓存
        return this.getWorkFlowRuleId2EventWorkFlowNot2DB(notExistIds);
    }


    @Override
    public XXFlowRuleBO getWorkFlowRule2DB(String ruleConfigId) {
        return flowRuleConfigGetService.getById(ruleConfigId);
    }

    @Override
    public Map<String, XXFlowRuleBO> getWorkFlowRuleMap2DB(List<String> ruleConfigIds) {
        return null;
    }

    @Override
    public List<XXFlowRuleBO> getWorkFlowRuleList2DB(List<String> ruleConfigIds) {
        return flowRuleConfigGetService.getListByIds(ruleConfigIds);
    }


    @Override
    public List<String> getWorkFlowRuleId2InferenceNot2DB(Set<String> notExistIds) {
        List<String> data=this.getWorkFlowRuleId2Inference2DB();
        if(CollUtil.isNotEmpty(notExistIds)){
            data.removeAll(notExistIds);
        }
        return data;
    }

    @Override
    public List<String> getWorkFlowRuleId2WorkFlowNot2DB(Set<String> notExistIds) {
        List<String> data=this.getWorkFlowRuleId2WorkFlow2DB();
        if(CollUtil.isNotEmpty(notExistIds)){
            data.removeAll(notExistIds);
        }
        return data;
    }

    @Override
    public List<String> getWorkFlowRuleId2EventWorkFlowNot2DB(Set<String> notExistIds) {
        List<String> data=this.getWorkFlowRuleId2EventWorkFlow2DB();
        if(CollUtil.isNotEmpty(notExistIds)){
            data.removeAll(notExistIds);
        }
        return data;
    }


    @Override
    public List<String> getWorkFlowRuleId2Inference2DB() {
        List<String> data=new ArrayList<>();
        List<XXFlowRuleBO> list= flowRuleConfigGetService.getByBizType2Inference();
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                data.add(item.getId());
            });
        }
        return data;
    }

    @Override
    public List<String> getWorkFlowRuleId2WorkFlow2DB() {
        List<String> data=new ArrayList<>();
        List<XXFlowRuleBO> list= flowRuleConfigGetService.getByBizType2WorkFlow();
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                data.add(item.getId());
            });
        }
        return data;
    }

    @Override
    public List<String> getWorkFlowRuleId2EventWorkFlow2DB() {
        List<String> data=new ArrayList<>();
        List<XXFlowRuleBO> list= flowRuleConfigGetService.getByBizType2EventWorkFlow();
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                data.add(item.getId());
            });
        }
        return data;
    }

    @Override
    public List<String> getWorkFlowRuleId2EventWorkFlow2DB(String eventId) {
        List<String> data=new ArrayList<>();
        List<XXFlowRuleBO> list= flowRuleConfigGetService.getByBizType2EventWorkFlow(eventId);
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                data.add(item.getId());
            });
        }
        return data;
    }


}
