package com.xxh.cloud.rule.execute.framework.modules.client.convert;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteParamDTO;
import com.xxh.cloud.rule.execute.framework.modules.rule.bean.vos.ExecuteActionMethodBO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.vos.Execute2WorkFlowByReturnVO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.ClientActionMethodBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.ClientActionMethodParamBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteResultBO;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;

public class WorkFlowExecuteResultConvert {

    public static WorkFlowExecuteResultBO getWorkFlowExecuteResultBO(Execute2WorkFlowByReturnVO entity){
        WorkFlowExecuteResultBO data=new WorkFlowExecuteResultBO();
        BeanUtil.copyProperties(entity,data,"method");
        data.setMethod(getClientActionMethodBO(entity.getMethod()));
        return data;
    }


    public static ClientActionMethodBO getClientActionMethodBO(ExecuteActionMethodBO entity){
        if(entity==null){
            return null;
        }
        ClientActionMethodBO data=new ClientActionMethodBO();
        BeanUtil.copyProperties(entity,data,"p");

        if(CollUtil.isNotEmpty(entity.getP())){
            entity.getP().forEach(item->{
                data.addParam(getClientActionMethodParamBO(item));
            });
        }

        return data;
    }

    public static ClientActionMethodParamBO getClientActionMethodParamBO(MethodExecuteParamDTO entity){
        ClientActionMethodParamBO data=new ClientActionMethodParamBO();
        data.setParamCode(entity.getParamCode());
        data.setParamName(entity.getParamName());
        data.setParamType(entity.getParamType());
        data.setVal(entity.getVal());
        data.setValList(entity.getValList());
        return data;
    }





}
