package com.xxh.cloud.rule.execute.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.rule.execute.framework.modules.client.convert.WorkFlowExecuteResultConvert;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.ros.PatientExeRuleIdRO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.vos.Execute2WorkFlowByReturnVO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.service.FlowStartProcessWorkFlowService;
import com.xxh.cloud.rule.execute.framework.modules.workflow.service.FlowTaskExecuteQueryService;
import com.xxh.cloud.rule.execute.inference.client.api.RuleExecute2EventClientService;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.EventNodeTaskResultBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteProcessAllResultBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteResultBO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.EventFlowExecuteByEventDTO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.EventFlowExecuteByRuleDTO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.WorkFlowExecuteByRuleDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;


@Service
public class RuleExecute2EventClientServiceImpl implements RuleExecute2EventClientService {


    @Autowired
    private FlowStartProcessWorkFlowService flowStartProcessWorkFlowService;

    @Autowired
    private FlowTaskExecuteQueryService flowTaskExecuteQueryService;


    @Override
    public List<WorkFlowExecuteResultBO> startExecute(EventFlowExecuteByEventDTO params) {
        List<WorkFlowExecuteResultBO> data=new ArrayList<>();
        List<String> ids= flowTaskExecuteQueryService.getEventFlowListByEventId(params.getEventId());
        if(CollUtil.isEmpty(ids)){
            return data;
        }
        for(String ruleConfigId:ids){
            List<Execute2WorkFlowByReturnVO> list= flowStartProcessWorkFlowService.executeByReturn(ruleConfigId,params.getData(),false,"",params.getOpUserId());
            if(CollUtil.isNotEmpty(list)){
                list.forEach(item->{
                    data.add(WorkFlowExecuteResultConvert.getWorkFlowExecuteResultBO(item));
                });
            }
        }
        return data;
    }

    @Override
    public List<WorkFlowExecuteResultBO> startExecuteByRule(EventFlowExecuteByRuleDTO params) {
        List<WorkFlowExecuteResultBO> data=new ArrayList<>();
        List<Execute2WorkFlowByReturnVO> list= flowStartProcessWorkFlowService.executeByReturn(params.getRuleConfigId(),params.getData(),false,"",params.getOpUserId());
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            data.add(WorkFlowExecuteResultConvert.getWorkFlowExecuteResultBO(item));
        });
        return data;
    }




}
