package com.xxh.cloud.rule.execute.framework.modules.client.service;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.execute.framework.modules.client.convert.RuleExecute2InferenceConvert;
import com.xxh.cloud.rule.execute.framework.modules.rule.bean.vos.ExecuteByReturnVO;
import com.xxh.cloud.rule.execute.framework.modules.rule.service.RuleInferenceExecutorService;
import com.xxh.cloud.rule.execute.inference.client.api.RuleExecute2InferenceClientService;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.InferenceExecuteMethodBO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.InferenceExecuteBy2MQDTO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.InferenceExecuteBy2OnCallDTO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.InferenceExecuteBy2OnMQDTO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.InferenceExecuteBy2ReturnDTO;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Log4j2
@Service
public class RuleExecute2InferenceClientServiceImpl implements RuleExecute2InferenceClientService {



    @Autowired
    private RuleInferenceExecutorService ruleInferenceExecutorService;


    @Override
    public List<InferenceExecuteMethodBO> executeById2Return(InferenceExecuteBy2ReturnDTO params) {
        ValidatorUtils.validateEntity(params);
        List<InferenceExecuteMethodBO> data=new ArrayList<>();
        List<ExecuteByReturnVO> exeMethodList= ruleInferenceExecutorService.executeByReturn(
                params.getRuleId(),
                params.getData(),
                true,
                params.getOpWay()==null?null:params.getOpWay().getCode(),
                params.getOpUserId());
        if(CollUtil.isEmpty(exeMethodList)){
            return data;
        }
        exeMethodList.forEach(item->{
            data.add(RuleExecute2InferenceConvert.convertInferenceExecuteMethod(item));
        });
        return data;
    }

    @Override
    public void executeById2OnCall(InferenceExecuteBy2OnCallDTO params) {
        ValidatorUtils.validateEntity(params);
        ruleInferenceExecutorService.executeByCall(
                params.getRuleId(),
                params.getData(),
                true,
                params.getApi(),
                params.getOpWay()==null?null:params.getOpWay().getCode(),
                params.getOpUserId());
    }

    @Override
    public void executeById2OnMQ(InferenceExecuteBy2OnMQDTO params) {
        ValidatorUtils.validateEntity(params);
        ruleInferenceExecutorService.executeByMQ(
                params.getRuleId(),
                params.getData(),
                true,
                params.getApi(),
                params.getOpWay()==null?null:params.getOpWay().getCode(),
                params.getOpUserId());
    }

    @Override
    public void executeById2MQ(InferenceExecuteBy2MQDTO params) {
        ValidatorUtils.validateEntity(params);
        ruleInferenceExecutorService.executeByMQ(
                params.getRuleId(),
                params.getData(),
                true,
                params.getOpWay()==null?null:params.getOpWay().getCode(),
                params.getOpUserId());
    }


}
