package com.xxh.cloud.rule.execute.framework.modules.rule.bean.dto;

import com.xxh.cloud.rule.core.context.XXRuleNodeLogBean;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Getter
@Setter
public class InferenceExecutorLogAddDTO {

    /**
     * 规则ID
     * */
    private String ruleId;

    /**
     * 规则名称
     * */
    private String ruleName;

    /**
     * 规则分类[RuleConfigTypeEnum]
     * */
    private String ruleType;

    /**
     * 规则业务分类[RuleConfigBizTypeEnum]
     * */
    private String ruleBizType;

    /**
     * 规则版本号
     * */
    private Integer ruleVersion;

    /**
     * 规则ID
     */
    private String ruleCategoryId;

    /**
     * 患者ID
     */
    private String patientId;


    /**
     * 请求执行ID
     * */
    private String traceId;


    /**
     * 处理开始时间(毫秒)
     * */
    private Date requestStartTime;

    /**
     * 处理截止时间(毫秒)
     * */
    private Date requestEndTime;

    /**
     * 处理时间(毫秒)
     * */
    private long requestTime;



    @ApiModelProperty(value = "调用方式")
    private String callWay;

    /**
     * 调用人
     */
    @ApiModelProperty(value = "调用人")
    private String caller;


    /**
     * 节点:日志记录(返回)
     * */
    private List<XXRuleNodeLogBean> nodeLogList;





}
