package com.xxh.cloud.rule.execute.framework.modules.rule.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.IdUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.core.context.XXRuleNodeLogBean;
import com.xxh.cloud.rule.execute.framework.modules.base.entity.RuleInferenceExecuteMainItemLog;
import com.xxh.cloud.rule.execute.framework.modules.base.entity.RuleInferenceExecuteMainLog;
import com.xxh.cloud.rule.execute.framework.modules.base.service.RuleInferenceExecuteMainItemLogService;
import com.xxh.cloud.rule.execute.framework.modules.base.service.RuleInferenceExecuteMainLogService;
import com.xxh.cloud.rule.execute.framework.modules.rule.bean.dto.InferenceExecutorLogAddDTO;
import com.xxh.cloud.rule.execute.framework.modules.rule.service.RuleInferenceExecuteLogSaveBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class RuleInferenceExecuteLogSaveBizServiceImpl implements RuleInferenceExecuteLogSaveBizService {

    @Autowired
    private RuleInferenceExecuteMainLogService ruleInferenceExecuteMainLogService;
    @Autowired
    private RuleInferenceExecuteMainItemLogService ruleInferenceExecuteMainItemLogService;


    @Override
    public void save(InferenceExecutorLogAddDTO params) {
        ValidatorUtils.validateEntity(params);
        RuleInferenceExecuteMainLog mainLog=this.getRuleInferenceExecuteMainLog(params);
        List<RuleInferenceExecuteMainItemLog> itemLogs=new ArrayList<>();
        if(CollUtil.isNotEmpty(params.getNodeLogList())){
            params.getNodeLogList().forEach(item->{
                itemLogs.add(getRuleInferenceExecuteMainItemLog(mainLog.getId(), mainLog.getRuleId(), item));
            });
        }
        ruleInferenceExecuteMainLogService.save(mainLog);
        if(itemLogs.size()>0){
            ruleInferenceExecuteMainItemLogService.saveBatch(itemLogs);
        }
    }

    @Override
    public void saveBatch(List<InferenceExecutorLogAddDTO> list) {
        if(CollUtil.isEmpty(list)){
            return;
        }
        List<RuleInferenceExecuteMainLog> mainLogs=new ArrayList<>();
        List<RuleInferenceExecuteMainItemLog> itemLogs=new ArrayList<>();
        //todo:
    }


    private RuleInferenceExecuteMainLog getRuleInferenceExecuteMainLog(InferenceExecutorLogAddDTO params){
        RuleInferenceExecuteMainLog entity=new RuleInferenceExecuteMainLog();
        entity.setId(params.getTraceId());
        entity.setPatientId(params.getPatientId());
        entity.setRuleId(params.getRuleId());
        entity.setRuleName(params.getRuleName());
        entity.setRuleCategoryId(params.getRuleCategoryId());
        entity.setRuleVersion(params.getRuleVersion());
        entity.setStartDate(params.getRequestStartTime());
        entity.setEndDate(params.getRequestEndTime());
        entity.setTimeNum(Convert.toInt(params.getRequestTime()));
        entity.setCallWay(params.getCallWay());
        entity.setCaller(params.getCaller());
        return entity;
    }

    private RuleInferenceExecuteMainItemLog getRuleInferenceExecuteMainItemLog(String mainLogId,String ruleId, XXRuleNodeLogBean nodeLog){
        RuleInferenceExecuteMainItemLog entity=new RuleInferenceExecuteMainItemLog();
        entity.setId(IdUtil.getSnowflake(1,1).nextIdStr());
        entity.setExeLogId(mainLogId);
        entity.setRuleId(ruleId);
        entity.setNodeId(nodeLog.getNodeId());
        entity.setNodeType(nodeLog.getNodeType());
        entity.setNodeRuleType(nodeLog.getNodeRuleType());
        entity.setNodeExecuteStatus(nodeLog.isFlag()? YN.YES.getCode():YN.NO.getCode());
        if(CollUtil.isNotEmpty(nodeLog.getConditionList())){
            entity.setExecuteResult(JSON.toJSONString(nodeLog.getConditionList()));
        }
        if(nodeLog.getMethodResult()!=null){
            entity.setExecuteResult(JSON.toJSONString(nodeLog.getMethodResult()));
        }
        entity.setStartTime(nodeLog.getStart());
        entity.setStartDate(nodeLog.getEnd());
        entity.setTimeNum(Convert.toInt(nodeLog.getTimeNum()));
        return entity;
    }




}
