package com.xxh.cloud.rule.execute.framework.modules.rule.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.metadata.client.api.StandardKeywordsClientService;
import com.xxh.cloud.metadata.client.api.bean.bos.standard.StandardKeywordsBO;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.core.entity.flow.XXFlowRuleBO;
import com.xxh.cloud.rule.basic.api.MethodExecuteByCallApi;
import com.xxh.cloud.rule.basic.api.MethodExecuteByMQApi;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteDTO;
import com.xxh.cloud.rule.execute.framework.modules.action.service.MethodExecuteMQService;
import com.xxh.cloud.rule.execute.framework.modules.cache.RuleInferenceCacheService;
import com.xxh.cloud.rule.execute.framework.modules.rule.bean.dto.InferenceExecutorLogAddDTO;
import com.xxh.cloud.rule.execute.framework.modules.rule.bean.vos.ExecuteByReturnVO;
import com.xxh.cloud.rule.execute.framework.modules.rule.service.RuleInferenceExecuteLogSaveBizService;
import com.xxh.cloud.rule.execute.framework.modules.rule.service.RuleInferenceExecutorService;
import com.xxh.cloud.rule.flow.executor.XXRuleFlowExecutor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class RuleInferenceExecutorServiceImpl implements RuleInferenceExecutorService {

    @Autowired
    private RuleInferenceCacheService ruleInferenceCacheService;
    @Autowired
    private StandardKeywordsClientService standardKeywordsClientService;
    @Autowired
    private RuleInferenceExecuteLogSaveBizService ruleInferenceExecuteLogSaveBizService;
    @Autowired
    private MethodExecuteMQService methodExecuteMQService;



    private InferenceExecutorLogAddDTO getInferenceExecutorLogAddDTO(String callWay,String callUserId,XXRuleContext context){
        String patientId= context.getRoam().getPatientId();
        InferenceExecutorLogAddDTO addDTO=new InferenceExecutorLogAddDTO();
        addDTO.setRuleId(context.getRuleId());
        addDTO.setRuleName(context.getRuleName());
        addDTO.setRuleType(context.getRuleType());
        addDTO.setRuleBizType(context.getRuleBizType());
        addDTO.setRuleVersion(context.getRuleVersion());
        addDTO.setRuleCategoryId(context.getRuleCategoryId());
        addDTO.setPatientId(patientId);
        addDTO.setTraceId(context.getTraceId());
        addDTO.setRequestStartTime(context.getRequestStartTime());
        addDTO.setRequestEndTime(context.getRequestEndTime());
        addDTO.setRequestTime(context.getRequestTime());
        addDTO.setCallWay(callWay);
        addDTO.setCaller(callUserId);
        addDTO.setNodeLogList(context.getNodeLogList());
        return addDTO;
    }


    private void processInferenceLog_Save(String callWay,String callUserId,XXRuleContext context){
        InferenceExecutorLogAddDTO addDTO=this.getInferenceExecutorLogAddDTO(callWay,callUserId,context);
        ruleInferenceExecuteLogSaveBizService.save(addDTO);
    }

    private void processInferenceLog_MQ(String callWay,String callUserId,XXRuleContext context){
        InferenceExecutorLogAddDTO addDTO=this.getInferenceExecutorLogAddDTO(callWay,callUserId,context);
        //todo:
    }

    private List<ExecuteByReturnVO> processActionMethod(List<MethodExecuteDTO> returnMethodExecuteList){
        //todo:处理返回的方法
        return null;

    }

    @Override
    public  List<ExecuteByReturnVO> executeByReturn(String ruleConfigId, XXRuleRoam data, boolean isLogMQ,String callWay,String callUserId) {
        XXFlowRuleBO ruleConfig = ruleInferenceCacheService.getFlowRule(ruleConfigId);
        XXRuleContext context = XXRuleFlowExecutor.execute(ruleConfig,data,false);
        if(isLogMQ){
            this.processInferenceLog_MQ(callWay,callUserId,context);
        }else {
            this.processInferenceLog_Save(callWay,callUserId,context);
        }
        return this.processActionMethod(context.getReturnMethodExecuteList());
    }

    @Override
    public void executeByCall(String ruleConfigId, XXRuleRoam data, boolean isLogMQ,MethodExecuteByCallApi api,String callWay,String callUserId) {
        XXFlowRuleBO ruleConfig =ruleInferenceCacheService.getFlowRule(ruleConfigId);
        XXRuleContext context= XXRuleFlowExecutor.execute(ruleConfig,data,false);
        if(isLogMQ){
            this.processInferenceLog_MQ(callWay,callUserId,context);
        }else {
            this.processInferenceLog_Save(callWay,callUserId,context);
        }
    }

    @Override
    public void executeByMQ(String ruleConfigId, XXRuleRoam data, boolean isLogMQ, MethodExecuteByMQApi mqApi,String callWay,String callUserId) {
        XXFlowRuleBO ruleConfig =ruleInferenceCacheService.getFlowRule(ruleConfigId);
        XXRuleContext context = XXRuleFlowExecutor.execute(ruleConfig,data,false,mqApi);
        if(isLogMQ){
            this.processInferenceLog_MQ(callWay,callUserId,context);
        }else {
            this.processInferenceLog_Save(callWay,callUserId,context);
        }
    }

    @Override
    public void executeByMQ(String ruleConfigId, XXRuleRoam data, boolean isLogMQ,String callWay,String callUserId) {
        XXFlowRuleBO ruleConfig =ruleInferenceCacheService.getFlowRule(ruleConfigId);
        XXRuleContext context = XXRuleFlowExecutor.execute(ruleConfig,data,false,methodExecuteMQService);
        if(isLogMQ){
            this.processInferenceLog_MQ(callWay,callUserId,context);
        }else {
            this.processInferenceLog_Save(callWay,callUserId,context);
        }
    }


}
