package com.xxh.cloud.rule.execute.framework.modules.workflow.bean.ros;

import cn.hutool.core.util.StrUtil;
import lombok.Getter;
import lombok.Setter;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Getter
@Setter
public class PatientExeRuleIdRO {


    /**
     * 所有规则
     * */
    private List<String> allRuleConfigIds;

    /**
     * 可执行规则 = 所有规则 - 执行中的规则编号 (allRuleConfigIds - exeIngRuleConfigIds)
     * */
    private List<String> exeNotRuleConfigIds;

    /**
     * 执行中的规则编号
     * */
    private Set<String> exeIngRuleConfigIds;


    /**
     * 可执行的节点任务Id[定时]
     * */
    private Set<String> triggerNodeTaskIds;

    public PatientExeRuleIdRO(){

    }

    public void addExeIngRuleId(String exeIngRuleId){
        if(this.exeIngRuleConfigIds==null){
            this.exeIngRuleConfigIds=new HashSet<>();
        }
        if(StrUtil.isNotEmpty(exeIngRuleId)){
            this.exeIngRuleConfigIds.add(exeIngRuleId);
        }
    }

    public void addTriggerNodeTaskId(String triggerNodeTaskId){
        if(this.triggerNodeTaskIds==null){
            this.triggerNodeTaskIds=new HashSet<>();
        }
        if(StrUtil.isNotEmpty(triggerNodeTaskId)){
            this.triggerNodeTaskIds.add(triggerNodeTaskId);
        }
    }


}
