package com.xxh.cloud.rule.execute.framework.modules.workflow.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.rule.basic.api.WorkFlowNodeExecuteByCallApi;
import com.xxh.cloud.rule.basic.api.bean.dto.MethodExecuteDTO;
import com.xxh.cloud.rule.basic.api.bean.dto.WorkFlowNodeExecuteDTO;
import com.xxh.cloud.rule.basic.constant.WorkFlowNodeStatusEnum;
import com.xxh.cloud.rule.core.constant.NodeExecutorType;
import com.xxh.cloud.rule.execute.framework.modules.base.entity.FlowTaskInfo;
import com.xxh.cloud.rule.execute.framework.modules.base.entity.FlowTaskNodeInfo;
import com.xxh.cloud.rule.execute.framework.modules.base.service.FlowTaskInfoService;
import com.xxh.cloud.rule.execute.framework.modules.base.service.FlowTaskNodeInfoService;
import com.xxh.cloud.rule.execute.framework.modules.base.service.FlowTaskOperatorInfoService;
import com.xxh.cloud.user.client.api.DeptClientService;
import com.xxh.cloud.user.client.api.PostInfoClientService;
import com.xxh.cloud.user.client.api.bean.bos.DeptBO;
import com.xxh.cloud.user.client.api.bean.bos.PostInfoBO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class WorkFlowNodeExecuteProcessService implements WorkFlowNodeExecuteByCallApi {


    @Autowired
    private FlowTaskInfoService flowTaskInfoService;

    @Autowired
    private FlowTaskNodeInfoService flowTaskNodeInfoService;

    @Autowired
    private FlowTaskOperatorInfoService flowTaskOperatorInfoService;

    @Autowired
    private PostInfoClientService postInfoClientService;

    @Autowired
    private DeptClientService deptClientService;


    private Set<String> getUserByDept(List<String> deptIds){
        Set<String> data=new HashSet<>();
        List<DeptBO> list = deptClientService.getDeptListByIds(deptIds);
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                if(CollUtil.isNotEmpty(item.getManagerUserIds())){
                    data.addAll(item.getManagerUserIds());
                }
            });
        }
        return data;
    }

    private Set<String> getUserByPost(List<String> postIds){
        Set<String> data=new HashSet<>();
        List<PostInfoBO> list= postInfoClientService.getPostListByIds(postIds);
        if(CollUtil.isNotEmpty(list)){
            list.forEach(item->{
                if(CollUtil.isNotEmpty(item.getUserIds())){
                    data.addAll(item.getUserIds());
                }
            });
        }
        return data;
    }



    private MethodExecuteDTO getMethodExecuteDTO(WorkFlowNodeExecuteDTO params){
        MethodExecuteDTO data=new MethodExecuteDTO();
//        data.setRuleId(params.getRuleId());
//        data.setNodeId(params.getNodeId());
//        data.setNodeName(params.getNodeName());
//        data.setTraceId(params.getTraceId());
//        data.setActionId(params.getActionId());
//        data.setMethodCode(params.getMethodCode());
//        data.setParams(params.getParams());
        return data;
    }


    @Override
    public boolean process(WorkFlowNodeExecuteDTO params) {
        FlowTaskNodeInfo entity=new FlowTaskNodeInfo();
//        entity.setId(IdUtil.getSnowflake(4,1).nextIdStr());
//        entity.setTaskId(params.getTraceId());
//        entity.setNodeCode(params.getNodeId());
//        entity.setNodeName(params.getNodeName());
//        entity.setNodeType(params.getNodeType());
//        entity.setNodeRuleType(params.getNodeRuleType());
//        entity.setNodeAdvanceRatio(params.getAdvanceRatio());
//        entity.setNodeCheckWay(params.getCheckWay());
//        entity.setNodeCheckRatio(params.getCheckRatio());
//        entity.setNodeUp(params.getPreNodeId());
//
//        entity.setStatus(WorkFlowNodeStatusEnum.None.getCode());
//        entity.setStartTime(new Date());
//        entity.setStartUserId(params.getStartUserId()); //发起人用户ID
//
//        Set<String> exeUserIds=new HashSet<>();
//        if(NodeExecutorType.NE_Start.getCode().equals(params.getExecutorType())){
//            exeUserIds.add(params.getStartUserId());
//        }else if(NodeExecutorType.NE_User.getCode().equals(params.getExecutorType())){
//            exeUserIds.addAll(params.getExecutorIds());
//        }else if(NodeExecutorType.NE_Post.getCode().equals(params.getExecutorType())){
//            exeUserIds=this.getUserByPost(params.getExecutorIds());
//        }else if(NodeExecutorType.Check_Director.getCode().equals(params.getExecutorType())){
//            exeUserIds=this.getUserByDept(params.getExecutorIds());
//        }else if(NodeExecutorType.Check_FORM.getCode().equals(params.getExecutorType())){
//            //todo:
//        }
//        entity.setExecuteUserIds(CollUtil.join(exeUserIds,","));
//        entity.setExecuteNoUserIds(entity.getExecuteUserIds());
//
//
//
//        FlowTaskInfo taskInfo=new FlowTaskInfo();
//        taskInfo.setId(entity.getTaskId());
//        taskInfo.setCompletion(params.getAdvanceRatio());
//        taskInfo.setThisStepNo(params.getNodeId());
//        taskInfo.setThisStepName(params.getNodeName());
//        taskInfo.setThisStepId(entity.getId());
//        taskInfo.setEndTime(new Date());
//        flowTaskInfoService.updateById(taskInfo);
//
//
//        if(StrUtil.isNotEmpty(params.getAuto()) && YN.YES.getCode().equals(params.getAuto())){
//            //执行方法
//            MethodExecuteDTO methodExecuteParams= getMethodExecuteDTO(params);
//            params.getMethodApi().process(methodExecuteParams);
//            //自动执行
//            entity.setNodePropertyJson(JSON.toJSONString(methodExecuteParams));
//            entity.setStatus(WorkFlowNodeStatusEnum.Complete.getCode());
//            entity.setEndTime(new Date());
//            flowTaskNodeInfoService.save(entity);
//            return true;
//        }else {
//            //手动执行
//            MethodExecuteDTO methodExecuteDTO= getMethodExecuteDTO(params);
//            entity.setNodePropertyJson(JSON.toJSONString(methodExecuteDTO));
//            flowTaskNodeInfoService.save(entity);
//            return false;
//        }
        return false;
    }

}
