package com.xxh.cloud.rule.execute.framework.modules.workflow.utils;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.constant.DateTimeUnitTypeEnum;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
import com.xxh.cloud.framework.common.utils.XXEnumUtil;
import com.xxh.cloud.rule.core.constant.HealthDateLimitUnitEnum;
import com.xxh.cloud.rule.core.constant.NodeTriggerTypeEnum;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class FlowTaskNodeTriggerUtils {





//    //审核后数量:开始
//    private int s;
//
//    //审核后数量:截止
//    private int e;
//
//    //数量单位 : DateTimeUnitTypeEnum
//    private String u;





    /**
     *  时间单位
     * */
    private static DateTimeUnitTypeEnum getDateTimeUnitTypeEnum(String unitCode){
        Map<String,DateTimeUnitTypeEnum> unitMap= XXEnumUtil.getEnumMap(DateTimeUnitTypeEnum.class);
        DateTimeUnitTypeEnum unit = unitMap.get(unitCode);
        if(unit==null){
            throw new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR,"不支持的时间定义");
        }

        return unit;
    }


    /**
     *
     * */
    public static DateTime getDate(Date date, DateTimeUnitTypeEnum unit, int num){
        switch (unit){
            case DTU_Minute:
                return DateUtil.offsetMinute(date,num);
            case DTU_Hour:
                return DateUtil.offsetHour(date,num);
            case DTU_Day:
                return DateUtil.offsetDay(date,num);
        }
        throw new BusinessException(BusinessBaseErrorEnum.Config_GET_ERROR,"不支持的时间定义");
    }


//    public static List<String> getDataList(int startNum ,int endNum ,String unit,int loopNum ,String loopUnit){
//
//    }
//

    public static FlowTaskNodeTriggerRO getDataList(int startNum ,int endNum ,String unit, String loopType ,int loopNum ,String loopUnit){
        FlowTaskNodeTriggerRO retuenDate=new FlowTaskNodeTriggerRO();

        Date date=new Date();
        DateTimeUnitTypeEnum unitType=getDateTimeUnitTypeEnum(unit);
        Date startDate = getDate(date,unitType,startNum);
        Date endDate = getDate(date,unitType,endNum);


        List<String> returnDateList=new ArrayList<>();

        if(NodeTriggerTypeEnum.NTT_Once.getCode().equals(loopType)){
            returnDateList.add(DateUtil.format(endDate,"yyyyMMddHHmm")) ;
            retuenDate.setDateList(returnDateList);
            retuenDate.setStart(DateUtil.offsetMinute(endDate,-15));
            retuenDate.setEnd(DateUtil.offsetMinute(endDate,15));
            return retuenDate;
        }


        DateTimeUnitTypeEnum loopUnitType=getDateTimeUnitTypeEnum(loopUnit);
        int next=loopNum;

        //returnDateList.add(DateUtil.formatDateTime(startDate));
        returnDateList.add(DateUtil.format(startDate,"yyyyMMddHHmm"));
        retuenDate.addEnd(startDate);
        retuenDate.addStart(startDate);

        while (true){
            Date nextDate= getDate(startDate,loopUnitType,next);
            int compareNum= DateUtil.compare(nextDate,endDate);
            //System.out.println(compareNum);
            if(compareNum<=0){
                returnDateList.add(DateUtil.format(nextDate,"yyyyMMddHHmm"));
                //returnDateList.add(DateUtil.formatDateTime(nextDate));
                next=next+loopNum;
                retuenDate.addEnd(nextDate);
                retuenDate.addStart(nextDate);
            }else {
                retuenDate.setStart(DateUtil.offsetMinute(retuenDate.getStart(),-15));
                retuenDate.setEnd(DateUtil.offsetMinute(retuenDate.getEnd(),15));
                retuenDate.setDateList(returnDateList);
                return retuenDate;
            }
        }
    }

    public static long caltest(String date){
        Date d1=new Date();
        Date d2= DateUtil.parse(date,"yyyyMMddHHmm");
        return   DateUtil.between(d1,d2, DateUnit.MINUTE,true);
    }


    public static void main(String[] args) {

        FlowTaskNodeTriggerRO list= FlowTaskNodeTriggerUtils.getDataList(2,3,DateTimeUnitTypeEnum.DTU_Day.getCode(),
                NodeTriggerTypeEnum.NTT_Loop.getCode(),
                8,DateTimeUnitTypeEnum.DTU_Hour.getCode());

        System.out.println(JSON.toJSONString(list));

        //
       // System.out.println(FlowTaskNodeTriggerUtils.caltest("202311140008"));
    }



}
