package com.xxh.cloud.rule.execute.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.dto.RuleFlowExecuteLogGetByNodeTaskNDTO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.dto.RuleFlowExecuteLogGetByTaskDTO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.dto.RuleFlowExecuteLogGetByTaskIdDTO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.dto.RuleInferenceExecuteMainLogQueryDTO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.vos.RuleFlowExecuteLogVO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.vos.RuleInferenceExecuteMainLogVO;
import com.xxh.cloud.rule.execute.framework.modules.biz.service.RuleFlowExecuteLogBizService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Log4j2
@RestController
@RequestMapping("/sys/rule/flow/log")
@Api(tags = "运营端,流程日志")
public class RuleFlowExecuteLogManagerController {

    @Autowired
    private RuleFlowExecuteLogBizService ruleFlowExecuteLogBizService;

    @SaCheckPermission("sys:rule:flow:log:getByTaskId")
    @PostMapping("/getByTaskId")
    @ApiOperation(value = "获取", response = RuleFlowExecuteLogVO.class)
    public Result<RuleFlowExecuteLogVO> getByTaskId(@RequestBody RuleFlowExecuteLogGetByTaskDTO params) {
        ValidatorUtils.validateEntity(params);
        RuleFlowExecuteLogVO data= ruleFlowExecuteLogBizService.getRuleFlowExecuteLogByTask(params.getTaskId(), params.getNodeCode());
        return new Result<RuleFlowExecuteLogVO>().ok(data);
    }


    @SaCheckPermission("sys:rule:flow:log:getListByTaskId")
    @PostMapping("/getListByTaskId")
    @ApiOperation(value = "获取", response = RuleFlowExecuteLogVO.class)
    public Result<List<RuleFlowExecuteLogVO>> getListByTaskId(@RequestBody RuleFlowExecuteLogGetByTaskDTO params) {
        ValidatorUtils.validateEntity(params);
        List<RuleFlowExecuteLogVO> data= ruleFlowExecuteLogBizService.getRuleFlowExecuteLogListByTask(params.getTaskId(), params.getNodeCode());
        return new Result<List<RuleFlowExecuteLogVO>>().ok(data);
    }



    @SaCheckPermission("sys:rule:flow:log:getListByTaskNodeId")
    @PostMapping("/getListByTaskNodeId")
    @ApiOperation(value = "获取", response = RuleFlowExecuteLogVO.class)
    public Result<List<RuleFlowExecuteLogVO>> getListByTaskNodeId(@RequestBody RuleFlowExecuteLogGetByNodeTaskNDTO params) {
        ValidatorUtils.validateEntity(params);
        List<RuleFlowExecuteLogVO> data= ruleFlowExecuteLogBizService.getRuleFlowExecuteLogListByNodeTask(params.getNodeTaskId());
        return new Result<List<RuleFlowExecuteLogVO>>().ok(data);
    }








}
