package com.xxh.cloud.rule.execute.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.dto.WorkFlowTaskNodeGetDTO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.dto.WorkFlowTaskNodeQueryDTO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.vos.WorkFlowTaskNodeVO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.service.FlowTaskQueryService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

//@SaCheckPermission("sys:rule:treeConfig")
@Log4j2
@RestController
@RequestMapping("/sys/rule/flow/handle")
@Api(tags = "运营端,规则流程处理服务")
public class RuleFlowHandleExecuteManagerController {

    @Autowired
    private FlowTaskQueryService flowTaskQueryService;
//    @Autowired
//    private FlowTaskProcessService flowTaskProcessService;


    @SaCheckPermission("sys:rule:flow:handle:query")
    @PostMapping("/query")
    @ApiOperation(value = "节点任务查询", response = WorkFlowTaskNodeVO.class)
    public Result<PageData<WorkFlowTaskNodeVO>> query(@RequestBody WorkFlowTaskNodeQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<WorkFlowTaskNodeVO> data= flowTaskQueryService.queryTask(params);
        return new Result<PageData<WorkFlowTaskNodeVO>>().ok(data);
    }


    @SaCheckPermission("sys:rule:flow:handle:info")
    @PostMapping("/info")
    @ApiOperation(value = "节点任务明细", response = WorkFlowTaskNodeVO.class)
    public Result<WorkFlowTaskNodeVO> info(@RequestBody WorkFlowTaskNodeGetDTO params) {
        ValidatorUtils.validateEntity(params);
        WorkFlowTaskNodeVO data= flowTaskQueryService.getTaskInfoById(params.getTaskId());
        return new Result<WorkFlowTaskNodeVO>().ok(data);
    }



//    @SaCheckPermission("sys:rule:flow:handle:execute")
//    @PostMapping("/execute")
//    @ApiOperation(value = "节点任务执行", response = WorkFlowTaskNodeVO.class)
//    public Result<String> execute(@RequestBody WorkFlowTaskNodeExecuteDTO params) {
//        ValidatorUtils.validateEntity(params);
//        flowTaskProcessService.handleTask(params);
//        return new Result<String>().ok(null);
//    }











}
