package com.xxh.cloud.rule.execute.manager.controller;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.dto.WorkFlowQueryDTO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.bean.vos.WorkFlowConfigVO;
import com.xxh.cloud.rule.execute.framework.modules.workflow.service.FlowTaskQueryService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

//@SaCheckPermission("sys:rule:treeConfig")
@Log4j2
@RestController
@RequestMapping("/sys/rule/workflow")
@Api(tags = "运营端,规则流程发起服务")
public class RuleFlowStartExecuteManagerController {



    @Autowired
    private FlowTaskQueryService flowTaskQueryService;



    @SaCheckPermission("sys:rule:workflow:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询可执行的流程", response = WorkFlowConfigVO.class)
    public Result<PageData<WorkFlowConfigVO>> query(@RequestBody WorkFlowQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<WorkFlowConfigVO> data= flowTaskQueryService.queryWorkFlow(params);
        return new Result<PageData<WorkFlowConfigVO>>().ok(data);
    }








}
