package com.xxh.cloud.rule.execute.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.dto.RuleInferenceExecuteMainLogGetDTO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.dto.RuleInferenceExecuteMainLogQueryDTO;
import com.xxh.cloud.rule.execute.framework.modules.biz.bean.vos.RuleInferenceExecuteMainLogVO;
import com.xxh.cloud.rule.execute.framework.modules.biz.service.RuleInferenceExecuteLogBizService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

//@SaCheckPermission("sys:rule:treeConfig")
@Log4j2
@RestController
@RequestMapping("/sys/rule/inference/log")
@Api(tags = "运营端,规则流程执行日志服务")
public class RuleInferenceExecuteLogManagerController {

    @Autowired
    private RuleInferenceExecuteLogBizService ruleInferenceExecuteLogBizService;

    @SaCheckPermission("sys:rule:inference:log:query")
    @PostMapping("/query")
    @ApiOperation(value = "查询", response = RuleInferenceExecuteMainLogVO.class)
    public Result<PageData<RuleInferenceExecuteMainLogVO>> query(@RequestBody RuleInferenceExecuteMainLogQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<RuleInferenceExecuteMainLogVO> data= ruleInferenceExecuteLogBizService.query(params);
        return new Result<PageData<RuleInferenceExecuteMainLogVO>>().ok(data);
    }



    @SaCheckPermission("sys:rule:inference:log:del")
    @PostMapping("/del")
    @ApiOperation(value = "删除", response = String.class)
    public Result<String> del(@RequestBody RuleInferenceExecuteMainLogGetDTO params) {
        ValidatorUtils.validateEntity(params);
//        ruleActionInfoService.delById(params.getId());
        return new Result<String>().ok("ok");
    }

    @SaCheckPermission("sys:rule:inference:log:info")
    @PostMapping("/info")
    @ApiOperation(value = "获取", response = RuleInferenceExecuteMainLogVO.class)
    public  Result<RuleInferenceExecuteMainLogVO> info(@RequestBody RuleInferenceExecuteMainLogGetDTO params) {
        ValidatorUtils.validateEntity(params);
        RuleInferenceExecuteMainLogVO data= ruleInferenceExecuteLogBizService.getById(params.getId());
        return new Result<RuleInferenceExecuteMainLogVO>().ok(data);
    }




}
