package com.xxh.cloud.rule.flow.condition;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.IoUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItemHelper;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdEmrCheckBasic;
import com.xxh.cloud.rule.basic.context.bean.RoamItemDwdEmrSymptom;
import com.xxh.cloud.rule.core.constant.MethodExecuteWayEnum;
import com.xxh.cloud.rule.core.constant.RuleNodeTypeEnum;
import com.xxh.cloud.rule.core.constant.XXFlowNodeTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.executor.condition.ConditionExecutor;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.*;

public class DemoTest {


    public static XXRuleContext getContext(){

        XXRuleRoam userData=new XXRuleRoam();

        //-------------------------------------------------------1

        Map<String,List<XXRuleRoamHealthItem>> checkBasic=new HashMap<>();
        String dataKey= DateUtil.format(new Date(), DatePattern.PURE_DATE_FORMAT);
        List<XXRuleRoamHealthItem> list=checkBasic.get(dataKey);
        if(list==null){
            list=new ArrayList<>();
            checkBasic.put(dataKey,list);
        }
        RoamItemDwdEmrCheckBasic val=new RoamItemDwdEmrCheckBasic();
        val.setHeight(160f);
        val.setWeight(48.5f);
        val.setBloodPressure("120/85");
        val.setHeartRate(56);
        val.setTemperature(36.5f);
        val.setBmi(98.5f);
        val.setDeptCode("1010");
        val.setDeptName("门诊");
        val.setEmrData(new Date());
        XXRuleRoamHealthItem dataItem=new XXRuleRoamHealthItem(
                RuleCondtionDataTypeEnum.Physical_Sign.getCode(),
                XXRuleRoamHealthItemHelper.getMateDateCode(RuleCondtionDataTypeEnum.Physical_Sign.getCode(), "1000"),
                val,
                "1010",
                new Date()
        );
        list.add(dataItem);
        userData.addHealthData(checkBasic);


        //-------------------------------------------------------2

        Map<String,List<XXRuleRoamHealthItem>> emr2=new HashMap<>();

        String emrDataKey2 = DateUtil.format(new Date(), DatePattern.PURE_DATE_FORMAT);

        List<XXRuleRoamHealthItem> emrlist2=emr2.get(emrDataKey2);

        if(emrlist2==null){
            emrlist2=new ArrayList<>();
            emr2.put(emrDataKey2,emrlist2);
        }


        RoamItemDwdEmrSymptom emrVal2=new RoamItemDwdEmrSymptom();
        emrVal2.setCode("1698281182964490240-");
        emrVal2.setName("发烧");
        emrVal2.setPart("1111");
        emrVal2.setDuration(1);
        emrVal2.setOneTime(1);
        emrVal2.setDeptCode("1010");
        emrVal2.setDeptName("1010");
        emrVal2.setEmrData(new Date());

        XXRuleRoamHealthItem dataItemEmr2=new XXRuleRoamHealthItem(
                RuleCondtionDataTypeEnum.EMR_SymptomZS.getCode(),
                XXRuleRoamHealthItemHelper.getMateDateCode(RuleCondtionDataTypeEnum.EMR_SymptomZS.getCode(), "1698281182964490240"),
                emrVal2,
                "1010",
                new Date()
        );

        emrlist2.add(dataItemEmr2);
        userData.addHealthData(emr2);


        //-------------------------------------------------------3



        XXRuleContext context=new XXRuleContext();
        context.setRuleId("id");
        context.setRuleName("name");
        context.setRuleType("type");
        context.setRuleVersion(1);
        context.setRuleCategoryId("c1");
        context.setTraceId(IdUtil.simpleUUID());
        context.setRequestStartTime(new Date());
        context.setDebug(false);
        context.setRoam(userData);
        context.setMethodExecuteWay(MethodExecuteWayEnum.MEW_Return);
        return context;
    }


    public static NodeCondition getConfig(){
        String config="{\"children\":[{\"children\":[],\"id\":\"HuqDTT2\",\"property\":{\"dataType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"dtRangeType\":\"\",\"durationOp\":\"\",\"durationVal\":\"\",\"durationValTwo\":\"\",\"lxtjNum\":0,\"mdCode\":\"EMR_Temperature\",\"mdName\":\"体温\",\"mdRange\":\"\",\"mdType\":\"d\",\"mdTypeCode\":\"physical_sign\",\"mdTypeName\":\"体征\",\"oneTimeOp\":\"\",\"oneTimeVal\":\"\",\"oneTimeValTwo\":\"\",\"op\":\"eq\",\"opChild\":\"\",\"oval\":\"36.5\",\"ovalMany\":[],\"ovalTwo\":\"\",\"partCode\":\"\",\"restriction\":\"N\",\"rytjNum\":0,\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"},{\"id\":\"7TO3ZT2\",\"property\":{\"dataType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"durationOp\":\"\",\"durationVal\":\"\",\"lxtjNum\":0,\"mdCode\":\"1698281182964490240\",\"mdName\":\"发烧\",\"mdType\":\"s\",\"mdTypeCode\":\"EMR_SymptomZS\",\"mdTypeName\":\"主诉\",\"oneTimeOp\":\"\",\"oneTimeVal\":\"\",\"op\":\"emr_symptom\",\"opChild\":\"\",\"oval\":\"\",\"ovalMany\":[],\"ovalTwo\":\"\",\"partCode\":\"\",\"restriction\":\"N\",\"rytjNum\":0,\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"}],\"id\":\"xvY1ST2\",\"relation\":\"and\",\"type\":\"relation\"}";
        NodeCondition nodeCondition= JSON.parseObject(config,NodeCondition.class);
        return nodeCondition;
    }

    public static void main(String[] args) {

//        RoamItemDwdEmrSymptom

//        XXRuleContext context =DemoTest.getContext();
//
//        NodeCondition config=DemoTest.getConfig();
//
//        System.out.println("--------------------开始");
//
//        boolean flag =  ConditionExecutor.processExecute(context, "id1","N名称",
//                RuleNodeTypeEnum.RNT_Condition.getCode(), XXFlowNodeTypeEnum.XXFNT_Condition.getCode(), config);
//
//        System.out.println("--------------结束");
//        System.out.println(flag);


//        String file="D:\\work\\sourcecode\\XM_WBMD_23\\java\\health-etl-java\\health-etl-config-run\\a101-zz.txt";
//        List<String> list= FileUtil.readLines(file,"utf-8");
//        List<String> sqlList=new ArrayList<>();
//        list.forEach(item->{
//            if(StrUtil.isNotEmpty(item)){
//                String val1=item.trim();
//                String sql= StrUtil.format(" INSERT INTO s_md_standard_symptom_info (id ,name ,type ,pid ,rows_status ,creator,create_date,updater,update_date)  VALUES ('{}','{}','i','0','Y','100',NOW(),'100',NOW());",val1,val1);
//                sqlList.add(sql);
//            }
//        });
//        String fileOut="D:\\work\\sourcecode\\XM_WBMD_23\\java\\health-etl-java\\health-etl-config-run\\a101-zz.sql";
//        FileUtil.writeLines(sqlList,fileOut,"utf-8");



//        String file="D:\\work\\sourcecode\\XM_WBMD_23\\java\\health-etl-java\\health-etl-config-run\\a102-bw.txt";
//        List<String> list= FileUtil.readLines(file,"utf-8");
//        List<String> sqlList=new ArrayList<>();
//        list.forEach(item->{
//            if(StrUtil.isNotEmpty(item)){
//                String val1=item.trim();
//                String sql= StrUtil.format(" INSERT INTO s_md_standard_part_info (id ,name)  VALUES ('{}','{}');",val1,val1);
//                sqlList.add(sql);
//            }
//        });
//        String fileOut="D:\\work\\sourcecode\\XM_WBMD_23\\java\\health-etl-java\\health-etl-config-run\\a102-bw.sql";
//        FileUtil.writeLines(sqlList,fileOut,"utf-8");


    }


}
