package com.xxh.cloud.rule.flow.executor.wr;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;

import java.util.*;

/**
 * 节点规则表
 * */
public class XXWeightedRoundNodeListUtils {


    /**
     * 轮询配置列表（待优化到缓存）
     * */
    public static Map<String, List<String>> nodeIdsMap=new HashMap<>();


    /**
     * 获取轮询规则表缓存KEY
     * */
    public static String getNodeIdConfigKey(String ruleId, String mainNodeId,long timestamp){
        return StrUtil.format("X:{}:{}:{}",ruleId,mainNodeId,timestamp);
    }



    /**
     * 获取轮询配置列表（待优化到缓存）
     * */
    public static List<String> getNodeIdList(String ruleId, String mainNodeId,long timestamp,Map<String,Integer> nodeMap){
        String key=getNodeIdConfigKey(ruleId,mainNodeId,timestamp);
        return getNodeIdListByKey(key,nodeMap);
    }


    /**
     * 获取轮询配置列表（待优化到缓存）
     * */
    public static List<String> getNodeIdListByKey(String key,Map<String,Integer> nodeMap){
        List<String> nodeIds =nodeIdsMap.get(key);
        if(CollUtil.isNotEmpty(nodeIds)){
            return nodeIds;
        }
        synchronized (XXWeightedRoundRobin.class){
            nodeIds =generateNodeIdList(nodeMap);
            System.out.println("生成:"+ JSON.toJSONString(nodeIds));
            nodeIdsMap.put(key,nodeIds);
            return nodeIds;
        }
    }


    /**
     * 生成排序列表
     * */
    public static List<String> generateNodeIdList(Map<String,Integer> nodeMap){

        ArrayList<Integer> numList = new ArrayList<Integer>();
        nodeMap.forEach((k,n)->{
            numList.add(n);
        });
        int zdgys = GysUtils.gcdd(numList);

        Set<String> nodeIds=new TreeSet<>();
        Map<String,Integer> newNodeMap=new HashMap<>();
        nodeMap.forEach((id,num)->{
            newNodeMap.put(id,num/zdgys);
            nodeIds.add(id);
        });

        List<String> nodeIdList=new ArrayList<>();

        while (true){
            boolean isNext=false;
            for(String nodeId:nodeIds){
                int num= newNodeMap.get(nodeId);
                if(num>0){
                    nodeIdList.add(nodeId);
                    int newNum=num-1;
                    newNodeMap.put(nodeId,newNum);
                    if(newNum>0){
                        isNext=true;
                    }
                }
            }
            if(isNext==false){
                break;
            }
        }

        return nodeIdList;
    }









}
