package com.xxh.cloud.rule.flow.executor.wr;

import cn.hutool.core.util.StrUtil;

import java.util.*;

/**
 * 加权轮询算法
 * */
public class XXWeightedRoundRobin {



    /**
     * 根据访问量获取节点ID
     * */
    public static String selectNodeId(long callNum, String ruleId, String mainNodeId, long timestamp, Map<String,Integer> nodeMap){
        //获取数据
        List<String> nodeIds=XXWeightedRoundNodeListUtils.getNodeIdList(ruleId,mainNodeId,timestamp,nodeMap);
        if (nodeIds ==null || nodeIds.size()<=0) return null;
        if (nodeIds.size() == 1)  return nodeIds.get(0);
        int i= (int) callNum % nodeIds.size();
        return nodeIds.get(i);
    }

    /**
     * 根据访问量获取节点ID
     * */
    public static String selectNodeId(String ruleId, String mainNodeId,long timestamp,Map<String,Integer> nodeMap){
        long num= XXWeightedRoundCallNumUtils.getCallNum(ruleId,mainNodeId);
        return selectNodeId(num,ruleId,mainNodeId,timestamp,nodeMap);
    }




    public static void main(String[] args) {
        Map<String,Integer> nodeMap =new HashMap<>();
        nodeMap.put("C",10);
        nodeMap.put("A",20);
        nodeMap.put("D",30);

        String ruleId="R100";
        String mainNodeId="zgGXzb1";

        long l=1111L;
        for (int i = 0; i < 10; i++) {
           String nodeId= XXWeightedRoundRobin.selectNodeId(i,ruleId,mainNodeId,l,nodeMap);
            System.out.println(StrUtil.format("{} : 执行节点 {}",i,nodeId));
        }


        Date d=new Date();
        d.getTime();


    }



}
