package com.xxh.cloud.rule.flow.variable;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.context.XXRuleVariableRoom;
import com.xxh.cloud.rule.core.entity.base.NodeCondition;
import com.xxh.cloud.rule.core.entity.flow.XXFlowRuleBO;
import com.xxh.cloud.rule.core.executor.condition.ConditionVariable;

/**
 * 规则流:获取引用参数-执行
 * */
public class XXRuleFlowVariableExecutor {


    /**
     * 执行
     * */
    public XXRuleVariableRoom execute(XXFlowRuleBO rule,boolean isDebug){
        //上下文
        XXRuleContext context=XXRuleContext.getRuleContext2Variable(rule,isDebug);
        //处理器
        XXRuleFlowVariableHandler handler=new XXRuleFlowVariableHandler();
        handler.handle(context,rule.getConfig());
//        context.setRequestEndTime(System.currentTimeMillis());
        //返回变量
        XXRuleVariableRoom variableRoom= context.getVariable();
        return variableRoom;
    }



    public XXRuleVariableRoom executeByCondition(NodeCondition config){
        XXRuleContext context=new XXRuleContext();
        context.setVariable(new XXRuleVariableRoom());
        context.setDebug(false);

        ConditionVariable.processVariable(context,"-1",
                "条件",
                "1",
                "1",
                config);
        XXRuleVariableRoom variableRoom= context.getVariable();
        return variableRoom;
    }


//    public static void main(String[] args) {
//        String str="{\"children\":[{\"id\":\"cKardg1\",\"property\":{\"dateType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"lxtjNum\":0,\"mdCode\":\"1\",\"mdName\":\"罗红霉素\",\"mdType\":\"s\",\"mdTypeCode\":\"medicine_mz\",\"mdTypeName\":\"\",\"op\":\"\",\"opChild\":\"\",\"oval\":\"\",\"ovalMany\":[],\"ovalTwo\":\"\",\"rawType\":\"s\",\"restriction\":\"N\",\"rytjNum\":0,\"sampleCode\":\"\",\"sampleName\":\"\",\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"},{\"id\":\"XveLeg1\",\"property\":{\"dateType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"lxtjNum\":0,\"mdCode\":\"lab_item_00001\",\"mdName\":\"葡萄糖[120分钟]\",\"mdType\":\"d\",\"mdTypeCode\":\"laboratory_project\",\"mdTypeName\":\"\",\"op\":\"result_value\",\"opChild\":\"\",\"oval\":\"1\",\"ovalMany\":[],\"ovalTwo\":\"\",\"rawType\":\"d\",\"restriction\":\"N\",\"rytjNum\":0,\"sampleCode\":\"\",\"sampleName\":\"\",\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"},{\"id\":\"GkgLeg1\",\"property\":{\"dateType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"lxtjNum\":0,\"mdCode\":\"lab_item_00002\",\"mdName\":\"葡萄糖[15分钟]\",\"mdType\":\"d\",\"mdTypeCode\":\"laboratory_project\",\"mdTypeName\":\"\",\"op\":\"range\",\"opChild\":\"\",\"oval\":\"\",\"ovalMany\":[],\"ovalTwo\":\"2\",\"rawType\":\"d\",\"restriction\":\"N\",\"rytjNum\":0,\"sampleCode\":\"\",\"sampleName\":\"\",\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"},{\"id\":\"wWgLeg1\",\"property\":{\"dateType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"\",\"dtLimitStart\":\"\",\"dtLimitUnit\":\"D\",\"lxtjNum\":0,\"mdCode\":\"exam_item_00002\",\"mdName\":\"腹部超声\",\"mdType\":\"s\",\"mdTypeCode\":\"examine_project\",\"mdTypeName\":\"\",\"op\":\"result_narrate_tip\",\"opChild\":\"contain\",\"oval\":\"\",\"ovalMany\":[\"1\",\"3\"],\"ovalTwo\":\"\",\"rawType\":\"s\",\"restriction\":\"N\",\"rytjNum\":0,\"sampleCode\":\"\",\"sampleName\":\"\",\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"}],\"id\":\"LIzKYg1\",\"relation\":\"and\",\"type\":\"relation\"}";
//        NodeCondition config= JSON.parseObject(str,NodeCondition.class);
//        XXRuleFlowVariableExecutor executor=new XXRuleFlowVariableExecutor();
//        XXRuleVariableRoom ruleVariableRoom= executor.executeByCondition(config);
//        System.out.println(JSON.toJSONString(ruleVariableRoom));
//    }








}
