package com.xxh.cloud.rule.flow.workflow;

import cn.hutool.core.util.NumberUtil;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.entity.flow.XXFlowNodeBO;
import com.xxh.cloud.rule.core.entity.flow.XXFlowRuleBO;
import com.xxh.cloud.rule.core.constant.FlowResultEnum;

import java.util.Date;

/**
 * 工作流执行
 * */
public class XXWorkFlowExecutor {



    /**
     * 获取节点配置
     * */
    public static  XXFlowNodeBO getNode(XXFlowRuleBO ruleConfig,String nodeId){
        XXWorkFlowHandler ruleFlowHandler=new XXWorkFlowHandler();
        XXFlowNodeBO node= ruleFlowHandler.getWorkFlowNode(ruleConfig.getConfig(),nodeId);
        return node;
    }

    /**
     * 获取主节点
     * */
    public static XXFlowNodeBO getNextMainNode(XXFlowRuleBO ruleConfig,String nodeId){
        XXWorkFlowHandler ruleFlowHandler=new XXWorkFlowHandler();
        XXFlowNodeBO node=ruleFlowHandler.getNextMainNode(ruleConfig.getConfig(),nodeId);
        return node;
    }


    /**
     *
     * */
    public static double getExeComplete(int yesExeNum,int totalExeNum){
        double val= NumberUtil.div(yesExeNum,totalExeNum);
        double data= NumberUtil.mul(val,100);
        return data;
    }


    /**
     *
     * */
    public static boolean getExeCompleteFlag(int checkNum,int yesExeNum,int totalExeNum){
        double val=getExeComplete(yesExeNum,totalExeNum);
        if(val>=checkNum){
            return true;
        }else {
            return false;
        }
    }


//    /**
//     * 执行引擎:方法调用执行动作
//     * */
//    public static XXRuleContext start(String taskId, XXFlowRuleBO ruleConfig, XXRuleRoam userDataRoam, MethodExecuteByCallApi methodApi){
//        XXRuleContext context=XXRuleContext.getRuleContext2ExecutorByCall(ruleConfig,userDataRoam,methodApi,false);
//        context.setTraceId(taskId);
//
//        long start= System.currentTimeMillis();
//        context.setRequestStartTime(new Date());
//        XXWorkFlowHandler ruleFlowHandler=new XXWorkFlowHandler();
//        ruleFlowHandler.workflowStart(context,ruleConfig.getConfig());
//        context.setRequestEndTime(new Date());
//        long end= System.currentTimeMillis();
//        context.setRequestTime(end-start);
//        return context;
//    }

    /**
     * 执行引擎:执行动作返回
     * */
    public static XXRuleContext start(String taskId, XXFlowRuleBO ruleConfig, XXRuleRoam userDataRoam){
        XXRuleContext context=XXRuleContext.getRuleContext2ExecutorByReturn(ruleConfig,userDataRoam,false);
        context.setTraceId(taskId);

        long start= System.currentTimeMillis();
        context.setRequestStartTime(new Date());

        XXWorkFlowHandler ruleFlowHandler=new XXWorkFlowHandler();
        FlowResultEnum flowResult = ruleFlowHandler.workflowStart(context,ruleConfig.getConfig());
        context.setExecuteResult(flowResult);

        ConsoleUtils.log("+++++执行引擎结果 code = "+flowResult.getCode() +" ,name = "+flowResult.getName());

        context.setRequestEndTime(new Date());
        long end= System.currentTimeMillis();
        context.setRequestTime(end-start);
        return context;
    }


    /**
     * 执行引擎:执行动作返回
     * */
    public static XXRuleContext next(String taskId,XXFlowRuleBO ruleConfig,String currentNodeId,XXRuleRoam userDataRoam){
        XXRuleContext context=XXRuleContext.getRuleContext2ExecutorByReturn(ruleConfig,userDataRoam,false);
        context.setTraceId(taskId);


        long start= System.currentTimeMillis();
        context.setRequestStartTime(new Date());

        XXWorkFlowHandler ruleFlowHandler=new XXWorkFlowHandler();
        FlowResultEnum flowResult = ruleFlowHandler.workflowNext(context,ruleConfig.getConfig(),currentNodeId);
        context.setExecuteResult(flowResult);

        ConsoleUtils.log("+++++执行引擎结果 code = "+flowResult.getCode() +" ,name = "+flowResult.getName());

        context.setRequestEndTime(new Date());
        long end= System.currentTimeMillis();
        context.setRequestTime(end-start);
        return  context;
    }








}
