package com.xxh.cloud.rule.tree.executor;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.rule.core.constant.RuleNodeTypeEnum;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.executor.condition.ConditionExecutor;
import com.xxh.cloud.rule.core.executor.method.MethodExecutor;
import com.xxh.cloud.rule.core.entity.tree.XXTreeNodeBO;

public class XXRuleTreeHandler {




    public void handle(XXRuleContext context, XXTreeNodeBO node){

        boolean flag=false;

        if(RuleNodeTypeEnum.RNT_Action.getCode().equals(node.getType())){
            flag = MethodExecutor.processExecute(context,node.getId(),node.getName(),node.getType(),node.getType(),node.getAction());
        }

        if(RuleNodeTypeEnum.RNT_Condition.getCode().equals(node.getType())){

            flag = ConditionExecutor.processExecute(context,node.getId(),node.getName(),node.getType(),node.getType(),node.getCondition());
        }

//        if(RuleNodeTypeEnum.RNT_ConditionFn.getCode().equals(node.getType())){
//            flag = ConditionExecutor.processExecute(context,node.getId(),node.getName(),node.getType(),node.getType(),node.getCondition());
//        }

        if(flag){
            if(CollUtil.isNotEmpty(node.getChildren())){
                for(XXTreeNodeBO childNode: node.getChildren()){
                    this.handle(context,childNode);
                }
            }
        }

    }



}
