package com.xxh.cloud.uniondata.framework.modules.cache.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import com.xxh.cloud.uniondata.framework.modules.cache.service.StandardDataCacheService;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StandardDataCacheServiceImpl implements StandardDataCacheService {



    @Autowired
    private RedisUtils redisUtils;


    private String getCacheKey(String type){
        return StrUtil.format("md:data:standard:{}",type);
    }


    @Override
    public List<UnionDataItemVO> getByType(String type) {
        String key= this.getCacheKey(type);
        Object obj= redisUtils.get(key);
        if(obj==null){
            return null;
        }
        return JSON.parseArray(obj.toString(), UnionDataItemVO.class);
    }


    @Override
    public void removeByType(String type) {
        String key= this.getCacheKey(type);
        redisUtils.delete(key);
    }

    @Override
    public void initByType(String type, List<UnionDataItemVO> data) {
        if(CollUtil.isEmpty(data)){
            return;
        }
        String key= this.getCacheKey(type);
        redisUtils.set(key,JSON.toJSONString(data),RedisUtils.DEFAULT_EXPIRE);
    }
}
