package com.xxh.cloud.uniondata.framework.modules.query.bean.vos;

import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class UnionDataItemResultVO {

    @ApiModelProperty(value = "一级操作符:编号")
    private String code;

    @ApiModelProperty(value = "一级操作符:名称")
    private String name;

    @ApiModelProperty(value = "数据分类(字典编码数据、标准编码数据)(RuleMethodParamDataType)")
    private String dataType;

    @ApiModelProperty(value = "数据内容分类")
    private String dataContentType;

    @ApiModelProperty(value = "范围[StandardDataItemResultScopeEnum 所有,标准，原始]")
    private String scope;



    public UnionDataItemResultVO(MetadataStandardResultTypeEnum resultType, String dataType, String dataContentType, StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultType.getMsg();

        if(StrUtil.isEmpty(dataType)){
            this.dataType=RuleMethodParamDataType.RMP_DT_None.getCode();
        } else if(MetadataStandardTypeEnum.MT_Standard.getCode().equals(dataType)){
            this.dataType=RuleMethodParamDataType.RMP_DT_Standard.getCode();
            this.dataContentType=dataContentType;
        }else if(MetadataStandardTypeEnum.MT_Dict.getCode().equals(dataType)){
            this.dataType=RuleMethodParamDataType.RMP_DT_Dict.getCode();
            this.dataContentType=dataContentType;
        }else {
            this.dataType=RuleMethodParamDataType.RMP_DT_None.getCode();
        }
        this.scope=scope.getCode();

    }

    /**
     * 标准数据
     * */
    public UnionDataItemResultVO(MetadataStandardResultTypeEnum resultType, RuleCondtionDataTypeEnum dataContentType, StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultType.getMsg();
        this.dataType=RuleMethodParamDataType.RMP_DT_Standard.getCode();
        this.dataContentType=dataContentType.getCode();
        this.scope=scope.getCode();
    }

    /**
     * 标准数据
     * */
    public UnionDataItemResultVO(String resultTypeName, MetadataStandardResultTypeEnum resultType, RuleCondtionDataTypeEnum dataContentType, StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultTypeName;
        this.dataType=RuleMethodParamDataType.RMP_DT_Standard.getCode();
        this.dataContentType=dataContentType.getCode();
        this.scope=scope.getCode();
    }

        /**
         * 字典数据
         * */
    public UnionDataItemResultVO(MetadataStandardResultTypeEnum resultType, String dictDataContentType, StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultType.getMsg();
        this.dataType=RuleMethodParamDataType.RMP_DT_Dict.getCode();
        this.dataContentType=dictDataContentType;
        this.scope=scope.getCode();
    }

    /**
     * 字典数据
     * */
    public UnionDataItemResultVO(String resultTypeName, MetadataStandardResultTypeEnum resultType, String dictDataContentType, StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultTypeName;
        this.dataType=RuleMethodParamDataType.RMP_DT_Dict.getCode();
        this.dataContentType=dictDataContentType;
        this.scope=scope.getCode();
    }




    /**
     * 输入数据
     * */
    public UnionDataItemResultVO(MetadataStandardResultTypeEnum resultType, StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultType.getMsg();
        this.dataType=RuleMethodParamDataType.RMP_DT_None.getCode();
        this.scope=scope.getCode();
    }


    public UnionDataItemResultVO(String resultTypeName, MetadataStandardResultTypeEnum resultType , StandardDataItemResultScopeEnum scope){
        this.code=resultType.getCode();
        this.name=resultTypeName;
        this.dataType=RuleMethodParamDataType.RMP_DT_None.getCode();
        this.scope=scope.getCode();
    }


    public UnionDataItemResultVO(){

    }





}
