package com.xxh.cloud.uniondata.framework.modules.query.convert;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleItemConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleResultConfigBO;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.MetadataInfo;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.*;
import com.xxh.cloud.metadata.framework.modules.standard.entity.*;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSampleVO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemActivityVO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.*;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemResultVO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemVO;

import java.util.List;
import java.util.Map;

public class RuleConfigStandardDataConvert {


    //=================================== 申请
    /**
     * 标准检验组套-申请
     * */
    public static UnionDataItemVO getStandardDataItemVO_Apply(StandardLaboratoryGroupInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());

//        data.setResultType(MetadataStandardResultTypeEnum.MSRT_Complete.getCode());
//        data.addResultType(new UnionDataItemResultVO("申请",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }


    /**
     * 标准检验项目-申请
     * */
    public static UnionDataItemVO getStandardDataItemVO_Apply(StandardLaboratoryProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());

//        data.setResultType(MetadataStandardResultTypeEnum.MSRT_Complete.getCode());
//        data.addResultType(new UnionDataItemResultVO("申请",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }

    /**
     * 标准检查-申请
     * */
    public static UnionDataItemVO getStandardDataItemVO_Apply(StandardExamineProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        return data;
    }



    /**
     * 标准手术-申请
     * */
    public static UnionDataItemVO getStandardDataItemVO_Apply(StandardOperationInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        return data;
    }


    /**
     * 标准病理项目-申请
     * */
    public static UnionDataItemVO getStandardDataItemVO_Apply(StandardPathologyProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());

//        data.setResultType(MetadataStandardResultTypeEnum.MSRT_Complete.getCode());
//        data.addResultType(new UnionDataItemResultVO("申请",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }


    /**
     * 标准治疗-申请
     * */
    public static UnionDataItemVO getStandardDataItemVO_Apply(StandardTherapyInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());

//        data.setResultType(MetadataStandardResultTypeEnum.MSRT_Complete.getCode());
//        data.addResultType(new UnionDataItemResultVO("申请",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }



    /**
     *
     * */
    public static UnionDataItemVO getEmr_symptom(ThirdSymptomBO entity,List<ThirdPartBO> thirdPartList){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.EMR_Symptom,MetadataStandardResultTypeEnum.EMR_Symptom.getCode(),StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }



    //=================================== 报告
    /**
     * 标准检验项目-报告
     * */
    public static UnionDataItemVO getStandardDataItemVO_Report(StandardLaboratoryProjectInfo entity, Map<String, StandardSampleVO> sampleMap, List<ThirdDictItemBO> activityList){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());

        String sampleName=null;
        if(StrUtil.isNotEmpty(entity.getSampleId()) && MapUtil.isNotEmpty(sampleMap)){
            StandardSampleVO standardSampleVO= sampleMap.get(entity.getSampleId());
            if(standardSampleVO!=null && StrUtil.isNotEmpty(standardSampleVO.getName())){
                sampleName=standardSampleVO.getName();
            }
        }


        if(StrUtil.isNotEmpty(sampleName)){
            data.setName( StrUtil.format("{}_{}_({})",entity.getName(),sampleName,entity.getId()));
        }else {
            data.setName( StrUtil.format("{}_({})",entity.getName(),entity.getId()));
        }
        data.setDataType(entity.getResultDataType());
        data.setRawDataType(entity.getResultDataType());

        data.setResultType(entity.getResultType());


        //活动场景
        if(CollUtil.isNotEmpty(activityList)){
            activityList.forEach(item->{
                data.addActivity(new UnionDataItemActivityVO(item.getCode(),item.getName()));
            });
        }




        if(MetadataStandardResultTypeEnum.MSRT_ResultValue.getCode().equals(data.getResultType())){
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultValue,MetadataStandardResultTypeEnum.MSRT_ResultValue.getCode(),StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Range,StandardDataItemResultScopeEnum.SDRC_Standard));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Rise,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Decline,StandardDataItemResultScopeEnum.SDRC_ALL));
        }

        if(MetadataStandardResultTypeEnum.MSRT_ResultTwoCategory.getCode().equals(data.getResultType())){
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultTwoCategory,MetadataStandardResultTypeEnum.MSRT_ResultTwoCategory.getCode(),StandardDataItemResultScopeEnum.SDRC_ALL));
        }

        if(MetadataStandardResultTypeEnum.MSRT_ResultNarrate.getCode().equals(data.getResultType())){
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords, StandardDataItemResultScopeEnum.SDRC_ALL));
        }

        return data;
    }


    /**
     * 标准检查-报告
     * */

    public static UnionDataItemVO getStandardDataItemVO_Report(StandardExamineProjectNameInfo entity,List<ThirdDictItemBO> activityList){
        UnionDataItemVO data=new UnionDataItemVO();

        //活动场景
        if(CollUtil.isNotEmpty(activityList)){
            activityList.forEach(item->{
                data.addActivity(new UnionDataItemActivityVO(item.getCode(),item.getName()));
            });
        }

        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_ReportTip, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_ReportSee, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }

    /**
     * 标准病理-报告
     * */
    public static UnionDataItemVO getStandardDataItemVO_Report(StandardPathologyProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }



    /**
     * 用药-医嘱
     * */
    public static UnionDataItemVO getStandardDataItemVO_Advice(StandardMedicantInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
//        data.addResultType(new UnionDataItemResultVO("用药",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }


    /**
     * 手术记录-医嘱
     * */
    public static UnionDataItemVO getStandardDataItemVO_OperationRecord_Advice(StandardOperationInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
//        data.addResultType(new UnionDataItemResultVO("手术",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }



    /**
     * 手术文书-医嘱
     * */
    public static UnionDataItemVO getStandardDataItemVO_OperationText_Advice(StandardOperationInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }



    /**
     * 转科室-医嘱
     * */
    public static UnionDataItemVO getStandardDataItemVO_Change_dept(ThirdDeptItemBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_In_Dept, RuleCondtionDataTypeEnum.Change_Ward,StandardDataItemResultScopeEnum.SDRC_ALL));
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Out_Dept, RuleCondtionDataTypeEnum.Change_Ward,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }




    /**
     * 关键字
     * */
    public static UnionDataItemVO getStandardDataItemVO_Keywords_Basic(StandardKeywordsInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     * 元数据
     * */
    public static UnionDataItemVO getStandardDataItemVO_Meta_Basic(MetadataInfo entity){

        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(entity.getDataType());
        data.setRawDataType(entity.getDataType());

       if(MetadataStandardTypeEnum.MT_Dict.getCode().equals(entity.getDataType())){

           Map map= JSON.parseObject(entity.getValConfig(), Map.class);
           String dataContentType= Convert.toStr(map.get("dictType"));
           data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ, entity.getDataType(),dataContentType,StandardDataItemResultScopeEnum.SDRC_ALL));
           //data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE, entity.getDataType(),dataContentType,StandardDataItemResultScopeEnum.SDRC_ALL));



        }else if(MetadataStandardTypeEnum.MT_Int.getCode().equals(entity.getDataType()) ||
                MetadataStandardTypeEnum.MT_Decimal.getCode().equals(entity.getDataType())){

            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));

        }else if(MetadataStandardTypeEnum.MT_String.getCode().equals(entity.getDataType()) ||
                MetadataStandardTypeEnum.MT_Text.getCode().equals(entity.getDataType())){
            //data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));

        }else if(MetadataStandardTypeEnum.MT_DateTime.getCode().equals(entity.getDataType())){
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        }
        return data;
    }


    /**
     * 量表:量表结果
     * todo:20240402
     * */
    public static UnionDataItemVO getStandardDataItemVO_Scale(ScaleConfigBO entity, ScaleResultConfigBO configEntity){
        UnionDataItemVO data=new UnionDataItemVO();

        String id=StrUtil.format("{}_{}",entity.getId(),configEntity.getCode());
        String name=StrUtil.format("{}_{}",entity.getName(),configEntity.getName());

        data.setId(id);
        data.setName(name);


        if(MetadataStandardTypeEnum.MT_String.getCode().equals(configEntity.getType())){
            data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
            data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Scale_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Scale_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
        }

        if(MetadataStandardTypeEnum.MT_Decimal.getCode().equals(configEntity.getType())){
            data.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
            data.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Scale_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Scale_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        }


        return data;
    }

    /**
     * 量表:量表明细结果
     * */
    public static UnionDataItemVO getStandardDataItemVO_Scale(ScaleItemConfigBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        if(StrUtil.isNotEmpty(entity.getScaleConfigName())){
            data.setName(StrUtil.format("{}[{}]",entity.getTitle(),entity.getScaleConfigName()));
        }else {
            data.setName(entity.getTitle());
        }
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());



        //todo:暂时全部按照字符串处理
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));

//        if("radio".equals(entity.getType())){
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ, entity.getDictType(),StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE, entity.getDictType(),StandardDataItemResultScopeEnum.SDRC_ALL));
//        }
//
//        if("checkbox".equals(entity.getType())){
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ, entity.getDictType(),StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE, entity.getDictType(),StandardDataItemResultScopeEnum.SDRC_ALL));
//        }
//
//        if("select".equals(entity.getType())){
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ, entity.getDictType(),StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE, entity.getDictType(),StandardDataItemResultScopeEnum.SDRC_ALL));
//        }
//
//        if("input".equals(entity.getType())){
//            if("i".equals(entity.getDataType()) || "d".equals(entity.getDataType())){
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
//            }
//
//            if("s".equals(entity.getDataType()) || "t".equals(entity.getDataType())){
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
//                data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
//            }
//        }
//
//        if("date".equals(entity.getType())){
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_NE,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
//            data.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
//        }

        return data;
    }



//    /**
//     * 标准 : 标签
//     * */
//    public static  StandardDataItemVO getStandardDataItemVO_Label(StandardLabelInfo entity){
//        StandardDataItemVO data=new StandardDataItemVO();
//        data.setId(entity.getId());
//        data.setName(entity.getName());
//
//        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
//        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
//       // data.addResultType(new StandardDataItemResultVO("事件",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
//        data.addResultType(new StandardDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.MDS_Label,StandardDataItemResultScopeEnum.SDRC_ALL));
//        data.addResultType(new StandardDataItemResultVO("有",MetadataStandardResultTypeEnum.MSRT_Complete, RuleCondtionDataTypeEnum.MDS_Label,StandardDataItemResultScopeEnum.SDRC_ALL));
//        //todo:
//        return data;
//    }




    /**
     * 标准检查-报告
     * */
    public static UnionDataItemVO getStandardDataItemVO_Contion(StandardExamineProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        return data;
    }



    /**
     * 标准 : 诊断(IDC10)
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardDiseaseInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardLaboratoryProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardLaboratoryGroupInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardExamineProjectInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardOperationInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardTherapyInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardMedicantInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardSymptomInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     * 标准 :
     * */
    public static UnionDataItemVO getStandardDataItemVO_Standard(StandardDeptInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }



    /**
     * 标签
     * */
    public static UnionDataItemVO getUnionDataItemVO_Label(ThirdLabelModelBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     *  推送服务
     * */
    public static UnionDataItemVO getUnionDataItemVO_PushServe(ThirdPushServeModelBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     *  推送任务
     * */
    public static UnionDataItemVO getUnionDataItemVO_PushTask(ThirdPushTaskModelBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }

    /**
     *  提醒
     * */
    public static UnionDataItemVO getUnionDataItemVO_Remind(ThirdRemindModelBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     *  风险
     * */
    public static UnionDataItemVO getUnionDataItemVO_Risk(ThirdRiskModelBO entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        return data;
    }


    /**
     *  事件
     * */
    public static UnionDataItemVO getUnionDataItemVO_Event(StandardEventInfo entity){
        UnionDataItemVO data=new UnionDataItemVO();
        data.setId(entity.getId());
        data.setName(entity.getName());
        data.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        data.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
//        data.setResultType(MetadataStandardResultTypeEnum.MSRT_Complete.getCode());
//        data.addResultType(new UnionDataItemResultVO("申请",MetadataStandardResultTypeEnum.MSRT_Complete,StandardDataItemResultScopeEnum.SDRC_ALL));
        return data;
    }


    public static void main(String[] args) {
        String s="bwd_v1";
        System.out.println( s.hashCode());

    }

}
