package com.xxh.cloud.uniondata.framework.modules.query.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.ScaleConfigClientService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.ScaleItemConfigClientService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.PageScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.PageScaleItemConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleConfigBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.dto.ScaleConfigClientQueryPageDTO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.dto.ScaleItemConfigClientQueryPageDTO;
import com.xxh.cloud.metadata.framework.modules.base.biz.MetadataInfoBizService;
import com.xxh.cloud.metadata.framework.modules.base.entity.dos.MetadataInfo;
import com.xxh.cloud.metadata.framework.modules.base.entity.dto.MetadataInfoQueryDTO;
import com.xxh.cloud.metadata.framework.modules.cache.service.StandardSampleCacheService;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.dto.*;
import com.xxh.cloud.metadata.framework.modules.standardBiz.bean.vos.StandardSampleVO;
import com.xxh.cloud.metadata.framework.modules.standardBiz.biz.*;
import com.xxh.cloud.uniondata.framework.modules.cache.service.StandardDataCacheService;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardResultTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.MetadataStandardTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.StandardDataItemResultScopeEnum;
import com.xxh.cloud.metadata.framework.modules.standard.entity.*;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.*;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.*;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.*;
import com.xxh.cloud.uniondata.framework.modules.query.convert.RuleConfigStandardDataConvert;
import com.xxh.cloud.uniondata.framework.modules.query.bean.dto.StandardDataQueryTypeDTO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemResultVO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemVO;
import com.xxh.cloud.uniondata.framework.modules.query.service.UnionDataQueryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class UnionDataQueryServiceImpl implements UnionDataQueryService {



    @Override
    public PageData<UnionDataItemVO> query(StandardDataQueryTypeDTO params) {
        ValidatorUtils.validateEntity(params);
        //报告
        if(RuleCondtionDataTypeEnum.Report_Laboratory.getCode().equals(params.getType())){ //检验报告
            return this.query_LaboratoryProject_Report(params);
        }else if(RuleCondtionDataTypeEnum.Report_Examine.getCode().equals(params.getType())){ //检查报告-名称
            return this.query_Examine_Report(params);
        }else if(RuleCondtionDataTypeEnum.Report_Pathology.getCode().equals(params.getType())){ //病理报告
            //todo:未使用
            return this.query_Pathology_Report(params);
        }else if(RuleCondtionDataTypeEnum.Report_PhysicalExamine.getCode().equals(params.getType())){ //体检报告
            //todo:待实现
            return this.query_PhysicalExamine_Report(params);
        }

        //医生操作
        else if(RuleCondtionDataTypeEnum.Apply_Examine.getCode().equals(params.getType())){ //检查项目
            return this.query_Examine_Apply(params);
        }else if(RuleCondtionDataTypeEnum.Apply_Laboratory_Project.getCode().equals(params.getType())){ //检验组套
            return this.query_LaboratoryProjectGroup_Apply(params);
        }else if(RuleCondtionDataTypeEnum.Apply_Pathology.getCode().equals(params.getType())){ //
            return this.query_Pathology_Apply(params);
        }else if(RuleCondtionDataTypeEnum.Apply_Inpatient.getCode().equals(params.getType())){
            //todo: 申请住院
        }else if(RuleCondtionDataTypeEnum.Apply_Discharge.getCode().equals(params.getType())){
            //todo: 申请出院
        } else if(RuleCondtionDataTypeEnum.Apply_Operation.getCode().equals(params.getType())){
            return this.query_Operation_Apply(params);
        } else if(RuleCondtionDataTypeEnum.Therapy.getCode().equals(params.getType())){
            //治疗申请更改治疗记录
            return this.query_Therapy_Apply(params);
        }else if(RuleCondtionDataTypeEnum.Apply_Nurse.getCode().equals(params.getType())){
            //todo: 申请护理
        } else if(RuleCondtionDataTypeEnum.Medicine_MZ.getCode().equals(params.getType()) ){
            return this.query_Medicine_Advice(params);
        }else if(RuleCondtionDataTypeEnum.Medicine_JZ.getCode().equals(params.getType()) ){
            return this.query_Medicine_Advice(params);
        }else if(RuleCondtionDataTypeEnum.Medicine_ZY.getCode().equals(params.getType()) ){
            return this.query_Medicine_Advice(params);
        }else if(RuleCondtionDataTypeEnum.Medicine_CY.getCode().equals(params.getType()) ){
            return this.query_Medicine_Advice(params);
        } else if(RuleCondtionDataTypeEnum.Diagnosis.getCode().equals(params.getType())){
            return this.query_Diagnosis_Advice(params);
        }else if(RuleCondtionDataTypeEnum.OperationRecord.getCode().equals(params.getType())){
            return this.query_OperationRecord_Advice(params);
        }

        //患者信息
        //历史诊断
        else if(RuleCondtionDataTypeEnum.Medical_Record.getCode().equals(params.getType())){
            //todo: 病历
        } else if(RuleCondtionDataTypeEnum.ScaleResult.getCode().equals(params.getType())){ //量表结果
            return this.query_Result_Scale(params);
        } else if(RuleCondtionDataTypeEnum.ScaleItemResult.getCode().equals(params.getType())){ //量表问题
            return this.query_ItemResult_Scale(params);
        }else if(RuleCondtionDataTypeEnum.MDT_Patient.getCode().equals(params.getType())){
            return this.query_Meta_Patient_Basic(params);
        }

        //患者就医记录
        else if(RuleCondtionDataTypeEnum.VisitRecord.getCode().equals(params.getType())){ //
            //门急诊就诊
            return this.query_visitRecord_condition(params);
        }else if(RuleCondtionDataTypeEnum.Reserve_RegisterRecord.getCode().equals(params.getType())){ //
            //预约挂号
            return this.query_ReserveRegister_condition(params);
        }else if(RuleCondtionDataTypeEnum.Reserve_Examine.getCode().equals(params.getType())){ //
            //预约检查
            return this.query_ReserveExamine_condition(params);
        }else if(RuleCondtionDataTypeEnum.Reserve_Inpatient.getCode().equals(params.getType())){ //
            //预约住院[含诊断]
            return this.query_Inpatient_Advice(params);
        } else if(RuleCondtionDataTypeEnum.Reserve_Inpatient_Not.getCode().equals(params.getType())){ //
            //预约住院[不含诊断]
            List<UnionDataItemVO> list=new ArrayList<>();
            return new PageData<UnionDataItemVO>(list,0);
        } else if(RuleCondtionDataTypeEnum.Inpatient.getCode().equals(params.getType())){
            //入院记录[含诊断]
            return this.query_Inpatient_Advice(params);
        } else if(RuleCondtionDataTypeEnum.Inpatient_Not.getCode().equals(params.getType())){
            //入院记录[不含诊断]
            List<UnionDataItemVO> list=new ArrayList<>();
            return new PageData<UnionDataItemVO>(list,0);
        } else if(RuleCondtionDataTypeEnum.Discharge.getCode().equals(params.getType())){
            return this.query_Discharge_Advice(params);
        }else if(RuleCondtionDataTypeEnum.Online_Inquiry.getCode().equals(params.getType())){ //
            //todo:在线问诊
            return this.query_Diagnosis_Advice(params);
        }else if(RuleCondtionDataTypeEnum.Change_Dept.getCode().equals(params.getType())){ //
            //todo:转科室
            return this.query_change_dept(params);
        }




        //文书记录
        else if(RuleCondtionDataTypeEnum.DischargeSummary.getCode().equals(params.getType())){
            return this.query_DischargeSummary_Advice(params);
        }else if(RuleCondtionDataTypeEnum.OperationText.getCode().equals(params.getType())){
            return this.query_OperationText_Advice(params);
        }

        //患者就医事件
        else if(RuleCondtionDataTypeEnum.MDS_Event.getCode().equals(params.getType())){
            return this.query_condtion_Event(params);
        }
        //运营数据
        else if(RuleCondtionDataTypeEnum.Label.getCode().equals(params.getType())){
            return this.query_condtion_Label(params); //条件标签
        }

        //
        else if(RuleCondtionDataTypeEnum.Apply_Laboratory_Group.getCode().equals(params.getType())){
            return this.query_LaboratoryProjectGroup_Apply(params); //废弃
        } else if(RuleCondtionDataTypeEnum.Apply_Inpatient.getCode().equals(params.getType())){
            return this.query_Inpatient_Apply(params);
        }

        //关键字
        else if(RuleCondtionDataTypeEnum.Keywords.getCode().equals(params.getType())){
            return this.query_Keywords_Basic(params);
        }

        //标准
        else if(RuleCondtionDataTypeEnum.MDS_Disease.getCode().equals(params.getType())){
            //标准诊断(IDC10)
            return this.queryStandard_Disease(params);
        } else if(RuleCondtionDataTypeEnum.MDS_LaboratoryProject.getCode().equals(params.getType())){
            //标准检验项目
            return this.queryStandard_LaboratoryProject(params);
        }else if(RuleCondtionDataTypeEnum.MDS_LaboratoryProjectGroup.getCode().equals(params.getType())){
            //标准检验组套
            return this.queryStandard_LaboratoryGroup(params);
        }else if(RuleCondtionDataTypeEnum.MDS_ExamineProject.getCode().equals(params.getType())){
            //标准检验项目
            return this.queryStandard_ExamineProject(params);
        }else if(RuleCondtionDataTypeEnum.MDS_Operation.getCode().equals(params.getType())){
            //标准手术
            return this.queryStandard_Operation(params);
        }else if(RuleCondtionDataTypeEnum.MDS_Therapy.getCode().equals(params.getType())){
            //标准治疗
            return this.queryStandard_Therapy(params);
        }else if(RuleCondtionDataTypeEnum.MDS_Medicine.getCode().equals(params.getType())){
            //标准用药
            return this.queryStandard_Medicine(params);
        }else if(RuleCondtionDataTypeEnum.MDS_Symptom.getCode().equals(params.getType())){
            //标准症状
            return this.queryStandard_Symptom(params);
        }else if(RuleCondtionDataTypeEnum.MDS_Dept.getCode().equals(params.getType())){
            //标准症状
            return this.queryStandard_Dept(params);
        }

        //三方实体
        else if(RuleCondtionDataTypeEnum.MDS_Label.getCode().equals(params.getType())){
            //标签
            return this.query_Label(params);
        } else if(RuleCondtionDataTypeEnum.MDS_PushServe.getCode().equals(params.getType())){
            //推送服务
            return this.query_PushServe(params);
        } else if(RuleCondtionDataTypeEnum.MDS_PushTask.getCode().equals(params.getType())){
            //推送任务
            return this.query_PushTask(params);
        } else if(RuleCondtionDataTypeEnum.MDS_Remind.getCode().equals(params.getType())){
            //提醒
            return this.query_Remind(params);
        }else if(RuleCondtionDataTypeEnum.MDS_Risk.getCode().equals(params.getType())){
            //风险
            return this.query_Risk(params);
        }


        else if(RuleCondtionDataTypeEnum.EMR_SymptomZS.getCode().equals(params.getType())){
            return this.query_Symptom(params);
        }
        else if(RuleCondtionDataTypeEnum.EMR_SymptomJWS.getCode().equals(params.getType())){
            return this.query_Symptom(params);
        }
        else if(RuleCondtionDataTypeEnum.EMR_SymptomXBS.getCode().equals(params.getType())){
            return this.query_Symptom(params);
        }
        else if(RuleCondtionDataTypeEnum.EMR_SymptomPart.getCode().equals(params.getType())){
            return this.query_SymptomPart(params);
        }

        else if(RuleCondtionDataTypeEnum.Physical_Sign.getCode().equals(params.getType())){
            //todo: 体征
            return this.query_Physical_Sign(params);
        }

//        else if(RuleCondtionDataTypeEnum.EMR_Temperature.getCode().equals(params.getType())){
//            return this.query_Temperature(params);
//        }
//        else if(RuleCondtionDataTypeEnum.EMR_HeartRate.getCode().equals(params.getType())){
//            return this.query_HeartRate(params);
//        }
//        else if(RuleCondtionDataTypeEnum.EMR_BloodPressure.getCode().equals(params.getType())){
//            return this.query_BloodPressure(params);
//        }
//        else if(RuleCondtionDataTypeEnum.EMR_Weight.getCode().equals(params.getType())){
//            return this.query_Weight(params);
//        }
//        else if(RuleCondtionDataTypeEnum.EMR_Height.getCode().equals(params.getType())){
//            return this.query_Height(params);
//        }
//        else if(RuleCondtionDataTypeEnum.EMR_BMI.getCode().equals(params.getType())){
//            return this.query_BMI(params);
//        }
        return null;
    }





    @Autowired
    private StandardDiseaseBizService standardDiseaseBizService;

    @Autowired
    private StandardDiseaseSystemBizService standardDiseaseSystemBizService;

    @Autowired
    private StandardLaboratoryTypeBizService standardLaboratoryTypeBizService;
    @Autowired
    private StandardLaboratoryProjectBizService standardLaboratoryProjectBizService;
    @Autowired
    private StandardLaboratoryGroupBizService standardLaboratoryGroupBizService;

    @Autowired
    private ThirdLabeQueryService thirdLabeQueryService;

//    @Autowired
//    private StandardSampleBizService standardSampleBizService;
//    @Autowired
//    private StandardUnitBizService standardUnitBizService;

    @Autowired
    private StandardExamineProjectBizService standardExamineProjectBizService;
    @Autowired
    private StandardExamineNameBizService standardExamineNameBizService;
    @Autowired
    private StandardOperationBizService standardOperationBizService;
    @Autowired
    private StandardSymptomBizService standardSymptomBizService;
    @Autowired
    private StandardEventBizService standardEventBizService;
    @Autowired
    private StandardMedicantBizService standardMedicantBizService;
    @Autowired
    private StandardDataCacheService standardDataCacheService;
    @Autowired
    private StandardKeywordsBizService standardKeywordsBizService;
    @Autowired
    private MetadataInfoBizService metadataInfoBizService;
    @Autowired
    private StandardPathologyProjectBizService standardPathologyProjectBizService;
    @Autowired
    private StandardTherapyBizService standardTherapyBizService;
    @Autowired
    private StandardDeptBizService standardDeptBizService;
    @Autowired
    private ScaleConfigClientService scaleConfigClientService;
    @Autowired
    private ScaleItemConfigClientService scaleItemConfigClientService;
    @Autowired
    private ThirdPushServeQueryService thirdPushServeQueryService;
    @Autowired
    private ThirdPushTaskQueryService thirdPushTaskQueryService;
    @Autowired
    private ThirdRemindQueryService thirdRemindQueryService;

    @Autowired
    private ThirdRiskQueryService thirdRiskQueryService;

    @Autowired
    private StandardSampleBizService standardSampleBizService;




    @Autowired
    private StandardSampleCacheService standardSampleCacheService;

    @Autowired
    private ThirdBasicQueryService thirdBasicQueryService;



    public PageData<UnionDataItemVO> query_Physical_Sign(StandardDataQueryTypeDTO params){

        List<UnionDataItemVO> list=new ArrayList<>();

        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setId(RuleCondtionDataTypeEnum.EMR_Temperature.getCode());
        dataItem.setName(RuleCondtionDataTypeEnum.EMR_Temperature.getMsg());
        dataItem.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        list.add(dataItem);


        UnionDataItemVO dataItem1=new UnionDataItemVO();
        dataItem1.setId(RuleCondtionDataTypeEnum.EMR_BMI.getCode());
        dataItem1.setName(RuleCondtionDataTypeEnum.EMR_BMI.getMsg());
        dataItem1.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem1.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem1.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem1.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem1.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem1.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem1.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        list.add(dataItem1);


        UnionDataItemVO dataItem2=new UnionDataItemVO();
        dataItem2.setId(RuleCondtionDataTypeEnum.EMR_Height.getCode());
        dataItem2.setName(RuleCondtionDataTypeEnum.EMR_Height.getMsg());
        dataItem2.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem2.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem2.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem2.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem2.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem2.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem2.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        list.add(dataItem2);

        UnionDataItemVO dataItem3=new UnionDataItemVO();
        dataItem3.setId(RuleCondtionDataTypeEnum.EMR_Weight.getCode());
        dataItem3.setName(RuleCondtionDataTypeEnum.EMR_Weight.getMsg());
        dataItem3.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem3.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem3.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem3.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem3.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem3.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem3.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        list.add(dataItem3);

//        UnionDataItemVO dataItem4=new UnionDataItemVO();
//        dataItem4.setId(RuleCondtionDataTypeEnum.EMR_BloodPressure.getCode());
//        dataItem4.setName(RuleCondtionDataTypeEnum.EMR_BloodPressure.getMsg());
//        dataItem4.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
//        dataItem4.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
//        dataItem4.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
//        dataItem4.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
//        dataItem4.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
//        dataItem4.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
//        dataItem4.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
//        list.add(dataItem4);

        UnionDataItemVO dataItem5=new UnionDataItemVO();
        dataItem5.setId(RuleCondtionDataTypeEnum.EMR_HeartRate.getCode());
        dataItem5.setName(RuleCondtionDataTypeEnum.EMR_HeartRate.getMsg());
        dataItem5.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem5.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem5.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem5.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem5.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem5.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem5.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        list.add(dataItem5);

        return new PageData<UnionDataItemVO>(list,5);
    }


    //todo: delete
    public PageData<UnionDataItemVO> query_HeartRate(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    //todo: delete
    public PageData<UnionDataItemVO> query_BloodPressure(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    //todo: delete
    public PageData<UnionDataItemVO> query_Weight(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    //todo: delete
    public PageData<UnionDataItemVO> query_Height(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    //todo: delete
    public PageData<UnionDataItemVO> query_BMI(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_Decimal.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_EQ,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_GE,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LT,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_LE,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);

    }


    @Autowired
    private ThirdSymptomQueryService thirdSymptomQueryService;


    public PageData<UnionDataItemVO> query_Symptom(StandardDataQueryTypeDTO params){
        ThirdSymptomQueryDTO queryParams=new ThirdSymptomQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        IPage<ThirdSymptomBO> pageData= thirdSymptomQueryService.queryThirdSymptom(queryParams);

        if(pageData==null || CollUtil.isEmpty(pageData.getRecords())){
            return null;
        }


        PageData<UnionDataItemVO> data=new PageConverter<ThirdSymptomBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdSymptomBO entity) {
                return RuleConfigStandardDataConvert.getEmr_symptom(entity,null);
            }
        }.getPageData(pageData);

        return data;
    }

    public PageData<UnionDataItemVO> query_SymptomPart(StandardDataQueryTypeDTO params){
        ThirdPartQueryDTO queryParams=new ThirdPartQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        IPage<ThirdPartBO> pageData= thirdSymptomQueryService.queryThirdPart(queryParams);
        if(pageData==null || CollUtil.isEmpty(pageData.getRecords())){
            return null;
        }
        PageData<UnionDataItemVO> data=new PageConverter<ThirdPartBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdPartBO entity) {
                UnionDataItemVO data=new UnionDataItemVO();
                data.setId(entity.getId());
                data.setName(entity.getName());
                return data;
            }
        }.getPageData(pageData);
        return data;
    }



    /**
     * 报告:标准检验项目
     */
    public PageData<UnionDataItemVO> query_LaboratoryProject_Report(StandardDataQueryTypeDTO params){
        StandardLaboratoryProjectQueryDTO queryParams=new StandardLaboratoryProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardLaboratoryProjectInfo> pageData= standardLaboratoryProjectBizService.queryStandardLaboratoryProject(queryParams);


        List<ThirdDictItemBO> activityList= thirdBasicQueryService.getThirdDictItemList("hin_activity");

        Set<String> sampleIds=new HashSet<>();
        if(pageData!=null && CollUtil.isNotEmpty(pageData.getRecords())){
            pageData.getRecords().forEach(item->{
                if(StrUtil.isNotEmpty(item.getSampleId())){
                    sampleIds.add(item.getSampleId());
                }
            });
        }


        Map<String, StandardSampleVO> sampleMap= standardSampleCacheService.getMapByIds(sampleIds);

        PageData<UnionDataItemVO> data=new PageConverter<StandardLaboratoryProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardLaboratoryProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Report(entity,sampleMap,activityList);
            }
        }.getPageData(pageData);



       // standardSampleBizService.


        return data;
    }


    /**
     * 报告:检查报告
     * todo:20240402
     */
    public PageData<UnionDataItemVO> query_Examine_Report(StandardDataQueryTypeDTO params){
        StandardExamineNameQueryDTO queryParams=new StandardExamineNameQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());


        IPage<StandardExamineProjectNameInfo> pageData= standardExamineNameBizService.queryStandardExamineName(queryParams);

        List<ThirdDictItemBO> activityList= thirdBasicQueryService.getThirdDictItemList("hin_activity");

        PageData<UnionDataItemVO> data=new PageConverter<StandardExamineProjectNameInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardExamineProjectNameInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Report(entity,activityList);
            }
        }.getPageData(pageData);

        return data;
    }

    /**
     * 报告: 病理报告
     * */
    public PageData<UnionDataItemVO> query_Pathology_Report(StandardDataQueryTypeDTO params){
        StandardPathologyProjectQueryDTO queryParams=new StandardPathologyProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardPathologyProjectInfo> pageData= standardPathologyProjectBizService.queryStandardPathologyProject(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardPathologyProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardPathologyProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Report(entity);
            }
        }.getPageData(pageData);

        return data;
    }


    /**
     * 报告: 体检报告
     * */
    public PageData<UnionDataItemVO> query_PhysicalExamine_Report(StandardDataQueryTypeDTO params){
        //todo: 待实现
        return null;
    }

    /**
     * 申请:标准检验项目
     */
    public PageData<UnionDataItemVO> query_LaboratoryProject_Apply(StandardDataQueryTypeDTO params){
        StandardLaboratoryProjectQueryDTO queryParams=new StandardLaboratoryProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());

        IPage<StandardLaboratoryProjectInfo> pageData= standardLaboratoryProjectBizService.queryStandardLaboratoryProject(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardLaboratoryProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardLaboratoryProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Apply(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 申请:标准检验项目组套
     */
    public PageData<UnionDataItemVO> query_LaboratoryProjectGroup_Apply(StandardDataQueryTypeDTO params){
        StandardLaboratoryGroupQueryDTO queryParams=new StandardLaboratoryGroupQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardLaboratoryGroupInfo> pageData = standardLaboratoryGroupBizService.queryStandardLaboratoryGroup(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<StandardLaboratoryGroupInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardLaboratoryGroupInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Apply(entity);
            }
        }.getPageData(pageData);
        return data;
    }


    /**
     * 申请:病理检查申请
     * */
    public PageData<UnionDataItemVO> query_Pathology_Apply(StandardDataQueryTypeDTO params){
        StandardPathologyProjectQueryDTO queryParams=new StandardPathologyProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardPathologyProjectInfo> pageData= standardPathologyProjectBizService.queryStandardPathologyProject(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardPathologyProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardPathologyProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Apply(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 申请:检查项目申请
     * */
    public PageData<UnionDataItemVO> query_Examine_Apply(StandardDataQueryTypeDTO params){
        StandardExamineProjectQueryDTO queryParams=new StandardExamineProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardExamineProjectInfo> pageData= standardExamineProjectBizService.queryStandardExamineProject(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardExamineProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardExamineProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Apply(entity);
            }
        }.getPageData(pageData);



        return data;
    }

    /**
     *  治疗申请
     * */
    public PageData<UnionDataItemVO> query_Therapy_Apply(StandardDataQueryTypeDTO params){
        StandardTherapyQueryDTO queryParams=new StandardTherapyQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());

        IPage<StandardTherapyInfo> pageData= standardTherapyBizService.queryStandardTherapy(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<StandardTherapyInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardTherapyInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Apply(entity);
            }
        }.getPageData(pageData);
        return data;
    }



    /**
     * 手术申请
     * */
    public PageData<UnionDataItemVO> query_Operation_Apply(StandardDataQueryTypeDTO params){
        StandardOperationQueryDTO queryParams=new StandardOperationQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardOperationInfo> pageData = standardOperationBizService.queryStandardOperation(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardOperationInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardOperationInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Apply(entity);
            }
        }.getPageData(pageData);

        return data;
    }

    /**
     * 住院申请
     * */
    public PageData<UnionDataItemVO> query_Inpatient_Apply(StandardDataQueryTypeDTO params){

        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));

        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);


        return new PageData<UnionDataItemVO>(list,1);
    }



    /**
     * 基础:查询关键字
     * */
    public PageData<UnionDataItemVO> query_Keywords_Basic(StandardDataQueryTypeDTO params){
        StandardKeywordsQueryDTO queryParams=new StandardKeywordsQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        IPage<StandardKeywordsInfo> pageData =  standardKeywordsBizService.queryStandardKeywords(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardKeywordsInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardKeywordsInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Keywords_Basic(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 基础:查询元数据
     * */
    public PageData<UnionDataItemVO> query_Meta_Patient_Basic(StandardDataQueryTypeDTO params){
        MetadataInfoQueryDTO queryParams=new MetadataInfoQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setCategoryId(params.getType());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        IPage<MetadataInfo> pageData =  metadataInfoBizService.queryMetadataInfo(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<MetadataInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(MetadataInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Meta_Basic(entity);
            }
        }.getPageData(pageData);
        return data;
    }


    /**
     * 医嘱:诊断
     * */
    public PageData<UnionDataItemVO> query_Diagnosis_Advice(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();

        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));

        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_CB, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_MZ, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_RY, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_CY, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_XZ, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain_SW, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));

        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_CB, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_MZ, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_RY, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_CY, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_XZ, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre_SW, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));

        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }


    /**
     * 转科室
     * */
    public  PageData<UnionDataItemVO> query_change_dept(StandardDataQueryTypeDTO params){

        //todo: 转科室
        // 从A科室转入A1科室
        // 从B科室转出B1科室
//        ThirdDeptQueryDTO queryParams=new ThirdDeptQueryDTO();
//        queryParams.setPage(params.getPage());
//        queryParams.setRows(params.getRows());
//        queryParams.setIds(params.getIds());
//        queryParams.setName(params.getKeywords());
//        IPage<ThirdDeptItemBO> pageData =  thirdBasicQueryService.queryThirdDept(queryParams);
//
//        PageData<UnionDataItemVO> data=new PageConverter<ThirdDeptItemBO, UnionDataItemVO>() {
//            @Override
//            public UnionDataItemVO converter(ThirdDeptItemBO entity) {
//                return RuleConfigStandardDataConvert.getStandardDataItemVO_Change_dept(entity);
//            }
//        }.getPageData(pageData);
//        return data;

        //转入A科室
        //转出A科室
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_In_Dept, RuleCondtionDataTypeEnum.MDS_Dept,StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_Out_Dept, RuleCondtionDataTypeEnum.MDS_Dept,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);

    }

    //Change_Ward

    /**
     * 医嘱: 入院
     * */
    public PageData<UnionDataItemVO> query_Inpatient_Advice(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }


    /**
     * 门急诊就诊
     * */
    public PageData<UnionDataItemVO> query_visitRecord_condition(StandardDataQueryTypeDTO params){

        UnionDataItemVO dataItem_1=new UnionDataItemVO();
        dataItem_1.setId("JZ");
        dataItem_1.setName("急诊");
        dataItem_1.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem_1.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());

        UnionDataItemVO dataItem_2=new UnionDataItemVO();
        dataItem_2.setId("MZ");
        dataItem_2.setName("门诊");
        dataItem_2.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem_2.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());


        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem_1);
        list.add(dataItem_2);

        return new PageData<UnionDataItemVO>(list,2);

    }

    /**
     *  预约挂号
     * */
    public PageData<UnionDataItemVO> query_ReserveRegister_condition(StandardDataQueryTypeDTO params){

        UnionDataItemVO dataItem_1=new UnionDataItemVO();
        dataItem_1.setId("JZ");
        dataItem_1.setName("急诊");
        dataItem_1.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem_1.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());

        UnionDataItemVO dataItem_2=new UnionDataItemVO();
        dataItem_2.setId("MZ");
        dataItem_2.setName("门诊");
        dataItem_2.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem_2.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());


        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem_1);
        list.add(dataItem_2);

        return new PageData<UnionDataItemVO>(list,2);
    }


    public PageData<UnionDataItemVO> query_ReserveExamine_condition(StandardDataQueryTypeDTO params){
        StandardExamineProjectQueryDTO queryParams=new StandardExamineProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardExamineProjectInfo> pageData= standardExamineProjectBizService.queryStandardExamineProject(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<StandardExamineProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardExamineProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Contion(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 医嘱: 出院
     * */
    public PageData<UnionDataItemVO> query_Discharge_Advice(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnoseMain, RuleCondtionDataTypeEnum.MDS_Disease, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_DiagnosePre, RuleCondtionDataTypeEnum.MDS_Disease,StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    /**
     * 医嘱: 出院小结
     * */
    public PageData<UnionDataItemVO> query_DischargeSummary_Advice(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate, RuleCondtionDataTypeEnum.Keywords, StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    /**
     * 医嘱: 手术记录
     * */
    public PageData<UnionDataItemVO> query_OperationRecord_Advice(StandardDataQueryTypeDTO params){
        StandardOperationQueryDTO queryParams=new StandardOperationQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardOperationInfo> pageData = standardOperationBizService.queryStandardOperation(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardOperationInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardOperationInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_OperationRecord_Advice(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 医嘱: 手术文书
     * */
    public PageData<UnionDataItemVO> query_OperationText_Advice(StandardDataQueryTypeDTO params){
        StandardOperationQueryDTO queryParams=new StandardOperationQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardOperationInfo> pageData = standardOperationBizService.queryStandardOperation(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardOperationInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardOperationInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_OperationText_Advice(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 医嘱:用药
     * */
    public PageData<UnionDataItemVO> query_Medicine_Advice(StandardDataQueryTypeDTO params){
        StandardMedicantQueryDTO queryParams=new StandardMedicantQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        //queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardMedicantInfo>  pageData = standardMedicantBizService.queryStandardMedicant(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardMedicantInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardMedicantInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Advice(entity);
            }
        }.getPageData(pageData);

        return data;
    }


    /**
     * 量表: 量表结果
     * todo: 20240402
     * */
    public PageData<UnionDataItemVO> query_Result_Scale(StandardDataQueryTypeDTO params){
        ScaleConfigClientQueryPageDTO queryParams=new ScaleConfigClientQueryPageDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        PageScaleConfigBO pageData = scaleConfigClientService.query(queryParams);

        if(pageData==null || CollUtil.isEmpty(pageData.getRecords())){
            return null;
        }
        List<UnionDataItemVO> list=new ArrayList<>();

        for(ScaleConfigBO item:pageData.getRecords()){
            if(CollUtil.isNotEmpty(item.getResultConfig())){
                item.getResultConfig().forEach(configItem->{
                    list.add(RuleConfigStandardDataConvert.getStandardDataItemVO_Scale(item,configItem));
                });

            }
        }

        PageData<UnionDataItemVO> data=new PageData<UnionDataItemVO>(list,pageData.getTotal(),pageData.getSize(),pageData.getPages());
        return data;
    }


    /**
     * 量表: 量表明细结果
     * */
    public PageData<UnionDataItemVO> query_ItemResult_Scale(StandardDataQueryTypeDTO params){
        ScaleItemConfigClientQueryPageDTO queryParams=new ScaleItemConfigClientQueryPageDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        PageScaleItemConfigBO pageData = scaleItemConfigClientService.query(queryParams);

        if(pageData==null && CollUtil.isEmpty(pageData.getRecords())){
            return null;
        }

        List<UnionDataItemVO> list=new ArrayList<>();
        pageData.getRecords().forEach(item->{
            list.add(RuleConfigStandardDataConvert.getStandardDataItemVO_Scale(item));
        });
        PageData<UnionDataItemVO> data=new PageData<UnionDataItemVO>(list,pageData.getTotal(),pageData.getSize(),pageData.getPages());
        return data;
    }


    /**
     * 标准:诊断(IDC10)
     * */
    public  PageData<UnionDataItemVO> queryStandard_Disease(StandardDataQueryTypeDTO params){
        StandardDiseaseQueryDTO queryParams=new StandardDiseaseQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        queryParams.setTwoStatus(YN.NO.getCode());
        queryParams.setShowStatus(YN.YES.getCode());
        IPage<StandardDiseaseInfo> pageData = standardDiseaseBizService.queryStandardDisease(queryParams);


        PageData<UnionDataItemVO> data=new PageConverter<StandardDiseaseInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardDiseaseInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);

        return data;
    }


    /**
     * 标准: 标准检验项目
     * */
    public  PageData<UnionDataItemVO> queryStandard_LaboratoryProject(StandardDataQueryTypeDTO params){
        StandardLaboratoryProjectQueryDTO queryParams=new StandardLaboratoryProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());

        IPage<StandardLaboratoryProjectInfo> pageData= standardLaboratoryProjectBizService.queryStandardLaboratoryProject(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardLaboratoryProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardLaboratoryProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);


        return data;
    }

    /**
     * 标准: 标准检验组套
     * */
    public  PageData<UnionDataItemVO> queryStandard_LaboratoryGroup(StandardDataQueryTypeDTO params){
        StandardLaboratoryGroupQueryDTO queryParams=new StandardLaboratoryGroupQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardLaboratoryGroupInfo> pageData = standardLaboratoryGroupBizService.queryStandardLaboratoryGroup(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<StandardLaboratoryGroupInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardLaboratoryGroupInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);
        return null;
    }


    //


    /**
     * 标准: 标准检查项目
     * */
    public  PageData<UnionDataItemVO> queryStandard_ExamineProject(StandardDataQueryTypeDTO params){
        StandardExamineProjectQueryDTO queryParams=new StandardExamineProjectQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardExamineProjectInfo> pageData= standardExamineProjectBizService.queryStandardExamineProject(queryParams);


        PageData<UnionDataItemVO> data=new PageConverter<StandardExamineProjectInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardExamineProjectInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);

        return data;
    }

    /**
     * 标准: 标准手术
     * */
    public  PageData<UnionDataItemVO> queryStandard_Operation(StandardDataQueryTypeDTO params){
        StandardOperationQueryDTO queryParams=new StandardOperationQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardOperationInfo> pageData = standardOperationBizService.queryStandardOperation(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardOperationInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardOperationInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);

        return data;
    }

    /**
     * 标准: 标准治疗
     * */
    public  PageData<UnionDataItemVO> queryStandard_Therapy(StandardDataQueryTypeDTO params){
        StandardTherapyQueryDTO queryParams=new StandardTherapyQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());

        IPage<StandardTherapyInfo> pageData= standardTherapyBizService.queryStandardTherapy(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<StandardTherapyInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardTherapyInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    /**
     * 标准:  标准用药
     * */
    public  PageData<UnionDataItemVO> queryStandard_Medicine(StandardDataQueryTypeDTO params){
        StandardMedicantQueryDTO queryParams=new StandardMedicantQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        //queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
        IPage<StandardMedicantInfo>  pageData = standardMedicantBizService.queryStandardMedicant(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<StandardMedicantInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardMedicantInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);
        return data;
    }


    /**
     * 标准:  标准症状
     * */
    public  PageData<UnionDataItemVO> queryStandard_Symptom(StandardDataQueryTypeDTO params){
        StandardSymptomQueryDTO queryParams=new StandardSymptomQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        IPage<StandardSymptomInfo>  pageData = standardSymptomBizService.queryStandardSymptom(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<StandardSymptomInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardSymptomInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);

        return data;
    }

    /**
     * 标准:  标准科室
     * */
    public  PageData<UnionDataItemVO> queryStandard_Dept(StandardDataQueryTypeDTO params){
        StandardDeptQueryDTO queryDTO=new StandardDeptQueryDTO();
        queryDTO.setPage(params.getPage());
        queryDTO.setRows(params.getRows());
        queryDTO.setProjectCode(params.getProjectCode());
        queryDTO.setIds(params.getIds());
        queryDTO.setName(params.getKeywords());
        IPage<StandardDeptInfo> pageData= standardDeptBizService.queryStandardDept(queryDTO);
        PageData<UnionDataItemVO> data=new PageConverter<StandardDeptInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardDeptInfo entity) {
                return RuleConfigStandardDataConvert.getStandardDataItemVO_Standard(entity);
            }
        }.getPageData(pageData);
        return data;
    }


    public PageData<UnionDataItemVO> query_Label(StandardDataQueryTypeDTO params){
        ThirdLabelModelQueryDTO queryParams=new ThirdLabelModelQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setProjectCode(params.getProjectCode());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        IPage<ThirdLabelModelBO> pageData = thirdLabeQueryService.queryThirdLabel(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<ThirdLabelModelBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdLabelModelBO entity) {
                return RuleConfigStandardDataConvert.getUnionDataItemVO_Label(entity);
            }
        }.getPageData(pageData);
        return data;
    }




    public PageData<UnionDataItemVO> query_PushServe(StandardDataQueryTypeDTO params){
        ThirdPushServeQueryDTO queryParams=new ThirdPushServeQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setIds(params.getIds());
        queryParams.setKeywords(params.getKeywords());
//        queryParams.setStatus(YN.YES.getCode());
        IPage<ThirdPushServeModelBO> pageData = thirdPushServeQueryService.queryThirdPushServe(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<ThirdPushServeModelBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdPushServeModelBO entity) {
                return RuleConfigStandardDataConvert.getUnionDataItemVO_PushServe(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    public PageData<UnionDataItemVO> query_PushTask(StandardDataQueryTypeDTO params){
        ThirdPushTaskQueryDTO queryParams=new ThirdPushTaskQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
//        queryParams.setStatus(YN.YES.getCode());
        IPage<ThirdPushTaskModelBO> pageData = thirdPushTaskQueryService.queryThirdPushTask(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<ThirdPushTaskModelBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdPushTaskModelBO entity) {
                return RuleConfigStandardDataConvert.getUnionDataItemVO_PushTask(entity);
            }
        }.getPageData(pageData);
        return data;
    }

    public PageData<UnionDataItemVO> query_Remind(StandardDataQueryTypeDTO params){
        ThirdRemindQueryDTO queryParams=new ThirdRemindQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
//        queryParams.setStatus(YN.YES.getCode());
        IPage<ThirdRemindModelBO> pageData = thirdRemindQueryService.queryThirdRemind(queryParams);

        PageData<UnionDataItemVO> data=new PageConverter<ThirdRemindModelBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdRemindModelBO entity) {
                return RuleConfigStandardDataConvert.getUnionDataItemVO_Remind(entity);
            }
        }.getPageData(pageData);
        return data;
    }




    public PageData<UnionDataItemVO> query_Risk(StandardDataQueryTypeDTO params){
        ThirdRiskQueryDTO queryParams=new ThirdRiskQueryDTO();
        queryParams.setPage(params.getPage());
        queryParams.setRows(params.getRows());
        queryParams.setIds(params.getIds());
        queryParams.setName(params.getKeywords());
        queryParams.setStatus(YN.YES.getCode());
        IPage<ThirdRiskModelBO> pageData= thirdRiskQueryService.queryThirdRisk(queryParams);
        PageData<UnionDataItemVO> data=new PageConverter<ThirdRiskModelBO, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(ThirdRiskModelBO entity) {
                return RuleConfigStandardDataConvert.getUnionDataItemVO_Risk(entity);
            }
        }.getPageData(pageData);
        return data;
    }


    public PageData<UnionDataItemVO> query_condtion_Label(StandardDataQueryTypeDTO params){
        UnionDataItemVO dataItem=new UnionDataItemVO();
        dataItem.setDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.setRawDataType(MetadataStandardTypeEnum.MT_String.getCode());
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_History, RuleCondtionDataTypeEnum.MDS_Label, StandardDataItemResultScopeEnum.SDRC_ALL));
        dataItem.addResultType(new UnionDataItemResultVO(MetadataStandardResultTypeEnum.MSRT_ResultNarrate_Current, RuleCondtionDataTypeEnum.MDS_Label, StandardDataItemResultScopeEnum.SDRC_ALL));
        List<UnionDataItemVO> list=new ArrayList<>();
        list.add(dataItem);
        return new PageData<UnionDataItemVO>(list,1);
    }

    public PageData<UnionDataItemVO> query_condtion_Event(StandardDataQueryTypeDTO params){
        StandardEventQueryDTO queryDTO=new StandardEventQueryDTO();
        queryDTO.setPage(params.getPage());
        queryDTO.setRows(params.getRows());
        queryDTO.setIds(params.getIds());
        queryDTO.setName(params.getKeywords());
        IPage<StandardEventInfo> pageData = standardEventBizService.queryStandardEvent(queryDTO);
        PageData<UnionDataItemVO> data=new PageConverter<StandardEventInfo, UnionDataItemVO>() {
            @Override
            public UnionDataItemVO converter(StandardEventInfo entity) {
                return RuleConfigStandardDataConvert.getUnionDataItemVO_Event(entity);
            }
        }.getPageData(pageData);
        return data;
    }



}
