package com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdLabelModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.ThirdLabelModelQueryDTO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.mapper.ThirdLabeQueryMapper;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.ThirdLabeQueryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ThirdLabeQueryServiceImpl implements ThirdLabeQueryService {

    @Autowired
    private ThirdLabeQueryMapper thirdLabeQueryMapper;

    @Override
    public IPage<ThirdLabelModelBO> queryThirdLabel(ThirdLabelModelQueryDTO params) {
        IPage<ThirdLabelModelBO> page = thirdLabeQueryMapper.selectPageLabel(new Page<ThirdLabelModelBO>(params.getPage(), params.getRows()),
                new QueryWrapper<ThirdLabelModelBO>()
                        .eq("rows_status", YN.YES.getCode())
                        .eq(StrUtil.isNotEmpty(params.getProjectCode()),"project_code",params.getProjectCode())
                        .like(StrUtil.isNotEmpty(params.getName()),"name",params.getName())
                        .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                        .in(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                        .eq(StrUtil.isNotEmpty(params.getStatus()),"status",params.getStatus())
                        .eq(StrUtil.isNotEmpty(params.getBizType()),"biz_type",params.getBizType())
                        .orderByDesc("orders")
        );
        return page;
    }



}
