package com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdLabelModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdPushServeModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.ThirdPushServeQueryDTO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.mapper.ThirdPushServeQueryMapper;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.ThirdPushServeQueryService;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ThirdPushServeQueryServiceImpl implements ThirdPushServeQueryService {

    @Autowired
    private ThirdPushServeQueryMapper thirdPushServeQueryMapper;

    @Override
    public IPage<ThirdPushServeModelBO> queryThirdPushServe(ThirdPushServeQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        IPage<ThirdPushServeModelBO> page = thirdPushServeQueryMapper.selectPagePushServe(new Page<ThirdPushServeModelBO>(
                params.getPage(), params.getRows()), new QueryWrapper<ThirdPushServeModelBO>()
                        .eq("rows_status", YN.YES.getCode())
                        .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                        .in(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                        .eq(StrUtil.isNotEmpty(params.getStatus()),"status",params.getStatus())
                        .eq(StrUtil.isNotEmpty(params.getMediaType()),"media_type",params.getMediaType())
                        .eq(StrUtil.isNotEmpty(params.getType()),"type",params.getType())
                        .eq(StrUtil.isNotEmpty(params.getPushWay()),"push_way",params.getPushWay())
                        .and(StrUtil.isNotEmpty(params.getKeywords()),
                                i->i.or().like("name",params.getKeywords())
                                        .or().like("media_name",params.getKeywords())
                                        .or().like("title",params.getKeywords())
                        )
        );
        return page;
    }


}
