package com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdPushServeModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdPushTaskModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.ThirdPushTaskQueryDTO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.mapper.ThirdPushTaskQueryMapper;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.ThirdPushTaskQueryService;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
@Service
public class ThirdPushTaskQueryServiceImpl implements ThirdPushTaskQueryService {

    @Autowired
    private ThirdPushTaskQueryMapper thirdPushTaskQueryMapper;

    @Override
    public IPage<ThirdPushTaskModelBO> queryThirdPushTask(ThirdPushTaskQueryDTO params) {
        ValidatorUtils.validateEntity(params);

        IPage<ThirdPushTaskModelBO> page = thirdPushTaskQueryMapper.selectPagePushTask(new Page<ThirdPushTaskModelBO>(
                params.getPage(), params.getRows()), new QueryWrapper<ThirdPushTaskModelBO>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                .eq(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                .like(StrUtil.isNotEmpty(params.getName()),"name",params.getName())
                .eq(StrUtil.isNotEmpty(params.getType()),"type",params.getType())
                .eq(StrUtil.isNotEmpty(params.getStatus()),"status",params.getStatus())
        );

        return page;
    }
}
