package com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdPushTaskModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdRiskModelBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.ThirdRiskQueryDTO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.mapper.ThirdRiskQueryMapper;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.ThirdRiskQueryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ThirdRiskQueryServiceImpl implements ThirdRiskQueryService {


    @Autowired
    private ThirdRiskQueryMapper thirdRiskQueryMapper;

    @Override
    public IPage<ThirdRiskModelBO> queryThirdRisk(ThirdRiskQueryDTO params) {
        ValidatorUtils.validateEntity(params);
        IPage<ThirdRiskModelBO> page = thirdRiskQueryMapper.selectPageRisk(new Page<ThirdRiskModelBO>(
                params.getPage(), params.getRows()), new QueryWrapper<ThirdRiskModelBO>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                .eq(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                .like(StrUtil.isNotEmpty(params.getName()),"name",params.getName())
                .eq(StrUtil.isNotEmpty(params.getType()),"type",params.getType())
                .eq(StrUtil.isNotEmpty(params.getLevel()),"level",params.getLevel())
                .eq(StrUtil.isNotEmpty(params.getStatus()),"status",params.getStatus())
        );
        return page;
    }


}
