package com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdPartBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.bos.ThirdSymptomBO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.ThirdPartQueryDTO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.bean.dto.ThirdSymptomQueryDTO;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.mapper.ThirdBasicQueryMapper;
import com.xxh.cloud.uniondata.framework.modules.thirdQuery.service.ThirdSymptomQueryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ThirdSymptomQueryServiceImpl implements ThirdSymptomQueryService {


    @Autowired
    private ThirdBasicQueryMapper thirdBasicQueryMapper;

    @Override
    public IPage<ThirdSymptomBO> queryThirdSymptom(ThirdSymptomQueryDTO params) {
        IPage<ThirdSymptomBO> page = thirdBasicQueryMapper.selectPageSymptom(new Page<ThirdSymptomBO>(
                params.getPage(), params.getRows()), new QueryWrapper<ThirdSymptomBO>()
                .eq("rows_status", YN.YES.getCode())
                .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                .eq(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                .like(StrUtil.isNotEmpty(params.getName()),"name",params.getName())
        );
        return page;
    }

    @Override
    public IPage<ThirdPartBO> queryThirdPart(ThirdPartQueryDTO params) {
        IPage<ThirdPartBO> page = thirdBasicQueryMapper.selectThirdPart(new Page<ThirdPartBO>(
                params.getPage(), params.getRows()), new QueryWrapper<ThirdPartBO>()
                .eq(StrUtil.isNotEmpty(params.getId()),"id",params.getId())
                .eq(CollUtil.isNotEmpty(params.getIds()),"id",params.getIds())
                .like(StrUtil.isNotEmpty(params.getName()),"name",params.getName())
        );
        return page;
    }

    @Override
    public List<ThirdPartBO> listThirdPart(String id, List<String> ids, String name) {
        List<ThirdPartBO> data= thirdBasicQueryMapper.listThirdPart(
                new QueryWrapper<ThirdPartBO>()
                        .eq(StrUtil.isNotEmpty(id),"id",id)
                        .in(CollUtil.isNotEmpty(ids),"id",ids)
                        .like(StrUtil.isNotEmpty(name),"name",name)
        );
        return data;
    }


}
