package com.xxh.cloud.uniondata.sys.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.page.PageData;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import com.xxh.cloud.uniondata.framework.modules.query.bean.dto.StandardDataQueryPageDTO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataPageVO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.dto.StandardDataQueryTypeDTO;
import com.xxh.cloud.uniondata.framework.modules.query.bean.vos.UnionDataItemVO;
import com.xxh.cloud.uniondata.framework.modules.query.service.UnionDataQueryService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@Log4j2
@RestController
@RequestMapping("/sys/union/data")
@Api(tags = "运营端,联合数据查询管理")
public class UnionDataQueryManagerController {

    @Autowired
    private UnionDataQueryService unionDataQueryService;

    @SaCheckPermission("sys:union:data:page")
    @PostMapping("/page")
    @ApiOperation(value = "数据属性分页接口", response = UnionDataPageVO.class)
    public Result<List<UnionDataPageVO>> page(@RequestBody StandardDataQueryPageDTO params) {
        ValidatorUtils.validateEntity(params);
        List<UnionDataPageVO> data=new ArrayList<>();
        for(StandardDataQueryTypeDTO typeDTO:params.getTypeList()){
            PageData<UnionDataItemVO> pageData = unionDataQueryService.query(typeDTO);
            data.add(new UnionDataPageVO(typeDTO.getType(),pageData));
        }
        return new Result<List<UnionDataPageVO>>().ok(data);
    }


    @SaCheckPermission("sys:union:data:pageType")
    @PostMapping("/pageType")
    @ApiOperation(value = "数据属性分页接口", response = UnionDataItemVO.class)
    public Result<PageData<UnionDataItemVO>> pageType(@RequestBody StandardDataQueryTypeDTO params) {
        ValidatorUtils.validateEntity(params);
        PageData<UnionDataItemVO> data = unionDataQueryService.query(params);
        return new Result<PageData<UnionDataItemVO>>().ok(data);
    }





}
